define("io.ox/office/editframework/app/editapplication",["exports","io.ox/core/tk/doc-converter-utils","io.ox/core/api/user","io.ox/core/api/tab","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/forms","io.ox/office/tk/utils/io","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/tk/worker/intervalrunner","io.ox/office/tk/dialogs","io.ox/office/baseframework/utils/apputils","io.ox/office/baseframework/utils/errorcode","io.ox/office/baseframework/utils/errorcontext","io.ox/office/baseframework/utils/errorcontextdata","io.ox/office/baseframework/utils/clienterror","io.ox/office/baseframework/utils/infostate","io.ox/office/baseframework/utils/errormessages","io.ox/office/baseframework/utils/infomessages","io.ox/office/baseframework/utils/seleniumlogger","io.ox/office/baseframework/app/baseapplication","io.ox/office/baseframework/app/extensionregistry","io.ox/office/rt2/rt2const","io.ox/office/rt2/rt2protocol","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/utils/webfonts","io.ox/office/editframework/utils/dateutils","io.ox/office/editframework/app/rtconnection","io.ox/office/editframework/app/rtconnectionviewer","io.ox/office/editframework/app/acquireeditrightsworker","io.ox/office/editframework/view/editlabels","gettext!io.ox/office/editframework/main"],function(e,zt,Kt,Qt,Zt,t,n,Jt,r,i,Xt,en,o,a,s,tn,nn,rn,on,an,sn,ln,cn,l,dn,un,gn,pn,fn,c,d,En,hn,On,u,_n,Sn){"use strict";var mn=t.isFiniteNumber,In=t.getNumber,Rn=t.getArray,g=t.newPromise,Nn=t.newFulfilled,An=t.newRejected,Dn=t.toPromise,vn=n.stringEndsWith,yn=n.trimAndCleanString,Cn=n.capitalizeFirst,bn=n.filterArray,Tn=r.FILTER_MODULE_NAME,wn=r.requireOptModule,Fn=i.globalLogger,Ln=i.getLogBuffer,Un=pn.SaveAsType,xn=pn.STORAGE_AVAILABLE,kn=pn.RENAME_DISABLED,$n=pn.TRANSFER_EDIT_RIGHTS_TIMEOUT,Pn=pn.getStorageValue,Mn=o.IntervalRunner,Bn=a.MessageDialog,Hn=s.FlushReason,Gn=s.QuitReason,qn=s.createTextDownload,jn=l.BaseApplication,Vn=c.otLogger,Wn=c.dbgDumpActions,Yn=d.importWebFonts,zn=u.acquireEditLogger,Kn=u.AcquireEditRightsWorker,Qn="accept",Zn="decline",Jn="inactive",Xn=_.noI18n.fix(Sn("unnamed")),er=["editUserId","editUser","hasErrors","writeProtected","activeUsers","locked","lockedByUser","lockedByUserId","failSafeSaveDone","serverOSN"];function tr(e){e=Rn(e,"operations",!0);return e.every(_.isObject)?e:(Fn.error("$badge{EditApp} getOperationsFromData: invalid elements in operations array",e),[])}function nr(e){if(_.isObject(e)&&_.isString(e.action))switch(e.action){case"reload":e.action={itemKey:"document/reload",icon:_n.RELOAD_ICON,label:_n.RELOAD_LABEL};break;case"acquireedit":e.action={itemKey:"document/acquireeditOrPending",icon:_n.EDIT_ICON,label:_n.EDIT_LABEL};break;case"loadrestored":e.action={itemKey:"document/reload",icon:_n.LOAD_RESTORED_ICON,label:_n.LOAD_RESTORED_LABEL};break;default:delete e.action}}function rr(r,i,o){return g(function(e,t){r.done(e).fail(t);var n=window.setTimeout(function(){t("timeout"),Fn.warn(o+" - operation timed out")},i);r.always(function(){window.clearTimeout(n)})})}e.EditApplication=jn.extend(function(e,T,w){var F=this,L=null,U=null,t=null,x=null,n=null,k=null,P=null,u=[],i=null,r=!1,o=!1,a=0,M=Zt.getFunctionOption(w,"preProcessHandler"),B=Zt.getFunctionOption(w,"postProcessHandler"),c=Zt.getFunctionOption(w,"fastEmptyLoadHandler"),g=Zt.getFunctionOption(w,"previewHandler"),s=Zt.getFunctionOption(w,"importFailedHandler",_.noop),l=Zt.getFunctionOption(w,"optimizeOperationsHandler"),d=!0,p=Zt.getFunctionOption(w,"mergeCachedOperationsHandler"),f=!w||!w.otConfigKey||pn.getFlag(w.otConfigKey,!0),E=f?100:Zt.getNumberOption(w,"sendActionsDelay",0),h=Zt.getBooleanOption(w,"isMultiSelectionApp",!0),O=Zt.getBooleanOption(w,"isSnapshotApp",!0),S=null,m=null,I=!1,R=null,N=null,A=!1,D=!1,v=null,y=!1,C=!1,H=!1,b=null,G=!1,q=!1,j=!1,V=!1,W=null,Y=!1,z=Zt.getBooleanOption(w,"localStorageApp",!1)&&!f,K=Zt.getIntegerOption(w,"requiredStorageVersion",0),Q=Zt.getIntegerOption(w,"supportedStorageVersion",0),Z=!1,J=pn.USE_LOCAL_STORAGE&&!0===ox.secretCookie&&!T.auth_code,X=!1,ee={},te=1,ne=[],re=[],ie=[],oe=null,ae=0,se=!1,le=Zt.getBooleanOption(w,"supportsOnlineSync",!0),ce=null,de=!1,ue=!1,ge={},pe="",fe={},Ee=[],he=!0,Oe=!1,_e=[],Se=null,me=null,Ie=!1,Re=!1,Ne=!1,Ae=null,De=null,ve=0,ye=!0,Ce=null,be=null,Te=!1,we="slow load",Fe=!1,Le=[],Ue=0,xe=null,ke=-1,$e=0,Pe=[],Me={},Be=null,He=null,Ge=!1,qe=!1;function je(e,t){var n=F.getState();F.setRootAttribute("data-app-state",n),F.trigger("docs:state",n,e,t),F.trigger("docs:state:"+n,t),zn.log("statechange",n,e)}function Ve(e){var t,n=G?"error":oe?"preview":I?H||!N?"readonly":Ct()?"sending":A?"ready":"initial":"offline";S!==n&&(t=S,S=n,je(t,e))}function We(e){N!==e&&(N=e,F.setRootAttribute("data-edit-mode",N),F.trigger("docs:editmode",N),zn.log("$back{LightPink}changeEditMode",N),F.trigger(N?"docs:editmode:enter":"docs:editmode:leave"),Ve())}function Ye(){return{documentFileLockedByUser:b,fullFileName:F.getFullFileName(),oldEditUser:R,isEditor:Ot()}}function ze(e,t){var n,r=Sn("Read-Only Mode"),i=null,o=null;return _.isString(e)?(o={type:"info",message:e,headline:r},isNaN(t)||(o.duration=t),o=_.extend({},o,{action:"acquireedit"})):(n=Ye(),i=F.getErrorState(),o=Ce,_.isObject(o)||(_.isObject(i)&&(i.isError()||i.isWarning())?o=sn.getMessageData(i,n):(i=F.getInfoState(),_.isString(i)&&(o=ln.getMessageData(i,n))))),F.extendMessageData(o),U.yell(o)}jn.call(this,e,function(){var a=[],R=F.createDeferred("EditApplication.asynchronousLoadFinished"),e=null,t=null,s=$.Deferred(),l=!1,c=!1,N=[],A=[],D=!1,o=-1,d=F.launchTracker;function v(e,t){N.push(t),hn.log("Document status update received during document import")}function y(e,t){A.push(t),hn.log("Clients update received during document import")}function C(e,t){hn.log("Final operation message received for asynchronous load"),f&&!F.isViewerMode()&&t.docStatus&&mt(t.docStatus.serverOSN),t.hasErrors||"error"===F.getState()?R.reject(t):s.always(function(){var e,n,r,i;a.push(t),R.resolve((e=a,n={},r=[],i=null,_.each(e,function(e){var t=e.operations;$.extend(n,e),t&&(delete e.operations,r=r.concat(t)),e.rescueOperations&&(i=e.rescueOperations)}),Me=n&&n.syncInfo,hn.log("loadDocInfo",Me),n.operations=r,i&&(n.rescueOperations=i),_.isEmpty(n.operations)&&n.syncInfo&&o===parseInt(n.syncInfo["document-osn"],10)&&(D=!0),n))})}function b(e,t){var n,r,i,o=null;if(se)return delete t.actions,0<a.length?a[0]=_.extend(a[0],t):a.push(t),void s.resolve();if(n=t,Zt.getBooleanOption(n,"preview",!1))return l=!0,void a.push(t);if(l&&!c){c=!0,n=a,r=0,i=[],_.each(n,function(e){r=_.isNumber(e.activeSheet)?e.activeSheet:r,i=i.concat(e.operations)}),o={preview:{activeSheet:r,operations:i}},(a=[]).push(t);o=function(n){var e=new tn(n),r=Zt.getObjectOption(n,"preview"),e=e.isError()?$.Deferred().reject(n):$.when();r&&_.isArray(r.operations)&&(e=function(){var e=(e=At(M,"previewPreProcessing","Preview preprocess handler finished")).then(function(){M=null;var e=Rn(n.preview,"operations"),t=e?L.applyExternalOperations(e,{expand:!0}):F.createResolvedPromise();return d.asyncStep(t,"previewApplyOperations","$badge{EditApp} "+(e?e.length:0)+" preview operations applied"),t=t.then(function(){return g.call(F,r)?F.leaveBusyDuringImport():$.when()},function(e){e&&"abort"===e||(n.operationError=!0,n.message=Sn("An unrecoverable error occurred while modifying the document."))})});return d.asyncStep(e,"previewEnd","$badge{EditApp} Preview postprocess handler finished")}());return e}(o);return d.asyncStep(o,"previewProcessing","$badge{EditApp} Preview data processed"),o.done(function(){s.resolve()}),void o.fail(function(){s.reject(),Dt(t)})}l||"pending"!==s.state()||s.resolve(),a.push(t)}function r(t){var n,r,e,i,o,a,s,l,c,d,u,g,p,f=tr(t),E=(n=t.docStatus,r={},er.forEach(function(e){e in n&&(r[e]=n[e])}),r),h=new tn(t),O=null;function S(e,t){return Ge=!!e.rescueOperations||Zt.getBooleanOption(e.docStatus,"rescueDoc",null),_t(e).always(function(){ft(e.docStatus)}),me=Zt.getStringOption(e.syncInfo,"restore_id",null),Z=Zt.getBooleanOption(e.syncInfo,"renameNeedsReload",!1),F.waitForImportSuccess(function(){hn.log("Applying clients update messages, count = "+A.length),_.each(A,function(e){_t(e)}),hn.log("Applying document update messages, count = "+t.length),_.each(t,function(e){Nt(e)}),$t()&&(P.off(gn.RESPONSE_OPEN_DOC_CHUNK,b),P.off(gn.RESPONSE_OPEN_DOC,C),P.off(gn.BROADCAST_UPDATE_CLIENTS,y).on(gn.BROADCAST_UPDATE_CLIENTS,function(e,t){_t(t)}),P.off(gn.BROADCAST_UPDATE,v).on(gn.BROADCAST_UPDATE,function(e,t){Nt(t)})),Ve(),pn.DEBUG&&e.rescueOperations&&F.trigger("docs:rescueoperations",e.rescueOperations),R.resolve({action:[]})}),$.when()}function m(){return F.getUserInfo(ox.user_id).done(function(e){k=Zt.escapeHTML(e.operationName)})}return F.isViewerMode()&&(H=!0,We(!(Me={}))),x=Zt.getStringOption(t.docStatus,"clientId",""),ee[x]=0,e=null,Zt.getBooleanOption(t,"hasErrors",!1)?(Fn.error("$badge{EditApp} importHandler: server side error"),e="server"):Zt.getBooleanOption(t,"operationError",!1)?(Fn.error("$badge{EditApp} importHandler: operation failure"),e=t.message):h.isError()?(Fn.error("$badge{EditApp} importHandler: server side error, errorCode="+h.getCodeAsConstant()),e="server"):0===x.length?(Fn.error("$badge{EditApp} importHandler: missing client identifier"),e="noclientid"):se||D||_.isArray(f)&&0!==f.length||(Fn.error("$badge{EditApp} importHandler: missing document operations"),e="noactions"),O=e?{cause:e}:null,_.isObject(O)?(O=_.extend(O,Dt(t)),$.Deferred().reject(O)):(d=!0,u=null,"load"===T.action&&_.isObject(T.file)&&(xn&&z&&J&&t.syncInfo&&t.syncInfo.fileVersion&&mn(t.syncInfo["document-osn"])&&t.syncInfo.fileId&&t.syncInfo.folderId&&_.isFunction(L.setFullModelNode)&&_.isFunction(L.getSupportedStorageExtensions)&&(i=t.syncInfo.fileId+"_"+t.syncInfo.folderId,c=i+"_FILEVERSION",o=i+"_STORAGEVERSION",s=i+"_OSN",l=i+"_OPERATIONS",u=L.getSupportedStorageExtensions(),a=localStorage.getItem(o)&&parseInt(localStorage.getItem(o),10)||1,K<=a?(Fn.info("$badge{EditApp} importHandler: document-osn="+t.syncInfo["document-osn"]+", document-rev="+t.syncInfo.fileVersion),localStorage.getItem(c)&&localStorage.getItem(c)===t.syncInfo.fileVersion&&localStorage.getItem(s)&&parseInt(localStorage.getItem(s),10)===parseInt(t.syncInfo["document-osn"],10)?!function(){var e=Pn(l);if(_.isArray(e)){0<f.length&&L.setExternalLocalStorageOperationsExist(!0),f=e.concat(f);e=_.last(f);return _.isNumber(e.osn)||(e.opl=1,e.osn=parseInt(localStorage.getItem(s),10)-1),1}}()?(Fn.info("$badge{EditApp} importHandler: required operations in local storage not found. Key: "+l),I()):u.some(function(e){var t=i+e.extension,n={usedLocalStorage:!0};_.isObject(e.additionalOptions)&&_.extend(n,e.additionalOptions);var r=localStorage.getItem(t);if(r)Fn.info("$badge{EditApp} importHandler: loading document from local storage. Key: "+t+" Length: "+localStorage.getItem(t).length),X=!0,we="local storage",L.setFullModelNode(r,n);else{if(!e.optional)return Fn.info("$badge{EditApp} importHandler: key in local storage not found. Key: "+t+". But found OSN key: "+s),I(),!(X=!1);Fn.info("$badge{EditApp} importHandler: optional local storage value not found. Key: "+t)}}):(Fn.info("$badge{EditApp} importHandler: file in local storage not found. Key: "+i),I())):(Fn.info("$badge{EditApp} importHandler: version of file in local storage not supported. Key: "+i),I())),X&&L.trigger("update:model",{usedLocalStorage:!0})),d?(g="",p=Zt.getBooleanOption(t,"fastLoad",!1),X||(!t.htmlDoc&&pn.DEBUG&&!se&&L.setFullModelNode&&p&&F.getFileDescriptor()&&!vn(F.getFileDescriptor().filename,"_ox")&&U.yell({type:"error",headline:_.noI18n("Error in fastload"),message:_.noI18n('you should have a look in the backend logfiles ("Exception while creating the generic html document")')}),t.htmlDoc&&_.isFunction(L.setFullModelNode)&&!se&&(Fn.info("$badge{EditApp} importHandler: load complete HTML document, osn: ",t.syncInfo["document-osn"]),(p=JSON.parse(t.htmlDoc)).mainDocument&&L.setFullModelNode(p.mainDocument),p.headerFooter&&(_.each(p.headerFooter,function(e){g+=e}),L.setFullModelNode(g,{headerFooterLayer:!0}),L.getPageLayout().headerFooterCollectionUpdate()),p.comments&&(g="",_.each(p.comments,function(e){g+=e}),L.setFullModelNode(g,{commentLayer:!0})),we="fast load",L.trigger("fastload:done"))),N.unshift({docStatus:E}),se?(we="fast empty",S(t,N).then(m)):At(M,"preProcessing","Import preprocess handler finished").then(m).then(function(){return At(function(){var e=w&&w.applyActionsDetached;e&&U.detachAppPane();var t=L.applyExternalOperations(f,{expand:!0});return e&&U.finally(t,U.attachAppPane),t},"applyOperations",f.length+" document operations applied").then(function(){if(L.getOperationStateNumber()<0)return $.Deferred().reject({cause:"applyactions",headline:Sn("Synchronization Error")});var e=X&&!L.externalLocalStorageOperationsExist();return At(B?B.bind(F,e):null,"postProcessing","Import postprocess handler finished").then(function(){return S(t,N)},function(e){return _.extend({cause:"postprocess"},e)})},function(e){if($t()&&P.off(gn.RESPONSE_OPEN_DOC,C),"destroy"!==e)throw _.extend({cause:"applyactions"},e)})},function(e){throw _.extend({cause:"preprocess"},e)})):$.Deferred().reject({cause:"localStorageFailed",headline:_.noI18n("LocalStorage failure")}));function I(){_.each(u,function(e){localStorage.removeItem(i+e.extension)}),localStorage.removeItem(s),localStorage.removeItem(o),localStorage.removeItem(c),localStorage.removeItem(l)}}L.undoManager.on("undogroup:open",function(){i=vt()}),L.undoManager.on("undogroup:close",function(){yt()&&Lt(i),i=null,L.setInternalOperationBlocker(!1)}),L.on("operations:success",function(e,t,n,r){n||Oe||(_.isObject(i)?(hn.log("operations:success - push operations into pending action"),i.operations=i.operations.concat(t),r&&(i.userData=r)):Lt(vt(t,r)))}),L.on("cacheBuffer:flush",function(){hn.log("cacheBuffer:flush received - send cached operations"),_.isFunction(p)&&_e.length&&(u=p.call(F,u,_e),Ft())}),L.on("operations:error",function(){F.isImportFinished()?(F.setInternalError(on.ERROR_WHILE_MODIFYING_DOCUMENT,nn.GENERAL),hn.error("An unrecoverable error occurred while modifying the document")):(F.setInternalError(on.ERROR_WHILE_LOADING_DOCUMENT,nn.GENERAL),hn.error("An unrecoverable error occurred while loading the document"),R.reject())}),F.getWindowNode().on("drop",!1),P=F.isViewerMode()||Zt.getBooleanOption(T,"isAttachmentFile",!1)?new On(F,w):new hn(F);this.rtConnection=P,se||U.enterBusy({skipCancelOnReadOnly:!0,cancelHandler:function(){F.isInQuit()||(Mt(".abortOpen"),Ht(),F.quit())},immediate:!0,topLabel:_.noI18n(F.getFullFileName()),warningLabel:Sn("Sorry, your document is very large. It will take some time to be loaded."),warningDelay:1e4});$t()&&(P.on(un.EVENT_OFFLINE,et),P.on(un.EVENT_ONLINE,tt),P.on(un.EVENT_ERROR,function(e,t){!function(e,t){var n;hn.log("Error handler called by RT2 communication layer, cause = "+JSON.stringify(e)),t&&"pending"===t.state()&&t.reject(e);_.isObject(e)&&_.isString(e.error)&&(n=new tn(e));F&&("GENERAL_SESSION_INVALID_ERROR"===n.getCodeAsConstant()?function(e){if(Te)return;var t=Te=!0;function n(){ox.off("relogin:success",n),ox.off("relogin:fail",r),t=!1,(f?nt:rt)(),Te=!1}function r(){ox.off("relogin:success",n),ox.off("relogin:fail",r),F.setInternalError(e),Te=!1}F.setInternalError(on.WARNING_SESSION_INVALID_DETECTED,nn.CONNECTION),H=!0,We(!1),Ve(),ox.on("relogin:success",n),ox.on("relogin:fail",r),F.executeDelayed(function(){t&&(t=!1,ox.trigger("relogin:required"))},"EditApplication.connectionErrorHandler",5e3)}(n):"GENERAL_DOCUMENT_ALREADY_DISPOSED_ERROR"===n.getCodeAsConstant()?_.isString(ce)?(de=!0,f?Et({cause:"error:disposed"}):ht(0,null,null,{cause:"error:disposed"})):F.setInternalError(n,nn.CONNECTION):"TOO_MANY_CONNECTIONS_ERROR"===n.getCodeAsConstant()?(de=!0,ce=null,F.setInternalError(n,nn.CONNECTION)):F.isLocked()||F.isInQuit()||_.isString(ce)?_.isString(ce)&&(de=!0,f?Et({cause:"reset"}):ht(0,null,null,{cause:"reset"})):"HANGUP_INVALID_OPERATIONS_SENT_ERROR"===e.error||"HANGUP_INVALID_OSN_DETECTED_ERROR"===e.error||"GENERAL_OFFLINE_CLIENT_IN_NON_SYNC_STATE"===e.error?F.setInternalError(e,nn.CONNECTION):"HANGUP_NO_EDIT_RIGHTS_ERROR"===e.error?F.restoreDocument(n):(n=on.ERROR_UNKNOWN_REALTIME_FAILURE,F.setInternalError(e,nn.CONNECTION)))}(t,R)}),P.on(un.EVENT_NORESPONSE_IN_TIME,it),P.on(gn.BROADCAST_UPDATE,v),P.on(gn.BROADCAST_UPDATE_CLIENTS,y),P.on(gn.BROADCAST_SHUTDOWN,ot),P.on(gn.BROADCAST_CRASHED,at),P.on(gn.BROADCAST_RENAMED_RELOAD,dt),P.on(gn.BROADCAST_HANGUP,st),P.on(gn.BROADCAST_OT_RELOAD,lt));return d.step("initImport","$badge{EditApp} Import process initializated"),t=function(){var t=F.createDeferred("EditApplication.establishConnection");return At(function(){var e=$t()?P.connect():F.createRejectedPromise();return hn.log("Channel UID:",$t()?P.getChannelUID():null),Be=$t()?P.getDocUID():"null",He=$t()?P.getClientUID():"null",(e=(e=e.then(function(e){var t=new tn(e);if(e.hasErrors||t.isError())throw e;return e})).then(function(t){var e=new tn(t);if(e.isWarning()&&"ADVISORY_LOCK_SET_WARNING"===e.getCodeAsConstant()){var n=JSON.parse(e.getErrorValue()),e=new Date(n.since),r=En.format(e,En.getDateFormat())+" "+En.format(e,En.getTimeFormat()),i=Sn("Document in use");return F.getUserInfo(n.uid).then(function(e){e=Sn("%1$s edits this document since %2$s on %3$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",Sn.noI18n(e.displayName),Sn.noI18n(r),Sn.noI18n(n.hostName));return U.showQueryDialog(i,e)},function(){var e=Sn("Another user edits this document since %1$s on %2$s. To avoid data loss, please open the document on %3$s. Do you want to cancel opening it here?",Sn.noI18n(r),Sn.noI18n(n.hostName));return U.showQueryDialog(i,e)}).then(function(){return F.quit(),t},function(e){if("close"===e)throw e;return t=_.extend({advisoryLock:"reset"},t)})}return t})).done(function(e){t.resolve(e)}),e.fail(function(e){t.reject(e)}),t.promise()},"connect","Realtime connection established")}(),Ke(),(e=t.then(function(e){var t=new tn(e),n={fastEmpty:se};if(!t.isError())return $t()&&(P.on(gn.RESPONSE_OPEN_DOC_CHUNK,b),P.on(gn.RESPONSE_OPEN_DOC,C)),T.auth_code&&(n=_.extend({auth_code:T.auth_code},n)),e&&e.advisoryLock&&(n=_.extend({advisoryLock:e.advisoryLock},n)),"new"===T.action&&(n=_.extend({newDoc:!0},n)),se&&(n=_.extend({fastEmptyOSN:L.getOperationStateNumber()},n)),xn&&!se&&J&&(function(e,t){if("load"!==e.action||!_.isObject(e.file))return;var n=e.file.id+"_"+e.file.folder_id,r=n+"_OSN",e=n+"_FILEVERSION",n=n+"_STORAGEVERSION",r=localStorage.getItem(r),e=localStorage.getItem(e);localStorage.getItem(n)>=K&&r&&e&&(r=parseInt(r,10),e=parseInt(e,10),_.isNumber(r)&&_.isNumber(e)&&(t.storageOSN=r,t.storageVersion=e))}(T,n),o=n.storageOSN),$t()&&P.open(n),R.then(r,function(e){return An(e)});Dt(e)}).catch(function(e){return An(Dt(e))})).always(function(){oe=null,Ve()}),e},T,_.extend({},w,{initHandler:function(){var e=Yn();pn.DEBUG&&(e=e.then(function(){return wn("io.ox/office/debug/common/main",function(e){return e.initializeApp(F)})}));return e},initFileHandler:function(){if(!F||!T)return Fn.warn("$badge{EditApp} initFileHandler: called on an already destroyed instance."),$.Deferred().reject();var e={},n=!1,r=F.launchTracker;e.initial_language=ox.language.replace(/_/g,"-"),T.cryptoAction&&(e.cryptoAction=T.cryptoAction);T.decrypt_auth_code&&(e.cryptoAuth=T.decrypt_auth_code,e.encrypted_file=!0);switch(Zt.getStringOption(T,"action","load")){case"load":return en.isDriveFile(T.file)?en.getFile(T.file).done(function(e){T.file=e}):$.when();case"convert":n=!0;break;case"new":var t=w&&w.prepareNewDocHandler;t&&_.extend(e,t.call(F));break;default:return Fn.error("$badge{EditApp} initFileHandler: unsupported launch action"),$.Deferred().reject()}var i=Zt.getObjectOption(T,"templateFile"),o=Zt.getBooleanOption(T,"preserveFileName",!1),t=Zt.getStringOption(T,"target_filename",Xn),a=Zt.getStringOption(T,"target_folder_id",""),s=Zt.getObjectOption(i,"origin");function l(e){return F.setInternalError(e,nn.CREATEDOC),$.Deferred().reject({cause:n?"convert":"create"})}_.extend(e,{action:"createdefaultdocument",document_type:F.appType,target_filename:t,target_folder_id:a,preserve_filename:o,convert:n}),T.template&&_.extend(e,{action:"createfromtemplate",file_id:i.id});_.isObject(i)&&_.extend(e,{file_id:i.id,version:i.version});F.waitForImportSuccess(function(){var e=F.getFileDescriptor(),t=!T.template&&a!==e.folder_id;(T.template?e.converted:n)?F.setCurrentInfoState(t?an.INFO_DOC_CONVERT_STORED_IN_DEFFOLDER:an.INFO_DOC_CONVERTED_AND_STORED):t&&F.setCurrentInfoState(an.INFO_DOC_CREATED_IN_DEFAULTFOLDER)});o=_.url.hash("fields"),i=_.url.hash("fields-source");(o||i)&&(_.url.hash("fields",null),_.url.hash("fields-source",null),e.fields=o,e.sourcefields=i);e=F.sendRequest(Tn,e);return e=e.then(function(e){var t=new tn(e);return t.isError()?l(t):e},function(){return l()}),r.asyncStep(e,"createNewDocAfterRequest","$badge{EditApp} New file in remote storage created"),(e=(e=e.then(function(t){return en.getFile(t.file).then(function(e){return t.file=e,t})})).then(function(e){function t(t,n){var e=F.isPresentationApp()?F.createResolvedPromise():F.leaveBusyDuringImport(!t,{immediateShow:!0});return r.asyncStep(e,"afterLeaveBusyEarly","$badge{EditApp} Busy state after creation of document left"),e.then(function(){if(t)return n;throw n},function(e){throw t?e:n})}return _.isObject(e.file)?(s&&(e.file.origin=s),e.file.source="drive",e.converted&&(e.file.converted=e.converted),(se=_.isString(e.htmlDoc)&&_.isArray(e.operations)&&0<e.operations.length)&&c?c.call(F,e.htmlDoc,e.operations).then(t.bind(null,!0),t.bind(null,!1)).then(function(){return e}):e):(Fn.error("$badge{EditApp} initFileHandler: missing file descriptor"),$.Deferred().reject())})).then(function(e){return e.file})},flushHandler:function(e){if(G)return An();var t=Ut(e);e===Hn.QUIT&&t.always(function(){We(!1)});return t=t.then(function(){return $t()?P.flushDocument():An()})},messageDataHandler:nr,printOptionsHandler:function(){return $t()?{doc_uid:P.getDocUID(),client_uid:P.getClientUID()}:null}}));var Ke=pn.DEBUG?function(){J=F.getUserSettingsValue("debugUseLocalStorage",J)&&!F.isDocumentEncrypted()}:$.noop;function Qe(e){e=_.findWhere(ne,{clientUID:e});return e&&e.userName||""}var Ze=pn.LOG_PERFORMANCE_DATA?function(){var i=U.toolBarTabs,o=0;i.on("tab:activated",function e(t,n){var r;o++,n&&(r="tabActivated_"+Cn(n),F.launchTracker.step(r,'$badge{EditApp} Toolbar tab "'+n+'" activated')),2===o&&i.off("tab:activated",e)})}:$.noop;function Je(){function e(){F.getController().update().done(function(){F.launchTracker.step("considerToolbarUIStable","$badge{EditApp} Toolbar is visually stable"),F.isReloading()&&F.setAppReloadDone(F)})}function t(){Ne=!0,F.showEditToolbarAtStart()?U.one("edittoolpane:layout:finished",e):U.one("docs:toolpane:unhide",function(){F.executeDelayed(function(){e()},"registerFirstTabActivatedHandler.unhideToolpaneHandler",150)})}F.showEditToolbarAtStart()?U.toolBarTabs.one("tab:activated",t):F.waitForImportSuccess(t)}function Xe(e){var t=tn.isErrorCode(e)?e:function(e){var t;switch(e){case"reset":t=new tn(on.ERROR_CONNECTION_RESET_RECEIVED);break;case"timeout":t=new tn(on.ERROR_CONNECTION_TIMEOUT);break;case"notMember":t=new tn(on.ERROR_CONNECTION_NOT_MEMBER);break;default:t=new tn(on.ERROR_UNKNOWN_REALTIME_FAILURE)}return t}(e);t.setErrorContext(nn.CONNECTION),$t()?(e=P.hasPendingActions()||F.hasUnsavedChangesOffice(),We(!(H=!0)),e?f?F.setInternalError(on.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,nn.CONNECTION):F.restoreDocument(t):(T.action="load",delete T.template,F.reloadDocument())):F.setInternalError(t,nn.CONNECTION)}function et(){V=!0,I&&!G&&!F.isInQuit()&&$t()&&(j=N,I=!1,f&&xe.abort(),ce?P.hasPendingActions()?F.setInternalError(on.ERROR_OFFLINE_WHILE_SYNC_LOCAL_CHANGES,nn.OFFLINE):F.setInternalError(on.ERROR_OFFLINE_WHILE_SYNCHRONIZING,nn.OFFLINE):(We(!(H=!0)),Ve(),F.setInternalError(on.WARNING_READONLY_DUE_TO_OFFLINE,nn.OFFLINE)),hn.log("Connection offline handler called by Realtime!"),gt())}function tt(){!V||I||G||F.isInQuit()||(hn.log("Connection online handler called by Realtime!"),f&&Yt(),I=!0,le&&(f?nt:rt)(),Ve(),ze())}function nt(){hn.log("Client supports synchronization - starting to sync with server"),_.isObject(F)&&(j?(F.setInternalError(on.WARNING_SYNC_AFTER_OFFLINE,nn.SYNCHRONIZATION),hn.log("Client is editor - synchronizing with server using current client state"),ce="editSync",u&&0<u.length&&Ft()):(F.setInternalError(on.WARNING_SYNC_FOR_VIEWER,nn.SYNCHRONIZATION),hn.log("Client is viewer - waiting for server messages to unlock view"),ce="viewSync"),F.executeDelayed(function(){!de&&ce&&(hn.log("Synchronization time out detected - no synchronization possible"),Et({cause:"timeout"}))},"EditApplication.startSynchronizationProcessOT",3e4),ce&&$t()&&(P.sync(),P.syncStable().then(function(e){hn.log("SyncStable response received ",e),e&&e.docStatus?Et(null):Et({cause:"reset"})},function(){Et({cause:"reset"})}).done(function(){F.repeatDelayed(function(){return!ce||de?Zt.BREAK:$t()?void Et(null):(Et({cause:"reset"}),Zt.BREAK)},"EditApplication.startSynchronizationProcessOT",{delay:0,repeatDelay:3e3,cycles:9})})))}function rt(){var n,r;hn.log("Client supports synchronization - starting to sync with server"),_.isObject(F)&&(j?(F.setInternalError(on.WARNING_SYNC_AFTER_OFFLINE,nn.SYNCHRONIZATION),hn.log("Client is editor - synchronizing with server using current client state"),ce="editSync",u&&0<u.length&&Ft()):(F.setInternalError(on.WARNING_SYNC_FOR_VIEWER,nn.SYNCHRONIZATION),hn.log("Client is viewer - waiting for server messages to unlock view"),ce="viewSync"),F.executeDelayed(function(){!de&&ce&&(hn.log("Synchronization time out detected - no synchronization possible"),ht(0,null,null,{cause:"timeout"}))},"EditApplication.startSynchronizationProcess",3e4),ce&&$t()&&(n=-1,r=null,P.sync().then(function(e){if(hn.log("Sync response received ",e),e&&e.docStatus){var t=L.getOperationStateNumber();return r=Zt.getStringOption(e.docStatus,"editUserId",""),n=Zt.getIntegerOption(e.docStatus,"serverOSN",-1),ht(W=r,t,n,null),$.when()}throw new Error("sync response contains no mandatory data - synchronization impossible!")},function(){ht(0,null,null,{cause:"reset"})}).then(function(){if(ce&&$t()){var e=P.syncStable();return e.done(function(e){var t;hn.log("SyncStable response received ",e),e&&e.docStatus?(t=L.getOperationStateNumber(),r=Zt.getStringOption(e.docStatus,"editUserId",""),ht(W=r,t,n,null)):ht(0,null,null,{cause:"reset"})}),e.fail(function(){ht(0,null,null,{cause:"reset"})}),e}throw ht(0,null,null,{cause:"reset"}),new Error("synchronization not possible")},function(){ht(0,null,null,{cause:"reset"})}).done(function(){F.repeatDelayed(function(){if(!ce||!$t())return ht(0,null,null,{cause:"reset"}),Zt.BREAK;var e=L.getOperationStateNumber();ht(_.isString(r),e,n,null)},"EditApplication.startSynchronizationProcess",{delay:0,repeatDelay:3e3,cycles:9})})))}function it(){hn.log("NoResponseInTime notification received - Server has not responded in a certain time"),F.isLocked()||F.isInQuit()||F.setInternalError(on.WARNING_CONNECTION_INSTABLE)}function ot(){var e,t;hn.log("Shutdown notification received - Document middleware node is going down!"),F.isLocked()||F.isInQuit()||!$t()||(e=P.hasPendingActions()||F.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}},N&&e?F.setInternalError(on.ERROR_SERVER_SHUTDOWN_NO_RESCUE_POSSIBLE,nn.CONNECTION,null,t):F.setInternalError(on.ERROR_SERVER_GOING_TO_SHUTDOWN,nn.CONNECTION,null,t))}function at(){var e,t;hn.log("Crashed node notification received - Document middleware node is not available anymore!"),F.isLocked()||F.isInQuit()||!$t()||(e=P.hasPendingActions()||F.hasUnsavedChanges(),t={silentShutdownConfig:{skipCloseDoc:!0,skipDisconnect:!0}},N&&e?F.setInternalError(on.ERROR_SERVER_NODE_UNAVAILABLE_NO_RESCUE_POSSIBLE,nn.CONNECTION,null,t):F.setInternalError(on.ERROR_SERVER_NODE_UNAVAILABLE,nn.CONNECTION,null,t))}function st(e,t){var n;hn.log("Hangup notification received - document cannot be edited anymore!"),F.isLocked()||F.isInQuit()||!$t()||(n=P.hasPendingActions()||F.hasUnsavedChanges(),(t=new tn(t)).isError()||(t=new tn(on.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),Ot()&&(n||function(e){var t=!1;if(tn.isErrorCode(e)&&e.isError()){switch(e.getCodeAsConstant()){case"SAVEDOCUMENT_FILE_HAS_CHANGED_ERROR":case"GENERAL_FILE_NOT_FOUND_ERROR":case"GENERAL_PERMISSION_READ_MISSING_ERROR":case"GENERAL_PERMISSION_WRITE_MISSING_ERROR":case"LOADDOCUMENT_CANNOT_RETRIEVE_OPERATIONS_ERROR":t=!0}}return t}(t))?f?F.setInternalError(on.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,nn.CONNECTION):F.restoreDocument(t):"GENERAL_MALICIOUS_ACK_HANDLING_ERROR"!==t.getCodeAsConstant()||n?F.setInternalError(t,nn.CONNECTION):F.reloadDocument())}function lt(e,t){hn.log("OT reload notification received - client must reload the document"),F.isInQuit()||((t=new tn(t)).isError()||(t=new tn(on.ERROR_SERVER_NOTIFIED_A_CRITICAL_DOC_PROBLEM)),ct(t,nn.CONNECTION))}function ct(e,t){F.trigger("docs:reload:prepare"),F.setInternalError(e,t),F.executeDelayed(function(){F.reloadDocument()},"EditApplication.handleReload",1500)}function dt(e,t){var n,r;F.isInQuit()||(new tn(t).isError()?Se&&Se.reject(t):(n=Zt.getStringOption(t,"fileId",null),r=Zt.getStringOption(t,"fileName",null),n&&r?(Se&&Se.resolve(t),F.updateFileDescriptor({id:n,filename:r,title:en.getFileBaseName(r)}),T.action="load",delete T.template,A=!1,F.reloadDocument()):Se&&Se.reject(t)))}function ut(e){if(zn.log("$back{lightgreen}handleEditRequestViaUpdate",e),!F.isInQuit()&&null===ce&&!Y&&W===x){var e=e&&_.isArray(e.activeUsers)?_.find(e.activeUsers,function(e){return e&&e.clientUID!==x&&e.requestsEditRights}):null,t=e?e.clientUID:null;if(t){if(zn.log("$back{lightgreen}__handleEditRequestViaUpdate - clientUIDRequesting ",De,Qe(t)),De)return zn.log("$back{lightgreen}__handleEditRequestViaUpdate - BLOCK OTHER REQUESTS?",t),void(De.clientUID!==t&&$t()&&(zn.log("$back{lightgreen}__handleEditRequestViaUpdate - REQUEST BLOCKED!"),P.declineEditRights(t)));zn.log("$back{lightgreen}__handleEditRequestViaUpdate - Request edit rights",a);e=function(e){if(zn.log("$back{MediumAquaMarine}handleEditRightsTransferRequest"),function(){var e=12e4,t=0<a,n=null,r=_.now()-ve;zn.log("inactivCheck knownWhenLastOpWasSend",t),t?(n=Date.now()-a,zn.log("inactivCheck sendActionsTime",a,n)):(n=Date.now()-ae,zn.log("inactivCheck importFinishedTime",ae,n));return zn.log("inactivCheck User is inactive?",e<n,!Zt.wasKeyPressedWithinTime(e),"timeDeltaToLastTransfer",r,e<r),e<n&&!Zt.wasKeyPressedWithinTime(e)&&e<r}())return Nn(Jn);var i=F.newDeferred("EditApplication.handleEditRightsTransferRequest"),t=F.createAbortablePromise(i);De={deferred:i,promise:t,clientUID:e},zn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - callForUserInput"),U.yell({type:"question",message:Sn("%1$s is asking for edit rights. This request will be accepted automatically in %2$d seconds.",Qe(e),Math.floor($n/1e3)),duration:$n,progress:!0,disableCloser:!0,restoreHidden:!0,priority:!0,renderFn:function(e){var t=$.button({label:Sn("Decline")}).addClass("btn-default").css({marginRight:5});t.on("click tab",function(){zn.log("$back{Orchid}__handleEditRightsTransferRequest - DECLINE BUTTON PRESSED BY USER"),ve=Date.now(),zn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: declined"),i.resolve(Zn)});var n=$.button({label:Sn("Accept")}).addClass("btn-primary");n.on("click tab",function(){zn.log("$back{Orchid}__handleEditRightsTransferRequest - ACCEPT BUTTON PRESSED BY USER"),zn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest -> DECISION: accepted"),i.resolve(Qn)});var r=$('<div class="button-area" style="text-align:center;margin-top:10px;">');e.append(r.append(t,n))}});var n=F.executeDelayed(function(){zn.log("$back{MediumAquaMarine}__handleEditRightsTransferRequest - DECISION: accepted automatically"),i.resolve(Qn)},"EditApplication.handleEditRightsTransferRequest.autoAcceptTimer",{delay:$n,background:!0});return t.always(function(){De=null,n.abort(),U&&U.hideYell({priority:!0})}),t}(t);e.done(function(e){if(zn.log("$back{lightgreen}__handleEditRequestViaUpdate - answer: "+e),e===Zn)return zn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer declined"),void($t()&&P.declineEditRights(t));zn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer accepted"),We(!(Y=!0)),F.setCurrentInfoState(an.INFO_PREPARE_LOSING_EDIT_RIGHTS,{showMessage:e===Jn}),Ve(),F.getController().update();e=w&&w.prepareLoseEditRightsHandler;(e?Dn(e.bind(F)):Nn()).always(function(){hn.log("handle PrepareLosingEditRights"),F.executeDelayed(function(){!function e(t){F.hasUnsavedChangesOffice()?F.executeDelayed(function(){e(t)},"EditApplication.checkForPendingOperations",2e3):Ft().then(function(){$t()&&P.canLoseEditRights(t),Y=!1,F.getController().update(),hn.log("sent canLoseEditRights")})}(t)},"EditApplication.handlePrepareLosingEditRights",1e3)})}),e.fail(function(e){zn.log("$back{lightgreen}__handleEditRequestViaUpdate - EditRights transfer failure, reason:",e)})}}}function gt(){Ae.abort(),zn.log("$back{SandyBrown}abortPendingEditRightsRequest")}function pt(){De&&(De.promise.abort(),zn.log("abortPendingEditRightsTransfer"))}function ft(t){zn.log("$back{lightblue}applyEditState - DOC UPDATE",t);var e=f?null:Zt.getStringOption(t,"editUserId",""),n=f?null:Qe(e),r=f?null:n||t.editUser,i=f?null:N,o=f?null:i,a=F.getFileDescriptor(),s=L.getOperationStateNumber(),l=f?null:Zt.getIntegerOption(t,"serverOSN",-1),c=new tn(t),d=Zt.getIntegerOption(t,"lockedByUserId",-1),n=Zt.getBooleanOption(t,"writeProtected",null);if(f?hn.log("$badge{EditApp} applyEditState: clientOSN = "+s):hn.log("$badge{EditApp} applyEditState: clientOSN = "+s+", localServerOSN = "+l),!G&&er.some(function(e){return e in t})){if(f||e===W||(hn.log("Edit rights changed, new editing user id: "+e),o=x===e,F.setCurrentInfoState(an.INFO_USER_IS_CURRENTLY_EDIT_DOC,{showMessage:!1}),zn.log("$back{lightblue}__applyEditState - EDITOR HAS BEEN CHANGED","|editClientId:",e,"|oldEditClientId:",W),Ae.running&&""!==e&&(zn.log("$back{lightblue}__applyEditState - FORCE TIMER ABORTED the editor has been changed"),gt())),Zt.getBooleanOption(t,"failSafeSaveDone",!1)&&en.propagateChangeFile(a),Zt.getBooleanOption(t,"hasErrors",!1))return F.setInternalError(on.ERROR_GENERAL_SYNCHRONIZATION_ERROR,nn.SYNCHRONIZATION),void hn.error("synchronization to the server has been lost.");H||(pn.RESCUE_DOCUMENT_READONLY&&F.isRescueDocument()?(We(!(H=!0)),F.setInternalError(on.WARNING_RESCUE_DOC_CANNOT_BE_CHANGED,nn.READONLY)):_.isBoolean(n)&&n||Zt.getBooleanOption(T,"isAttachmentFile",!1)?(We(!(H=!0)),F.setInternalError(on.WARNING_NO_PERMISSION_FOR_DOC,nn.READONLY,null,{showMessage:!L.isValidReadOnlyMode(),hideError:L.isValidReadOnlyMode()})):-1!==d&&ox.user_id!==d&&(We(!(H=!0)),F.setInternalError(on.WARNING_DOC_IS_LOCKED,nn.READONLY),b=Zt.getStringOption(t,"lockedByUser",""))),H||Y||(f?We(!0):(hn.log("Edit mode: "+o),We(o),!o&&(!I||i||r!==R&&r.length)&&(R=r,F.setCurrentInfoState(an.INFO_USER_IS_CURRENTLY_EDIT_DOC)),I&&e&&e!==W&&(function(e){var t=W,n=e,e=[n];_.isString(t)&&0<t.length&&e.push(t);W=n,_t(e)}(e),R=r),o&&!1===i&&F.setCurrentInfoState(an.INFO_EDITRIGHTS_RECEIVED),I&&!o&&i&&-1!==l&&l<s&&(F.setInternalError(on.ERROR_GENERAL_SYNCHRONIZATION_ERROR,nn.SYNCHRONIZATION),hn.error("synchronization between client and server is broken. Switching editor into read-only mode. New edit mode: "+o+"Old edit mode: "+i+", local Server OSN: "+l+", Client OSN: "+s))),(c.isError()||c.isWarning())&&F.setInternalError(c,nn.GENERAL)),I=!0,Ve()}}function Et(e){var t=null,n=function(){if(0<u.length)return!0;var e=$t()?P.getPendingActions():null;return e&&_.isArray(e.actions)&&0<e.actions.length}();function r(){hn.log("logSynchronizationState... ","\n     localChanges = ",n,"\n     rtConnection.getPendingActions() = ",$t()&&JSON.stringify(P.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(u),"\n     mustSyncNowMode = ",ce,"\n     failedData = ",JSON.stringify(e))}if(ce){if(hn.log("Checking synchronization state with server"),e){switch(e.cause){case"timeout":hn.log("Synchronization not possible - maybe connection instance is gone"),(t=new tn(on.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(nn.SYNCHRONIZATION),r(),ce=null;break;case"notMember":case"reset":case"error:disposed":hn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(t=new tn(on.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(nn.SYNCHRONIZATION),r(),ce=null}Xe(t)}switch(ce){case"editSync":if(n)return;hn.log("Synchronization successfully completed"),We(!(H=!1)),F.setCurrentInfoState(an.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0});break;case"viewSync":hn.log("Synchronization for viewer completed"),F.setCurrentInfoState(an.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})}r(),ce=null}}function ht(e,t,n,r){var i=null,o=function(){if(0<u.length)return!0;var e=$t()?P.getPendingActions():null;return _.isObject(e)&&_.isArray(e.actions)&&0<e.actions.length}();function a(e,t){hn.log("logSynchronizationState... ","\n     localChanges = ",o,"\n     rtConnection.getPendingActions() = ",$t()&&JSON.stringify(P.getPendingActions()),"\n     actionsBuffer = ",JSON.stringify(u),"\n     mustSyncNowMode = ",ce,"\n     clientOSN = ",e,"\n     serverOSN = ",t,"\n     oldEditUser = ",R,"\n     failedData = ",JSON.stringify(r))}if(ce){if(hn.log("Checking synchronization state with server"),r){switch(r.cause){case"timeout":hn.log("Synchronization not possible - maybe connection instance is gone"),(i=new tn(on.ERROR_SYNCHRONIZATION_TIMEOUT)).setErrorContext(nn.SYNCHRONIZATION),a(t,n),ce=null;break;case"notMember":case"reset":case"error:disposed":hn.log("Synchronization not possible - connection instance is gone or rt-state broken"),(i=new tn(on.ERROR_SYNCHRONIZATION_NOT_POSSIBLE)).setErrorContext(nn.SYNCHRONIZATION),a(t,n),ce=null}Xe(i)}switch(ce){case"editSync":if(Ot()){if(o)return;hn.log("Synchronization successfully completed"),We(!(H=!1)),F.setCurrentInfoState(an.INFO_SYNCHRONIZATION_SUCCESSFUL,{resetWarning:!0})}else o?(hn.log("Synchronization not possible - editor changed"),(i=new tn(on.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)).setErrorContext(nn.SYNCHRONIZATION),F.restoreDocument(i)):n<=t?(hn.log("Synchronization possible - but we lost edit rights"),H=!1,F.setCurrentInfoState(an.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(hn.log("Synchronization not possible - did not receive missing operations"),F.reloadDocument());break;case"viewSync":n<=t?(hn.log("Synchronization for viewer completed"),H=!1,F.setCurrentInfoState(an.INFO_SYNCHRONIZATION_RO_SUCCESSFUL,{resetWarning:!0})):(hn.log("Synchronization not possible - did not receive missing operations"),F.reloadDocument())}a(t,n),ce=null}}function Ot(){return f||x===W}this.getServerModuleDocUrl=function(e,t,n){if(!$t()||!ox.session||!this.hasFileDescriptor())return null;n=this.getFileParameters(_.extend({},n,{encodeUrl:!0}));return t=_.extend({session:ox.session,uid:this.get("uniqueID"),docuid:P.getDocUID()},n,t),ox.apiRoot+"/"+e+"?"+_.map(t,function(e,t){return t+"="+e}).join("&")};var _t=this.synchronize(function(e){zn.log("$back{PaleGoldenRod}applyUserData: CLIENT UPDATE",e);var t=null;if(_.isArray(e)?(t={clients:{changed:[]}},_.each(e,function(e){t.clients.changed.push({clientUID:e})})):t=e,!_.isObject(t))return Fn.error("$badge{EditApp} applyUserData: called without valid data: "+JSON.stringify(t)),$.when();var n,r=re,e=Zt.getObjectOption(t,"clients",{}),i=[],o=[];return W===x&&_.isArray(e.changed)&&0<e.changed.length&&ut({activeUsers:e.changed}),_.isArray(e.list)?o=e.list:(_.isArray(e.left)||_.isArray(e.joined)||_.isArray(e.changed))&&(n={},re.forEach(function(e){n[e.clientUID]=e}),_.isArray(e.left)&&e.left.forEach(function(e){delete n[e]}),_.isArray(e.joined)&&e.joined.forEach(function(e){n[e.clientUID]=e}),_.isArray(e.changed)&&e.changed.forEach(function(e){n[e.clientUID]=_.extend({},n[e.clientUID],e)}),Object.keys(n).forEach(function(e){o.push(n[e])})),0===o.length?$.when():(_.each(o,function(t){var e=_.isObject(t)&&_.isString(t.clientUID),n=e&&!_.isNumber(t.userId)&&_.isNumber(t.id);e?n?i.push(F.getUserInfo(t.id).then(function(e){return t.userDisplayName=e.displayName,t.userOperationName=e.operationName,t})):i.push($.when(t)):Fn.warn("$badge{EditApp} applyUserData: missing identifier")}),F.createResolvedPromise().then(function(){return $.when.apply($,i)}).done(function(){var e,t;ne=_.map(arguments,function(e){var t=e;return _.isNumber(e.userId)||((t={}).clientUID=e.clientUID,t.userId=e.id,t.userName=e.userDisplayName,t.userOperationName=e.userOperationName,t.guest=e.guest),t.active=!0===e.active||_.isNumber(e.durationOfInactivity)&&e.durationOfInactivity<60,t.remote=x!==t.clientUID,t.editor=W===t.clientUID,_.isObject(e.userData)&&(t.userData=e.userData),t.clientUID in ee||(ee[t.clientUID]=te,te+=1),t.clientIndex=ee[t.clientUID],t.colorIndex=F.getAuthorColorIndex(t.userOperationName),t}),re=_.where(ne,{active:!0}),re=_.sortBy(re,"clientIndex"),_.isEqual(r,re)||(Fn.info("$badge{EditApp} applyUserData: activeClients=",re),t=re,(e=r).length===t.length&&(e=_.copy(e,!0),t=_.copy(t,!0),_.each(e,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.each(t,function(e){e.userData&&e.userData.selections&&delete e.userData.selections,e.userData&&e.userData.ranges&&delete e.userData.ranges}),_.isEqual(e,t))||F.trigger("docs:users",re),De&&!_.findWhere(re,{clientUID:De.clientUID})&&pt(),e=_.first(_.pluck(_.where(r,{clientUID:x}),"requestsEditRights")),t=_.first(_.pluck(_.where(re,{clientUID:x}),"requestsEditRights")),!0===e&&!1===t&&(zn.log("$back{PaleGoldenRod}applyUserData: REQUEST_EDITRIGHTS FOR USER -> is false - > event spinner off",e,t,W!==x),gt(),W!==x?(zn.log("$back{PaleGoldenRod}applyUserData: YOUR REQUEST WAS DECLINED"),U.yell({message:Sn("Your request for edit rights has been declined.")})):ve=_.now()),F.trigger("docs:users:selection",re))}))},{contextMsg:"EditApplication.applyUserData"});function St(){f&&0<Pe.length&&!L.isProcessingActions()&&!function e(t){It(t,!0).done(function(){Pe.shift(),0<Pe.length&&e(Pe[0])})}(Pe[0])}function mt(e,t,n){if(n&&Vn.info("$badge{EditApp} setServerOSN: Coming back to set OSN from ACK triggered by operations:after event. Current server OSN: "+Ue+" Planned new OSN from ACK: "+e),Ue<e)if(t){if(f&&L.isProcessingExternalOperations())return Vn.info("$badge{EditApp} setServerOSN: External operations are currently applied -> coming back later. Keeping OSN: "+Ue+". NOT setting OSN from ACK: "+e),void L.one("operations:after",function(){mt(e,t,!0)});e===Ue+1?(Ue=e,ke=-1):(ke=e,Vn.info("$badge{EditApp} setServerOSN: Saving OSN from ack temporarily: "+ke))}else Ue+1<e&&Vn.info("$badge{EditApp} setServerOSN: Setting server OSN. Info: Increasing OSN by more than 1. Increasing from: "+Ue+" to "+e),n=Ue,(Ue=e)+1<ke&&Vn.info("$badge{EditApp} setServerOSN: Far distance ACK: ACK OSN is: "+ke+". But received external operations with OSN: "+Ue),ke===Ue+1?(Vn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+ke+". Triggering event: docs:ackosn:updated after next operations:after."),Ue=ke,ke=-1,L.one("operations:after",function(){Vn.info("$badge{EditApp} setServerOSN: Updating server OSN with saved ack osn: "+ke+". Triggering event: docs:ackosn:updated."),F.trigger("docs:ackosn:updated")})):0<=ke&&ke<Ue&&(Vn.error("$badge{EditApp} setServerOSN: ERROR: Setting server OSN. Receiving OSN from external operation: "+e+". But still have temporary OSN from acknowledge: "+ke),Vn.error("$badge{EditApp} setServerOSN: ERROR: Current locally used server OSN is: "+n),ke=-1,F.trigger("docs:ackosn:updated"));else Vn.info("$badge{EditApp} setServerOSN: Setting server OSN. Avoiding to set server OSN to: "+e+". Current OSN is already: "+Ue);Vn.info("$badge{EditApp} setServerOSN: Setting server OSN to: "+Ue),L.trigger("change:osn",Ue)}function It(e,t){if(G)return hn.error("$badge{EditApp} applyRemoteOperations: failed due to internal error"),$.Deferred().reject();var n=f?In(e.docStatus,"serverOSN",-1):0;if(n<0)return Fn.error("$badge{EditApp} applyRemoteActions: missing server OSN in external operations"),$.Deferred().reject();var r=tr(e);if(0===r.length)return f&&mt(n),$.when();if(fn.handleMinifiedActions([{operations:r}],!0),f||L.undoManager.clearUndoActions(),hn.log("$badge{EditApp} applyRemoteOperations: last remote operation: "+JSON.stringify(_.last(r))),f){if(L.isProcessingInternalOperations()||0<Pe.length&&!t)return t||Pe.push(e),F.createResolvedPromise({cached:!0});if(Vn.info("$badge{EditApp} applyRemoteOperations: received external operations with server OSN "+n),mt(n),0<Le.length)try{$e+=r.length,r=F.otManager.transformOperations(r,Le)}catch(e){return"OTError"===e.name?(u=[],ct(new tn(on.ERROR_CLIENT_OT_UNRESOLVABLE_OP_CONFLICT_ERROR))):Vn.exception(e,"$badge{EditApp} applyRemoteOperations: operation transformation failed"),$.Deferred().reject({cause:"operation"})}else Vn.trace("$badge{EditApp} applyRemoteOperations: external operations not transformed:",r)}n=L.applyExternalOperations(r);return n.done(function(){D=!0}),n.fail(function(){F&&!F.isInQuit()&&hn.error("$badge{EditApp} applyRemoteOperations: failed")}),n}var Rt=this.synchronize(function(o){if(function(e){if(!f){var t=!1,n=L.getOperationStateNumber();return pn.RESTORE_DOCUMENT_ENABLED&&0<e.length&&(t=!("editSync"!==ce||!$t()||!P.hasPendingActions())||n!==e[0].osn),t}}(tr(o)))return f?F.setInternalError(on.ERROR_SYNCHRONIZATION_NOT_POSSIBLE_LOCAL_CHANGES,nn.CONNECTION):ce||Ot()?F.restoreDocument(new tn(on.ERROR_SYNCHRONIZATION_LOST_EDIT_RIGHTS)):F.setInternalError(on.ERROR_GENERAL_SYNCHRONIZATION_ERROR,nn.CONNECTION),$.when();var e=It(o);return e.done(function(e){var t,n,r,i;_.isObject(o)&&!_.isObject(o.docStatus)&&Fn.error("$badge{EditApp} broadcast_update sent bad data "+JSON.stringify(o)),f&&e&&e.cached||(ft(o.docStatus),t=o,n=F.getFileDescriptor(),r=Zt.getStringOption(t,"fileName",""),i=Zt.getStringOption(t,"com.openexchange.file.sanitizedFilename",""),e=Zt.getStringOption(t,"fileVersion",""),t={},0<r.length&&r!==Zt.getStringOption(n,"filename")&&(t.filename=r),0<i.length&&i!==Zt.getStringOption(n,"com.openexchange.file.sanitizedFilename")&&(t["com.openexchange.file.sanitizedFilename"]=i),0<e.length&&e!==Zt.getStringOption(n,"version")&&(t.version=e),G||_.isEmpty(t)||(F.updateFileDescriptor(t),F.getController().update(),Ve()))}),e},{contextMsg:"EditApplication.applyUpdateMessageData"});function Nt(e){if(!_.isObject(e))return Fn.error("$badge{EditApp} registerUpdateMessageData: invalid response (object expected):",e),this.setInternalError(on.ERROR_WHILE_MODIFYING_DOCUMENT,nn.GENERAL),$.Deferred().reject();var t;hn.log("$badge{EditApp} registerUpdateMessageData: received update message:",e),0<ie.length&&x!==e.editUserId&&(hn.log(" "+ie.length+' existing pending updates must be changed to user "'+e.editUserId+'"'),t={editUser:e.editUser,editUserId:e.editUserId},ie.forEach(function(e){_.extend(e,t)})),ie.push(e);e=Rt(e);return e.always(function(){ie.shift(),hn.log("$badge{EditApp} registerUpdateMessageData: update processed, "+ie.length+" pending messages left")}),e}function At(e,t,n){if(!e)return Nn();e=(e=Dn(e.bind(F)).fail(function(){Fn.warn("$badge{EditApp} failed initialization step: "+n)})).then(function(e){return F.isInQuit()?An({cause:"closing"}):e});return F.launchTracker.asyncStep(e,t,"$badge{EditApp} "+n)}function Dt(e){if(_.isObject(F)&&!F.isInQuit()||(e={cause:"quit"}),ue)return{cause:""};var t,n,r=new tn(e),i=r.getCodeAsConstant();return G=!0,s.call(F,e),e=_.clone(e),"GENERAL_FILE_NOT_FOUND_ERROR"===i&&(C=!0),r.isError()||((n=e)&&n.error_desc&&n.error_id&&_.isString(n.error_desc)&&_.isString(n.error_id)?(t=e,r=new tn(tn.GENERAL_ERROR),t&&t.error_desc&&(t=t.error_desc,r.setDescription(t))):r=new tn(on.ERROR_UNKNOWN_REALTIME_FAILURE)),F.isInQuit()||F.setInternalError(r,nn.LOAD,null,{showMessage:!1}),e=_.extend({},e,{errorForErrorCode:F.isViewerMode()}),ue=!0,e}function vt(e,t){e={operations:e||[]};return t&&(e.userData=t),e}function yt(){return i&&i.operations&&0<i.operations.length}function Ct(){return r||0<u.length||yt()}function bt(t){bn(Le,function(e){return!e[t]})}var Tt,wt,Ft=(Tt=null,function(){if(hn.log("$badge{EditApp} sendActions: entered"),r)return hn.log("$badge{EditApp} sendActions: sending in progress - using current promise"),Tt.promise();if(G)return hn.error("$badge{EditApp} sendActions: internal error detected - promise rejected!"),$.Deferred().reject();if(f&&(bn(u,function(e){return 0<e.operations.length}),bn(Le,function(e){return 0<e.operations.length})),0===u.length)return hn.log("$badge{EditApp} sendActions: no need to send action buffer empty"),$.when();if(f){if(0<=ke)return Vn.info("$badge{EditApp} sendActions: Not all external operations are currently applied. Coming back later, when all external ops are applied!"),F.once("docs:ackosn:updated",Wt),Tt.promise();if(L.isProcessingExternalOperations())return Vn.info("$badge{EditApp} sendActions: External operations are currently applied. Coming back later in operations:after handler!"),L.one("operations:after",Vt),Tt.promise()}return Tt=F.createDeferred("EditApplication.sendActions").always(function(){hn.log("$badge{EditApp} sendActions: current send promise resolved - sendingActions = false"),r=!1,a=_.now(),Ve()}),r=!0,Ve(),function t(){if(pn.REALTIME_DEBUGGING&&Y&&u&&0<u.length&&(e=u[u.length-1].operations)&&0<e.length&&Fn.log("$badge{EditApp} sendActionsBuffer: last action:",_.last(e)),f&&Fe)return F.executeDelayed(function(){t()},"sendActionsBuffer",1e3),void Tt.resolve();l&&d&&(n=f?u.length:0,u=l.call(F,u),f&&u.length!==n&&bt("_OPTIMIZED_OPERATION_")),Wn("$badge{EditApp} sendActions: sending local actions, serverOSN="+Ue,u),u=fn.handleMinifiedActions(u),f&&Le.forEach(function(e){e.sentToServer=!0});var e=u.map(function(e){return{operations:e.operations}}),n=f?Ue:void 0,n=$t()?P.sendActions(e,n):F.createRejectedPromise();n.done(function(e){f&&(Vn.info("$badge{EditApp} sendActions: Receiving acknowledge with new OSN sent from server: "+e.body.serverOSN),mt(e.body.serverOSN,!0),Vn.info("$badge{EditApp} sendActions: Trying to clear local operation cache after receiving acknowledge"),jt()),G?(hn.error("$badge{EditApp} sendActionsBuffer: sent successfully, but internal error detected!"),Tt.reject()):0===u.length?Tt.resolve():f&&L.isProcessingExternalOperations()?(Vn.info("$badge{EditApp} sendActions: External operations are currently applied. Calling sendActions later in operations:after handler!"),L.one("operations:after",Vt),Tt.resolve()):f&&0<ke?(Vn.info("$badge{EditApp} sendActions: External operations are still missing. Calling sendActions later in operations:after handler!"),L.one("operations:after",Vt),Tt.resolve()):t()}),n.fail(function(e){hn.error("$badge{EditApp} sendActionsBuffer: rtConnection.sendActions promise failed!"),Tt.reject(e)}),u=[]}(),Tt.promise()}),Lt=(wt=F.debounce(function(t){var e=!1;hn.log(function(){var e=0<t.operations.length?JSON.stringify(_.last(t.operations)):null;return"$badge{EditApp} storeAction: "+(e?"last operation: "+e:"no operations provided")}),p&&0<_e.length&&(u=p.call(F,u,_e),_e=[],e=!(p=null)),!G&&(0<t.operations.length||e)&&(0<t.operations.length&&(u.push(t),f&&(Le.push(t),Wn("$badge{EditApp} registerAction: added local action without ACK to cache",Le))),o=A=!0,Ve())},Ft,{delay:E,maxDelay:E,contextMsg:"EditApplication.storeAndSendDebounced"}),function(e){he?wt(e):(hn.log("$badge{EditApp} registerAction: cached action during non-distribution mode"),_e.push(e))});function Ut(t){var e=U.processUnsavedComment(t===Hn.QUIT);return e=(e=(e=e.then(function(){return v})).then(function(){var e=w&&w.prepareFlushHandler;return e?e.call(F,t):null})).then(function(){var e=Ft();return t===Hn.QUIT&&(e=rr(e,5e3,"EditApplication.prepareFlushDocument")),e})}var xt,kt=_.once(function(){if(qe=!0,$t())try{var e=w&&w.prepareLeaveDataHandler,t=e?e.call(F):null}finally{P.emergencyLeave(t)}We(!1)});function $t(){return!(!P||P.destroyed)}function Pt(){P&&(gt(),pt(),P.destroy(),F.rtConnection=P=null)}function Mt(e,t,n){if(qe||!$t())return An();var r=null,i=P.getConnectOpenState();if(hn.log("$badge{EditApp} executeShutdownStep: - silentShutdownEntered:",Bt()," connectionOpenState:",i," action:",e),!Bt()){var o=!1,a=!1,s=!1;switch(i){case"unknown":case"joining":s=a=o=!1;break;case"joined":s=!(a=o=!1);break;case"opening":s=!(a=!(o=!0));break;case"opened":s=a=!(o=!1)}r=function(){switch(e){case".abortOpen":return o?P.abortOpen():null;case".closeDocument":return a?P.closeDocument(t):null;case".disconnect":return s?P.disconnect(t):null}}()}return Bt()&&(r=function(){switch(e){case".closeDocument:force":return P.closeDocument(t);case".disconnect:force":return P.disconnect(t)}}()),r?n?rr(r,n,'EditApplication.executeShutdownStep("'+e+'")'):r:An()}function Bt(){return!(null===be)}function Ht(e){var n,r,i=Zt.getBooleanOption(e,"skipCloseDoc",!1),o=Zt.getBooleanOption(e,"skipDisconnect",!1);hn.log("$badge{EditApp} silentShutdownConnection entered! - silentShutdownConfig:",e,"silentShutdownConnectionEntered",Bt()),Bt()||(We(!(H=!0)),f&&xe.abort(),n=$.Deferred(),be=n.promise(),$t()&&P.off(),(r=i?$.when():Mt(".closeDocument:force",{no_restore:ye},500)).always(function(e){var t=o?$.when():(e="timeout"===e,t="rejected"===r.state(),t=e||Boolean(i)||t,hn.log("$badge{EditApp} silentShutdownConnection: closeDocument rejected by timeout?:",e),Mt(".disconnect:force",t,500));t.always(function(){Pt(),hn.log("$badge{EditApp} silentShutdownConnection is finished"),n.resolve()})}))}function Gt(c,e){var d=F.getWindow();function t(e){var t,n,r,i,o=F.createDeferred("EditApplication.checkCloseDocumentResult"),a=new tn(e),s={},l=null;return a.isError()||a.isWarning()?(t=Zt.getStringOption(e,rn.RESTORED_FILEID,null),n=Zt.getStringOption(e,rn.RESTORED_FILENAME,null),r=Zt.getStringOption(e,rn.RESTORED_FOLDERID,null),l=Zt.getStringOption(e,rn.RESTORED_ERRORCODE,"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"),_.isString(t)&&_.isString(n)&&_.isString(r)?(l=l===tn.CONSTANT_NO_ERROR?new tn({errorClass:tn.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"}):new tn({errorClass:tn.ERRORCLASS_ERROR,error:l}),s[rn.RESTORED_FILENAME]=n,en.getPath(r).always(function(e){s[rn.RESTORED_PATHNAME]=en.preparePath(e),s[rn.ORIGINAL_FILEID]=F.getFileDescriptor().id,F.updateFileDescriptor({id:t,folder_id:r}),F.setInternalError(l,nn.CLOSE,a,{additionalData:s})})):F.setInternalError(a,nn.CLOSE,null,{additionalData:s}),L&&U?(F.registerQuitHandler(function(){o.reject()}),F.quit=(i=F.quit,function(){return o.reject(),i.call(F)}),d.idle(),o.always(function(){d.busy()}),c===Gn.LOGOUT&&o.reject()):o.reject(),a.getDescription()&&Fn.log(a.getDescription()),o.promise()):e}return Mt(".closeDocument",e=e||null,8e3).then(t,function(e){return"timeout"===e?F.createRejectedPromise(e):t(e)})}function qt(){Vn.info("$badge{EditApp} clearLocalActionsWithoutAckAfterEvent: Clearing the local actions!"),jt()}function jt(){L.isProcessingExternalOperations()?(L.off("operations:after",qt),Vn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are currently applied. Coming back later after event operations:after!"),L.on("operations:after",qt)):0<ke?(F.off("docs:ackosn:updated",qt),L.off("operations:after",qt),Vn.info("$badge{EditApp} clearLocalActionsWithoutAck: External operations are still missing. Coming back later after event docs:ackosn:updated or operations:after!"),F.on("docs:ackosn:updated",qt),L.on("operations:after",qt)):(Vn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. Before: "+JSON.stringify(Le)),L.off("operations:after",qt),F.off("docs:ackosn:updated",qt),bt("sentToServer"),Vn.info("$badge{EditApp} clearLocalActionsWithoutAck: Clearing local cache. After: "+JSON.stringify(Le)))}function Vt(){Vn.info("$badge{EditApp} sendActionsAfterApplyingExternalOperations: Sending actions after receiving operations:after event!"),Ft()}function Wt(){Vn.info("$badge{EditApp} sendActionsAfterReceivingRequiredExternalOperations: Sending actions after receiving docs:ackosn:updated event!"),Ft()}function Yt(){F.isOnline()&&Xt.isTabVisible()&&xe.start()}this.leaveBusyDuringImport=_.once(function(e,t){return oe=F.launchTracker.step("previewStart","$badge{EditApp} Busy state during import process left"),Ve(),U.showAfterImport(e,t)}),this.createDebouncedFor=function(t,e,n,r){var i=!1;return t.debounce(e,function(){if(!i){if(!F.isImportFinished()||!L.isProcessingActions())return n.call(t);var e=L.waitForActionsProcessed();i=!0,t.await(e,function(){i=!1,n.call(t)})}},r)},this.checkStartOfExternalOperations=function(){!f||i||L.isProcessingInternalOperations()||F.trigger("docs:operations:completed")},this.isRemovalOfInternalBlockerPossible=function(){return f&&!i&&!L.isDrawingChangeActive()},this.getFileFormat=function(){var e;return null===n&&(e=this.hasFileDescriptor()?this.getFullFileName():T&&T.templateFile?T.templateFile.filename:"",n=e?dn.getFileFormat(e):null),n||"ooxml"},this.isOOXML=function(){return"ooxml"===this.getFileFormat()},this.isODF=function(){return"odf"===this.getFileFormat()},this.isTemplateFile=function(){return this.hasFileDescriptor()&&dn.isTemplate(this.getFullFileName())},this.isScriptable=function(){return this.hasFileDescriptor()&&dn.isScriptable(this.getFullFileName())},this.isShutdownReceived=function(){return!1},this.getClientId=function(){return x},this.getShortClientId=function(){return x.slice(0,4)},this.getDocUID=function(){return $t()?P.getDocUID():null},this.getLoadMode=function(){return we},this.getEditClientId=function(){return W},this.getEditClientUserName=function(){return Qe(W)},this.getClientOperationName=function(){return k},this.getActiveClients=function(){return re},this.isLocallyModified=function(){return A},this.isPrepareLosingEditRights=function(){return Y},this.sendActionRequest=function(t,n,r){if(!$t())return F.createRejectedPromise();var e={action:t,docuid:P.getDocUID(),requestdata:JSON.stringify(n)};r=_.extend({method:"POST"},r);e=this.sendFileRequest(Tn,e,r);return e.fail(function(e){Fn.warn("$badge{EditApp} sendActionRequest: failed: ",t,n,r,e)}),e},this.sendAddImageIdRequest=function(e){return $t()?P.addImageId(e).then(_.constant(e)):Nn(e)},this.sendLogMessage=pn.LOG_ERROR_DATA?function(e){return F&&F.allowStoreLogFile()&&F.sendLogErrorData({errorCode:e}),this}:Zt.NOOP,this.sendCommentNotification=function(e,t,n){var r=F.getFileDescriptor(),r={recipients:e&&e.map(function(e){return{userId:fn.resolveUserId(Number(e.userId.split("::")[1])),emailAddress:e.email,posInComment:e.pos,lengthInComment:e.length}}),comment:t,commentId:n,filename:r.filename,fileId:r.id,folderId:r.folder_id},r={action:"sendcommentnotification",requestdata:JSON.stringify(r)};return F.sendRequest(Tn,r,{method:"POST"})},this.isRenameEnabled=function(){return!kn&&(!Z&&!pn.getDebugFlag("office:simple-filestore")||!this.isDocumentEncrypted()&&!f)},this.rename=function(e){var t=this.getFileDescriptor(),n=Zt.getStringOption(t,"filename",this.getFullFileName()),r=Zt.getStringOption(t,"com.openexchange.file.sanitizedFilename",n),i=yn(e);if(this.setUnsavedFileName(null),v)return Fn.warn("$badge{EditApp} rename: multiple calls, ignoring subsequent call"),v;if(0===i.length)return $.Deferred().reject();if(i===this.getShortFileName())return $.when();i+="."+this.getFileExtension(),this.isDocumentEncrypted()&&(i+=en.GUARD_EXT),this.updateFileDescriptor({filename:i}),Se=this.createDeferred("EditApplication.renameAndReload",{background:!0});e=w&&w.prepareRenameHandler;return(v=(v=(v=(v=e?Dn(e.bind(F)):Nn()).then(Ft)).then(function(){return $t()?P.renameDocument({target_filename:i}):An()})).then(function(e){var t=new tn(e);return t.isWarning()&&"RENAMEDOCUMENT_SAVE_IN_PROGRESS_WARNING"===t.getCodeAsConstant()?Se.promise():t.isError()?An(t):e})).done(function(e){y=!0,F.updateFileDescriptor({filename:Zt.getStringOption(e,"fileName",n),"com.openexchange.file.sanitizedFilename":Zt.getStringOption(e,"com.openexchange.file.sanitizedFilename",r)})}),v.fail(function(e){var t;"abort"!==e&&((t=tn.isErrorCode(e)?e:new tn(e)).setErrorContext(nn.RENAME),(e=sn.getMessageData(t)).restoreHidden=!1,Fn.warn("$badge{EditApp} rename: error: "+t.getErrorText()),U.yell(e)),F.updateFileDescriptor({filename:n})}),v.always(function(){v=null})},this.getCurrentFileName=function(){return v?U.getToolbarFileNameFieldValue():F.getShortFileName()},this.hasUnsavedChangesOffice=function(){return Ct()||!!v||this.hasUnsavedFileName()||!!L&&L.hasUnsavedComments()},this.hasUnsavedChanges=function(){return(!ox.tabHandlingEnabled||Qt.getLoggingOutState()!==Qt.LOGGING_OUT_STATE.FOLLOWER)&&(!(!$t()||!P.isConnected())&&(this.hasUnsavedChangesOffice()||P.hasPendingActions()))},this.setUserState=function(e){return this.isInternalError()||m===e||(m=e,je()),this},this.getState=function(){return m&&!this.isInternalError()?m:S},this.isEditable=function(){return N},this.isOnline=function(){return"offline"!==S},this.isInternalError=function(){return"error"===S},this.setInternalError=function(e,t,n,r){var i=tn.isErrorCode(e)?e:new tn(e),o=null,a=null,s=null,l=!0,c=Zt.getObjectOption(r,"additionalData",{}),d=tn.isErrorCode(n)?n:i,u=!1,g=Zt.getObjectOption(r,"silentShutdownConfig",{}),e=Zt.getObjectOption(r,"hideError",{}),n=i.isError();if(F.isReloading()&&F.setAppReloadDone(F),_.isString(t)&&i.setErrorContext(t),o=F.getErrorState(),(t=!_.isObject(o)||!o.isError())?(F.setErrorState(i),u=!0):_.isObject(o)&&(i=o,a=Ce),s=F.getErrorState(),tn.isErrorCode(s)&&!e&&Fn.error("$badge{EditApp} Internal error: "+s.getErrorText()),n?(We(!(H=!(I=!(G=!0)))),Ht(g)):(s=_.has(ge,i.getCodeAsConstant()),g=pe===i.getCodeAsConstant()&&sn.suppressDirectlyRepeated(i.getCodeAsConstant()),l=!s&&!g,sn.showOnceInDocLifetime(i.getCodeAsConstant())&&(ge[i.getCodeAsConstant()]=!0),pe=i.getCodeAsConstant()),Ve(i),_.isObject(a)&&!u||(a=sn.getMessageData(i,_.extend({causeError:d,viewerMode:F.isViewerMode()},Ye(),c)),F.extendMessageData(a),Re="document/reload"===Zt.getStringOption(a.action,"itemKey"),Ce=a),Zt.getBooleanOption(r,"showMessage",!0)&&l&&F.waitForImport(function(){U&&U.yell&&U.yell(a)}),n&&t&&!qe){try{q=F.sendLogErrorData({errorCode:i.getCodeAsConstant()})}catch(e){Fn.error("$badge{EditApp} Error when sendLogErrorData is callend in setInternalError error:",e," fileDec:",F&&_.isFunction(F.getFileDescriptor)&&F.getFileDescriptor())}if(F.allowStoreLogFile()&&sn.createCrashDataForError(i.getCodeAsConstant()))if(en.isGuest())F.createCrashDataAsDownload();else try{F.createCrashDataInDrive()}catch(e){Fn.error("$badge{EditApp} Error when createCrashDataInDrive is callend in setInternalError error:",e," fileDec:",F&&_.isFunction(F.getFileDescriptor)&&F.getFileDescriptor())}}},this.createCrashDataAsDownload=function(){var e,t,n;this.generateLogData()&&(n=Sn("A debug report can be downloaded. The report may contain content of previously opened documents."),e=new Bn(n,{title:Sn("Generating debug report"),classes:"generate-log-dialog",okLabel:_n.CLOSE_LABEL,showReadOnly:!0}),t=$('<div style="padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result"></div>'),n=$('<a href="#"><i class="fa fa-download" aria-hidden="true"></i><span style="padding: 0px 10px"<span>Download</span></a>'),e.listenTo(n,"click",function(){F.downloadFrontendLog()}),t.append(n),e.append(t),e.show())},this.createCrashDataInDrive=function(){var e,t,n,r,i=this.generateLogData();i&&(e=Sn("A debug report is uploaded to Drive/myFiles/crashdata. This can take a while. Closing the browser tab cancels the upload. The report may contain content of previously opened documents."),e=new Bn(e,{title:Sn("Generating debug report"),classes:"generate-log-dialog",okLabel:_n.CLOSE_LABEL,showReadOnly:!0}),t=Sn("Finished upload"),n=Sn("Could not upload file"),r=$('<div style="padding: 10px 0; text-align: center; font-weight: 400; font-size: 14px" class="result"><div class="busy-indicator io-ox-busy"></div></div>'),e.append(r),e.show(),this.sendLogErrorData({logData:i}).done(function(){r.html('<i class="fa fa-check" aria-hidden="true"></i><span style="padding: 0px 5px">'+t+"</span>")}).fail(function(){r.html('<i class="fa fa-exclamation-circle" aria-hidden="true"></i><span style="padding: 0px 5px">'+n+"</span>")}))},this.allowStoreLogFile=function(){return pn.LOG_ERROR_DATA&&!!F&&!F.isDocumentEncrypted()},this.sendLogErrorData=function(e){var t=_.has(e,"errorCode"),n=_.has(e,"logData");if(!t&&!n)return F.createRejectedPromise();function r(e){return a?"hidden":e}var i,o,a=!pn.LOG_ERROR_DATA,s=F.getFileDescriptor(),n={action:"logclientdata",logAnonymous:String(a),fileId:String(r(s&&s.id)),folderId:String(r(s&&s.folder_id)),fileName:String(r(F.getFullFileName())),userId:String(ox&&ox.user_id),docUid:String(Be),errorCode:t?(o=e&&e.errorCode,String(o||"unknownError")):"",logData:n&&F.allowStoreLogFile()?(i=e&&e.logData,String(i)):""};return F.sendRequest(Tn,n,{method:"POST",dataType:"xml"})},this.setCurrentInfoState=function(e,t){var n,r=Zt.getBooleanOption(t,"showMessage",!0),i=null;return Zt.getBooleanOption(t,"resetWarning",!1)&&(i=F.getErrorState(),_.isObject(i)&&i.isError()||F.setErrorState(new tn)),F.setInfoState(e),!(!r||(n=ln.getMessageData(e,_.extend({},Ye(),t)),F.extendMessageData(n),!_.isObject(n)))&&U.yell(n)},this.isLocked=function(){return G||H},this.isAcquireEditRightsEnabled=function(){return!f&&$t()&&!this.isLocked()&&this.isOnline()&&!N},this.isAcquireEditRightsEnabledPendingUpdates=function(){return this.isAcquireEditRightsEnabled()&&ie.length<=1},this.acquireEditRights=function(){if(zn.log("$back{Orchid}acquireEditRights - User wants to acquireEditRights -> Button pressed  "),this.isAcquireEditRightsEnabled())return Ae.start();gt()},this.saveDocumentAs=function(n,e,r,i){var o=e,a=null,s=F.getFileDescriptor(),t=null,l=!1;switch(r){case Un.NATIVE:if(i&&i.encrypted){o+="."+F.getFileExtension()+en.GUARD_EXT,t=(t=en.authorizeGuard().then(function(e){return T.auth_code=e,F.flushDocument(Hn.DOWNLOAD)},function(){return l=!0,An()})).then(function(){var e=s.file_options||{},t=e.params||{};return _.extend(t,{cryptoAction:"Encrypt",filedisplay:o,ignoreWarnings:!1}),s.file_options=_.extend(e,{params:t}),en.copyFile(s,n)});break}case Un.TEMPLATE:o+="."+F.getFileExtension(),t=(t=F.createResolvedPromise()).then(function(){return $t()?P.copyDocument({file_id:F.getFileParameters().id,target_filename:e,asTemplate:r===Un.TEMPLATE,target_folder_id:n}):An()});break;case Un.PDF:o+=".pdf",t=(t=(t=F.flushDocument(Hn.DOWNLOAD)).then(function(){return en.propagateChangeFile(s)})).then(function(){return en.getFileModelFromDescriptor(s).then(function(e){return zt.sendConverterRequest(e,{documentformat:"pdf",saveas_filename:o,saveas_folder_id:n})})});break;default:return Fn.error('$badge{EditApp} saveDocumentAs: unknown file type "'+r+'"'),An()}return(t=(t=(t=t.then(function(e){var t=new tn(e);return t.isError()?An(t):e})).then(function(t){return o=Zt.getStringOption(t,"filename")||o,en.deleteFromCache(n),en.getPath(n).then(function(e){return a=en.preparePath(e),t})})).then(function(e){if(r!==Un.PDF){r===Un.TEMPLATE&&F.setCurrentInfoState(an.INFO_DOC_SAVED_AS_TEMPLATE,{fullFileName:o,fullPathName:a,type:"success",duration:1e4});var t=Zt.getStringOption(e,"id",null);return!t&&i&&i.encrypted&&(t=_.isArray(e)?Zt.getStringOption(_.first(e),"data",null):e),n=n||Zt.getStringOption(e,"folder_id",null),en.getFile({id:t,folder_id:n}).then(function(e){e.title=en.getFileBaseName(e.filename),F.updateFileDescriptor(e),T.action="load",delete T.template,F.reloadDocument();e=F.newDeferred("EditApplication.saveDocumentAs.keepBusyScreenOpen");return F.createAbortablePromise(e)})}F.setCurrentInfoState(an.INFO_DOC_SAVED_IN_FOLDER,{fullFileName:o,fullPathName:a,type:"success",duration:1e4})})).fail(function(e){"destroy"!==e&&("cancel"===e||l||(zt.isDocConverterError(e)?U.yell({type:"error",message:zt.getErrorTextFromResponse(e)}):((e=tn.isErrorCode(e)?e:new tn(tn.GENERAL_ERROR)).setErrorContext(nn.SAVEAS),Fn.warn('$badge{EditApp} saveDocumentAs: Error code "'+e.getCodeAsConstant()+'"'),U.yell(sn.getMessageData(e,Ye())))))}),t},this.isReloadEnabled=function(){return Re},this.reloadDocument=function(e,t){this.trigger("docs:reload:prepare");var n=this.getFileDescriptor(),r=this.getFullFileName(),i=dn.getEditModule(r);if(!i)return Fn.error("$badge{EditApp} reloadDocument: unknown application type"),An();if(!dn.isNative(r))return Fn.error("$badge{EditApp} reloadDocument: unsupported document type"),An();e=_.extend({},e,{action:"load",file:n}),T.auth_code&&(e.auth_code=T.auth_code),e.activeTabId=U.toolBarTabs.getActiveTabId(),e.commentsPaneVisible=U.commentsPane&&U.commentsPane.isVisible();n=w&&w.prepareReloadHandler;return n&&_.extend(e,n.call(this)),U.isBusy()||t||U.enterBusy(),Fn.info("$badge{EditApp} reloadDocument: start reloading the document",e),this.quit(Gn.RELOAD,{editModule:i+"/main",reloadLaunchOptions:e})},this.restoreDocument=function(l,e){var t,n,r=Zt.getArrayOption(e,"actions",null),i=F.getFileDescriptor(),o=null;pn.RESTORE_DOCUMENT_ENABLED?Ie||(ye=!(Ie=!0),o=_.isNull(r)?(e=fn.handleMinifiedActions(u),$t()?(t=P.getPendingActions(),n=e,t=fn.getActionsArray(t),n=fn.getActionsArray(n),_.isArray(t)&&_.isArray(n)?t.concat(n):t):e):r,We(!(H=!0)),Ve(),G=!0,o={action:"saveaswithbackup",file_id:i.id,target_filename:i.filename,target_folder_id:i.folder_id,restore_id:me,operations:_.isNull(o)?o:JSON.stringify(o)},F.sendFileRequest(Tn,o,{method:"POST"}).then(function(e){var t=new tn(e),n=F.newDeferred("EditApplication.restoreDocument"),r=Zt.getStringOption(e,rn.RESTORED_FILEID,null),i=Zt.getStringOption(e,rn.RESTORED_FILENAME,null),o=Zt.getStringOption(e,rn.RESTORED_FOLDERID,null),a=null,s={};_.isObject(e)&&_.isString(i)&&_.isString(o)?en.getPath(o).always(function(e){a=en.preparePath(e),n.resolve(a)}):n.resolve(null),n.always(function(e){e=_.isString(e);t.isError()||(t=new tn({errorClass:tn.ERRORCLASS_ERROR,error:"BACKUPDOCUMENT_RESTORE_DOCUMENT_WRITTEN"})),s[rn.RESTORED_FILENAME]=i,s[rn.RESTORED_PATHNAME]=a,s[rn.ORIGINAL_FILEID]=F.getFileDescriptor().id,e&&F.updateFileDescriptor({id:r,folder_id:o}),F.setInternalError(t,l.getErrorContext(),l,{additionalData:s})})},function(){F.setInternalError(l)})):F.setInternalError(l)},this.rejectEditAttempt=function(e){if(this.isViewerMode())return!1;switch(e){case"image":return U.yell({message:Sn("The image could not be inserted.")});case"siri":return this.setInternalError(on.ERROR_SIRI_NOT_SUPPORTED,nn.GENERAL),!0;case"loadingInProgress":return this.setCurrentInfoState(an.INFO_LOADING_IN_PROGRESS);default:return this.isImportFinished()?ze():this.setCurrentInfoState(an.INFO_LOADING_IN_PROGRESS)}},this.getUserInfo=function(e){return this.createResolvedPromise().then(function(){return Kt.get({id:e})}).then(function(e){var t=!!e.guest_created_by,n=_.noI18n(e.display_name||e.email1||""),r=t?"User "+e.user_id:e.first_name&&e.last_name?_.noI18n(e.first_name.trim()+" "+e.last_name.trim()):e.last_name?_.noI18n(e.last_name.trim()):e.first_name?_.noI18n(e.first_name.trim()):n;return{id:e.user_id,displayName:n,operationName:r,guest:t}})},this.updateUserData=(xt=null,F.debounce(function(e){return xt=e,this},function(){$t()&&F.isImportSucceeded()&&!G&&!F.isInQuit()&&P.updateUserData("updateuserdata",xt)},{delay:500,maxDelay:1e3,contextMsg:"EditApplication.updateUserData"})),this.registerAuthorItem=function(e){var t,n;"authorId"in e&&"authorName"in e&&(t=e.authorId,(n=(_.isFinite(t)||_.isString(t))&&Zt.getStringOption(e,"authorName","").trim()||"")&&(fe[t]={id:t,name:n,initials:Zt.getStringOption(e,"initials","").trim()||null,providerId:Zt.getStringOption(e,"providerId","").trim()||null,userId:Zt.getStringOption(e,"userId","").trim()||null}))},this.getRegisteredAuthorItemById=function(e){return fe[e]},this.getAuthorColorIndex=function(e){return Jt.getSchemeColor((t=e,(e=_.indexOf(Ee,t))<0&&(e=Ee.length,Ee.push(t)),e));var t},this.addAuthors=function(e){return Ee=_.union(Ee,e),this},this.stopOperationDistribution=function(e){return he=!1,F.convertToPromise(e.call(F)).always(function(){he=!0})},this.isOperationsBlockActive=function(){return Oe},this.enterBlockOperationsMode=function(e){Oe=!0,yt()&&(F.trigger("docs:operations:remove",i.operations.length),i=vt(null,i.userData)),e.call(F),Oe=!1},this.isMultiSelectionApplication=function(){return h},this.isSnapshotApp=function(){return O},this.isFirstTabActivated=function(){return Ne},this.getLoadDocInfo=function(){return Me},this.isOTEnabled=function(){return f},Object.defineProperty(this,"otManager",{get:function(){return t=t||e.createOTManager(this.docModel)},configurable:!0,enumerable:!0}),this.transformPositionWithLocalActions=function(e,t){return this.otManager.transformPosition(e,Le,t)},this.getOTStatistics=function(){return{extOpCount:$e,otCount:t?t.getStatistics().otCount:0}},this.setOTBlockingOpsMode=function(e){Fe=e},this.isOTBlockingOpsMode=function(){return Fe},this.hasLocalActionsWithoutAck=function(){return f&&0<Le.length},this.getServerOSN=function(){return Ue},this.isRescueDocument=function(){return Ge},this.isRescueDocMode=function(){return pn.DEBUG&&Ge},this.generateLogData=function(){var e=Ln();if(0===e.length)return"";var t=navigator.userAgent,n=Be,r=He,i=this.getFullFileName(),o=en.isGuest();return t+"\ndoc_uid: "+n+"\nclient_uid: "+r+"\napp: "+this.appType+"\nguestUser: "+o+"\nfileName: "+i+"\n \n"+e.join("\n")},this.downloadFrontendLog=function(){var e="Documents_UI_log_"+ox.user+(new Date).toISOString()+".txt";qn(e,this.generateLogData())},this.useOperationOptimization=function(e){d=e},this.showEditToolbarAtStart=function(){return F.getUserSettingsValue("showToolbars",!0)||_.device("!desktop")},this.debugTypeError=pn.DEBUG?{testPlace:null,activateTestPlace:function(e){this.testPlace=e},test:function(e){this.testPlace===e&&(Fn.info("You should see a typeError now at",e),this.debugxyz.debugTypeErrorXYZ())}}:$.noop,(Ae=new Kn(this)).startHook.on(function(){F.trigger("docs:acquireeditrights:start")}),Ae.finishHook.on(function(){F.trigger("docs:acquireeditrights:end")}),xe=new Mn(function(){return $t()?P.syncStable().catch(_.noop):Nn()},{delay:3e4,interval:3e4,windowId:this.getWindowId(),contextMsg:"EditApplication.osnBeacon",background:!0}),this.onInit(function(){L=this.docModel,U=this.docView,this.getWindow().addClass("io-ox-office-edit-window"),this.waitForImport(function(){ae=F.launchTracker.step("triggerImportSuccess","$badge{EditApp} End of import process notified"),ve=ae,hn.log("Load-mode:",we)}),Ve(),Ze(),Je(),this.listenTo(L,"operations:error",function(){We(!1)}),this.listenTo(F,"docs:reload",ct),this.on("docs:operations:completed",St),dn.supportsEditMode(F.appType)||(We(!(H=!0)),Ve(),ze(dn.DOM_TEXT_EDIT_ALERT,-1)),z&&J&&(Fn.info("$badge{EditApp} onInit(): saving document to local storage is active"),xn?Fn.info("$badge{EditApp} onInit: current browser supports local storage"):Fn.warn("$badge{EditApp} onInit: current browser does not support local storage")),this.on("docs:flush:success",function(){o=!1}),L.listenTo(Xt.hideTabHook,function(){Xt.BROWSER_TAB_SUPPORT&&o&&F.flushDocument(Hn.USER),f&&xe.abort()}),L.listenTo(Xt.showTabHook,function(){f&&Yt()})},this),this.registerBeforeUnloadHandler(function(e){e||kt()}),this.registerUnloadHandler(function(){kt()}),this.registerBeforeQuitHandler(function(){if(pn.DEBUG&&F.debugTypeError.test("sync-beforeQuitHandler"),G)return(q?rr(q,4e3,"EditApplication.waitForInternalErrorLog"):Nn()).catch(function(){return Nn()});var e=F.isOnline()&&F.hasUnsavedFileName()?F.rename(F.getUnsavedFileName()):Nn();return e=(e=e.then(function(){return F.isOnline()?Ut(Hn.QUIT).catch(function(e){if("timeout"===e)return e;throw e}):null})).then(function(){var e=Ot()&&F.hasUnsavedChangesOffice(),t=Sn("This document contains unsaved changes. Do you really want to close?");return e?U.showQueryDialog(null,t):void 0})}),this.registerQuitHandler(function(e){function t(){return $.when(be).always(function(){hn.log("$badge{EditApp} quitHandler.finalizeRTConnection called"),Pt()})}function n(){try{if(hn.log("$badge{EditApp} quitHandler.connectionGateKeeper entered"),!$t())return;if(Bt())return;var e=P.getCloseLeaveState();switch(hn.log("$badge{EditApp} quitHandler.connectionGateKeeper - connectionOpenState:",e),e){case"unknown":return void Ht();case"closing":case"closed":return void Ht({skipCloseDoc:!0});case"disconnecting":case"disconnected":return;default:return void Ht()}}catch(e){Ht(),Fn.warn("$badge{EditApp} quitHandler.connectionGateKeeper: Error caught:",e)}}var r=null;try{hn.log("$badge{EditApp} quitHandler: reason",e),pn.DEBUG&&F.debugTypeError.test("sync-quithandler"),r=e===Gn.RELOAD?(Ht(),$.when()):function(e){var t=null,n=F.getWindow(),r=F.getFileDescriptor(),o=!1,i=null,a=["_OSN","_FILEVERSION","_STORAGEVERSION","_OPERATIONS"],E=e===Gn.LOGOUT,s=F.launchTracker;function l(e){o&&U.updateBusyProgress(e)}function h(n){var e="appsuiteDocsExpiryDates",r=localStorage.getItem(e),i=_.now();r&&(r=JSON.parse(r),_.isObject(r)?_.each(r,function(e,t){t!==n&&e<i&&(e=_.pluck(L.getSupportedStorageExtensions({allApps:!0}),"extension").concat(a),_.each(e,function(e){e=t+e;localStorage.removeItem(e)}),delete r[t])}):r=null),(r=r||{})[n]=i+6048e5,localStorage.setItem(e,JSON.stringify(r))}function c(){return en.propagateChangeFile(r)}n&&n.busy();var d=A||y||D||C,n="new"===T.action||T.template;r&&(d||pn.LOG_PERFORMANCE_DATA||!n&&ne.length<=1)&&(i={file:_.extend({last_opened:Date.now()},r),app:F.appType},s.setItem("LocalStorage",X),s.setItem("FastEmptyLoad",se),s.sendData());s=$t()&&P.isConnected()&&!F.isShutdownReceived();t=r&&s?(i=ye?i:_.extend({no_restore:ye},i),(Xt.BROWSER_TAB_SUPPORT?Gt(e,i):Gt(e,i).then(function(s){var l,c,d,u,g=null,p=null,e=null,t=A||y||D,n=L.getOperationStateNumber(),f=0,r=20;function i(e){e=Zt.getBooleanOption(e,"migration",!1);_.each(a,function(e){localStorage.removeItem(g+e)}),e&&(mn(s.syncInfo.fileVersion)?_.each(_.range(s.syncInfo.fileVersion>r?s.syncInfo.fileVersion-r:0,s.syncInfo.fileVersion),function(t){_.each(a,function(e){localStorage.removeItem(g+"_"+t+e)})}):(localStorage.removeItem(g+"_"+s.syncInfo.fileVersion),localStorage.removeItem(g+"_CURRENTVERSION")))}return Ke(),(t||!X)&&s&&s.syncInfo&&!E&&!F.isDocumentEncrypted()&&xn&&z&&J&&_.isFunction(L.getFullModelDescription)&&s.syncInfo.fileVersion&&s.syncInfo.fileId&&s.syncInfo.folderId&&mn(s.syncInfo["document-osn"])&&n===s.syncInfo["document-osn"]&&(h(g=s.syncInfo.fileId+"_"+s.syncInfo.folderId),e=F.newDeferred("EditApplication.saveLocalStorage"),F.executeDelayed(function(){o=!0},"EditApplication.saveFileInStorage",1500),F.executeDelayed(function(){e.notify(.1),l=_.now(),L.getFullModelDescription(e,.1,.9).always(function(){_.isFunction(L.getSupportedStorageExtensions)&&_.each(L.getSupportedStorageExtensions(),function(e){e&&_.isString(e.extension)&&a.push(e.extension)}),i({migration:!0})}).done(function(e){function a(e){return i(),Fn.info("$badge{EditApp} quitHandler: "+e),!1}e.every(function(e){var t,n,r=e.htmlString,i=g+e.extension;Fn.info("$badge{EditApp} quitHandler: created document string with size: "+r.length+". Time for conversion: "+(_.now()-l)+" ms.");try{if(0===f){if(p=g+"_OSN",c=g+"_FILEVERSION",d=g+"_STORAGEVERSION",u=g+"_OPERATIONS",localStorage.setItem(p,s.syncInfo["document-osn"]),localStorage.setItem(d,Q),localStorage.setItem(c,s.syncInfo.fileVersion),t=L.getStorageOperationCollector(),_.each(t,function(e){delete e.osn,delete e.opl}),n=JSON.stringify(t),localStorage.setItem(u,n),!localStorage.getItem(u)||localStorage.getItem(u).length!==n.length)return a("failed to save document operations in local storage");Fn.info("$badge{EditApp} quitHandler: successfully saved document operations in local storage with key: "+u)}localStorage.setItem(i,r);var o=localStorage.getItem(i);if(!o||o.length!==r.length)return a("failed to save document in local storage");if(Fn.info("$badge{EditApp} quitHandler: successfully saved document in local storage with key: "+i),0===f){o=localStorage.getItem(p),o=o?parseInt(o,10):-1;if(o!==s.syncInfo["document-osn"])return a("failed to save OSN for document in local storage");Fn.info("$badge{EditApp} quitHandler: successfully saved OSN for document in local storage with key: "+p+" : "+o)}return f++,!0}catch(e){return a("failed to save document and/or document OSN in local storage")}})}).always(function(){e.notify(1),e.resolve(s)})},"EditApplication.saveFileInStorage")),null===e?s:e.promise()})).progress(l)):$.when();s&&(t=t.then(function(){return pn.DEBUG&&F.debugTypeError.test("async-quithandler"),Mt(".disconnect",null,2e3)}));r&&(d?t=t.then(c,c):"reload"!==e&&("new"===T.action||T.template)&&ne.length<=1&&!T.keepFile&&(t=t.then(function(){return en.purgeFile(r)})));return t}(e)}catch(e){r=$.when(),Fn.warn("$badge{EditApp} quitHander: Error caught:",e)}return r=(r=r.then(n,n)).then(t,t)}),this.waitForImportStart(function(){cn.logState("import","app/loading","pending")}),this.once("docs:state:preview",function(){cn.logState("import","app/preview","pending")}),this.waitForImport(function(){cn.logState("import","app/preview","resolved"),cn.logState("import","app/loading","resolved")}),this.waitForImportSuccess(function(){f&&Yt()}),this.registerDestructor(function(){xe.destroy(),Ae.destroy(),T=w=F=L=U=null,P=u=i=_e=null,M=B=null,c=g=s=null,l=p=null,v=ee=ne=re=null,ie=xe=null,Ae=De=null})})});