define("io.ox/office/editframework/app/editcontroller",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/utils/logger","io.ox/office/tk/utils/tabutils","io.ox/office/tk/utils/driveutils","io.ox/office/baseframework/app/basecontroller","io.ox/office/baseframework/app/extensionregistry","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/view/editdialogs","gettext!io.ox/office/editframework/actions"],function(e,t,n,r,f,m,a,h,o,i,g){"use strict";var b=t.newRejected,v=n.trimAndCleanString,E=r.globalLogger,T=a.BaseController,w=o.SaveAsType,y=o.GUARD_AVAILABLE,A=o.CONVERTER_AVAILABLE,x=i.SaveAsFileDialog,C=i.SaveAsTemplateDialog,S=e.SearchCommand={CONFIG:"search:config",START:"search:start",NEXT:"search:next",PREV:"search:prev",END:"search:end"},R=e.ReplaceCommand={NEXT:"replace:next",ALL:"replace:all"},e=e.EditController=T.extend(function(a,e,t,n){T.call(this,a,e,t,n);var r=this,o=null,i="",u="",c={withcase:!1,regexp:!1},s=!0;function d(n,r){var e=t.processUnsavedComment();return e=(e=(e=e.then(function(){switch(n){case w.NATIVE:return new x(t,r&&r.encrypted?g("Save as (encrypted)"):g("Save as"),_.noI18n.fix(g("Copy of %1$s",a.getShortFileName())));case w.TEMPLATE:return new C(t,g("Save as template (%1$s)",h.getTemplateExtension(a.getFullFileName())),a.getShortFileName());case w.PDF:return new x(t,g("Export as PDF"),a.getShortFileName());default:return E.error('$badge{EditController} showSaveAsDialog: unknown file type "'+n+'"'),b()}})).then(function(e){return e.show()})).then(function(e){var t=_.isString(e.fileName)?v(e.fileName):null;return t?a.saveDocumentAs(e.folderId,t,n,r):(E.error("$badge{EditController} showSaveAsDialog: missing file name"),b())})}function l(e){return r.executeSearch(e,i,c)}function p(e){return r.executeReplace(e,i,u,c)}this.registerUndoManager=function(e){o!==e&&(this.stopListeningTo(o),o=e,this.updateOnEvent(o),this.update())},this.restoreUndoManager=function(){this.registerUndoManager(e.undoManager)},this.enableUndoRedo=function(e){s!==!!e&&(s=!!e,this.update())},this.registerItems({"app/valid":{parent:"app/imported",enable:function(){return!a.isInternalError()}},"view/toolbars/show":{get:function(){return t.toolPane.isVisible()},set:function(e){a.setUserSettingsValue("showToolbars",e),t.toolPane.toggle(e)}},"view/toolbars/tab":{get:function(){return t.toolBarTabs.getActiveTabId()},set:function(e){t.toolBarTabs.activateTab(e)},focusTarget:function(e){return"keyboard"===e?t.toolPane:null}},"view/new/menu":{parent:"app/valid",enable:function(){return f.BROWSER_TAB_SUPPORT}},"view/saveas/menu":{parent:"app/valid",enable:function(){return!a.getLaunchOption("disableSaveAs")}},"view/pane/search":{parent:"app/valid",get:function(){return t.searchPane.isVisible()},set:function(e){t.searchPane.toggle(e)},focusTarget:function(){return t.searchPane},shortcut:{keyCode:"F",ctrlOrMeta:!0,value:!0}},"document/ooxml":{enable:function(){return a.isOOXML()}},"document/odf":{enable:function(){return a.isODF()}},"document/acquireedit":{parent:"app/valid",enable:function(){return a.isAcquireEditRightsEnabled()}},"document/acquireeditOrPending":{parent:"app/valid",enable:function(){return a.isAcquireEditRightsEnabledPendingUpdates()},set:function(){a.acquireEditRights()}},"document/ot/enabled":{parent:"app/imported",enable:function(){return a.isOTEnabled()}},"document/reload":{parent:"app/imported",enable:function(){return a.isReloadEnabled()},set:function(){a.reloadDocument()}},"document/editable":{parent:"app/valid",enable:function(){return a.isEditable()}},"document/readonly":{parent:"app/valid",enable:function(){return!a.isEditable()}},"document/fullname":{get:function(){return a.getFullFileName()}},"document/rename":{parent:["document/editable","app/bundled"],enable:function(){return a.isRenameEnabled()},get:function(){return a.getCurrentFileName()},set:function(e){return a.rename(e)},async:"background"},"document/rename/dialog":{parent:"document/rename",set:function(){return t.showRenameDialog()}},"document/undo":{parent:"document/editable",enable:function(){return 0<this.getValue()&&s},get:function(){return o.getUndoCount()},set:function(){return o.undo()},shortcut:[{keyCode:"Z",ctrlOrMeta:!0,selector:".app-pane"},{keyCode:"BACKSPACE",alt:!0,selector:".app-pane"}]},"document/redo":{parent:"document/editable",enable:function(){return 0<this.getValue()&&s},get:function(){return o.getRedoCount()},set:function(){return o.redo()},shortcut:[{keyCode:"Y",ctrlOrMeta:!0,selector:".app-pane"},{keyCode:"BACKSPACE",shift:!0,alt:!0,selector:".app-pane"}]},"document/saveas/unencrypted":{parent:["app/valid","app/unencrypted"]},"document/saveas/native/dialog":{parent:"document/saveas/unencrypted",set:function(){return d(w.NATIVE)}},"document/saveas/template/dialog":{parent:"document/saveas/unencrypted",enable:function(){return!a.isRescueDocument()},set:function(){return d(w.TEMPLATE)}},"document/saveas/encrypted/dialog":{parent:"app/valid",enable:function(){return y&&!a.isExternalStorage()&&!a.isRescueDocument()},set:function(){return d(w.NATIVE,{encrypted:!0})}},"document/saveas/pdf/dialog":{parent:"document/saveas/unencrypted",enable:function(){return A&&!a.isRescueDocument()},set:function(){return d(w.PDF)}},"document/autosave":{parent:"document/editable",get:function(){return!0},set:function(){t.yell({headline:g("What is AutoSave?"),message:g("In OX Documents all your changes are saved automatically through AutoSave. It is not necessary to save your work manually.")})}},"document/users":{parent:"app/valid",enable:function(){return 1<a.getActiveClients().length},get:function(){return t.collaboratorMenu.isVisible()},set:function(e){t.collaboratorMenu.toggle(e)}},"document/search":{parent:"app/valid"},"document/search/text":{parent:"document/search",get:function(){return i},set:function(e,t){if(i=e,!t||!t.commitEvent||"focus"!==t.commitEvent.sourceType)return l(S.START)}},"document/search/withcase":{parent:"document/search",get:function(){return c.withcase},set:function(e){return c.withcase=e,l(S.CONFIG)}},"document/search/regexp":{parent:"document/search",get:function(){return c.regexp},set:function(e){return c.regexp=e,l(S.CONFIG)}},"document/search/start":{parent:"document/search",set:function(){return l(S.START)}},"document/search/prev":{parent:"document/search",set:function(){return l(S.PREV)},shortcut:[{keyCode:"G",ctrlOrMeta:!0,shift:!0},{keyCode:"F3",shift:!0}]},"document/search/next":{parent:"document/search",set:function(){return l(S.NEXT)},shortcut:[{keyCode:"G",ctrlOrMeta:!0},{keyCode:"F3"}]},"document/search/end":{parent:"document/search",set:function(){return i=u="",l(S.END)}},"document/search/close":{parent:"document/search",set:function(){return t.searchPane.hide()}},"document/replace":{parent:["document/search","document/editable"]},"document/replace/text":{parent:"document/replace",get:function(){return u},set:function(e){u=e}},"document/replace/next":{parent:"document/replace",set:function(){return p(R.NEXT)}},"document/replace/all":{parent:"document/replace",set:function(){return p(R.ALL)}},"document/new":{parent:"app/valid",set:function(e){f.openEditorChildTab(e,{target_folder_id:m.getStandardDocumentsFolderId(),target_filename:g("unnamed"),new:!0})}},"document/new/encrypted":{parent:"app/valid",enable:function(){return y},set:function(t){return m.authorizeGuardWithTab().then(function(e){f.openEditorChildTab(t,{target_folder_id:m.getStandardDocumentsFolderId(),target_filename:g("unnamed"),crypto_action:"Encrypt",auth_code:e.authCode,new:!0},e.targetTab)})}},"document/new/fromTemplate":{parent:"app/valid",set:function(){f.openPortalChildTab(a.appType)}},"document/open":{parent:"app/valid",enable:function(){return f.BROWSER_TAB_SUPPORT},set:function(){return t.showOpenDocumentDialog()}}}),a.onInit(function(){o=e.undoManager,this.updateOnEvent(o)},this),this.waitForImport(function(){this.updateOnEvent(a,"docs:state:error docs:users docs:editmode"),this.updateOnEvent(t.collaboratorMenu,"popup:show popup:hide")},this),this.listenTo(t,"dialog:show",function(e,t,n){n&&n.showReadOnly||t.listenTo(a,"docs:editmode:leave",t.close)})});e.prototype.executeSearch=function(){E.error("$badge{EditController} executeSearch: missing implementation of abstract method")},e.prototype.executeReplace=function(){E.error("$badge{EditController} executeReplace: missing implementation of abstract method")}});