define("io.ox/office/editframework/model/editmodel",["static/3rd.party/crypto-js/crypto-js.js","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/basemodel","io.ox/office/editframework/utils/editconfig","io.ox/office/editframework/utils/operations","io.ox/office/editframework/utils/operationerror","io.ox/office/editframework/utils/operationutils","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operation/context","io.ox/office/editframework/model/operation/generator","io.ox/office/editframework/model/modelattributesmixin","io.ox/office/editframework/model/undomanager"],function(x,E,e,t,n,o,k,A,P,i,$,r,a,s,D,c){"use strict";var C=e.isFulfilled,I=e.isPending,U=e.newFulfilled,N=e.newRejected,R=e.toPromise,j=t.fastThen,F=t.stringifyForDebug,H=n.TMap,n=o.Logger,T=o.globalLogger,B=i.OperationError,G=r.otLogger,J=r.isOperationRemoved,L=a.OperationContext,z=s.resolveOperations,K=s.OperationGenerator,V=c.UndoManager,W=new n("office:log-ops",{tag:"OP",tagColor:16711935});return k.extend(function(d,s){var c=s&&s.contextClass||L,u=this,t=null,o=new H,i=!1,n=!1,r=!1,a=!1,l=0,p=-1,f=null,g=d.isOTEnabled(),e=!(!s||!s.slideMode),h=e&&(E.IOS||E.CHROME_ON_ANDROID);function O(e){if(u.isProcessingActions())return g&&i&&(r?(G.info("$badge{EditModel} enterProcessActionsMode: Collision! External operations are currently applied"),u.trigger("docs:ot:collision")):n&&G.info("$badge{EditModel} enterProcessActionsMode: Internal operations are currently applied")),N(new B("$badge{EditModel} enterProcessActionsMode: recursive call",{cause:"recursive"}));t=u.newDeferred("EditModel.enterProcessActionsMode").always(function(){var e=t?t.state().replace(/ed$/,"ing"):"destructed";W.log("$badge{EditModel} enterProcessActionsMode: "+e+" promise...")});e=R(G.profileMethod("$badge{EditModel} enterProcessActionsMode",e.bind(u)));return e.progress(t.notify.bind(t)),e.done(t.resolve.bind(t)),e.fail(t.reject.bind(t)),e}function m(e,t){if(i)throw g&&(r&&!t?G.info("$badge{EditModel} beginProcessOperations: Collision! Receiving internal operation during applying external operations"):n&&t?G.info("$badge{EditModel} beginProcessOperations: Collision! Receiving external operation during applying internal operations"):G.info("$badge{EditModel} beginProcessOperations: Collision! State of external: "+t+", processingExternalOperations: "+r+", processingInternalOperations: "+n)),new B("$badge{EditModel} beginProcessOperations: recursive call - currently processing operations.",{cause:"recursive"});if(d.isInternalError())throw new B("$badge{EditModel} beginProcessOperations: illegal call - application is in error state.",{cause:"recursive"});u.trigger("operations:before",e,t),i=!0,g&&(t?r=!0:u.setInternalOperationBlocker(!0))}function M(e,t,n,o){i=!1,g&&(r=!1),e&&(e.operation&&(e.message+="; op="+F(e.operation)),W.exception(e),d.sendLogMessage(e.message)),u.trigger("operations:after",t,n,o),u.trigger(e?"operations:error":"operations:success",t,n,o)}function b(e){var t=e.getStr("name"),n=o.get(t,null);return e.ensure(n,"unknown operation %s",t),n}function v(e){return e||d.isEditable()||d.isRescueDocMode()}function y(e,t,n,o){if(W.log("i="+l+", op=",e),!_.isObject(e))throw new B("$badge{EditModel} applyOperation: JSON object expected.",{operation:e});var i=new c(u,e,t,o),r=b(i);t&&i.has("osn")&&(a=i.getInt("osn"),i.ensure(0<=a,"Invalid OSN: %d",a),-1===p&&u.setOperationStateNumber(a),g||p===a||i.error("Wrong OSN (current=%d operation=%d)",p,e.osn)),t||(e.osn=g?d.getServerOSN():p,e.opl=1,A.DEBUG&&(e.dbg_user_id=ox.user_id)),0<=p&&u.setOperationStateNumber(p+i.optInt("opl",1));var a=s&&s.storageOperationCollector;a&&a.call(u,e);a=i.optStr("scope");n||"filter"===a||g&&J(e)||(r.call(u,i),f=e,g&&!o&&(t=t?"operation:external":"operation:internal",u.trigger(t,e))),l+=1}function S(e,t,n){var o=n&&n.sendOnly,i=n&&n.userData,r=!u.isImportFinished();if(e=z(e,n),!v(t)||0===e.length)return 1;n=!t&&s&&s.operationsFinalizer;n&&(e=n.call(u,e));var a=null;try{m(e,t),u.undoManager.enterUndoGroup(function(){try{e.forEach(function(e){y(e,t,o,r)})}catch(e){a=e}})}catch(e){a=e}if(M(a,e,t,i),a)throw a}function w(n,o,e){var i=e&&e.sendOnly,t=e&&e.userData,r=!u.isImportFinished(),a=l;if(0===(n=z(n,e)).length)return u.createResolvedPromise(null);try{m(n,o)}catch(e){return M(e,n,o,t),u.createRejectedPromise(e)}e=u.undoManager.enterUndoGroup(function(){return u.iterateArraySliced(n,function(e,t){return v(o)?void y(e,o,i,r):(n=n.slice(0,t),E.BREAK)},"EditModel.applyOperationsAsync")});return u.await(e,function(){M(void 0,n,o,t)}),u.catch(e,function(e){"abort"===e?M(void 0,n.slice(0,l-a),o,t):M(e,n,o,t)}),e}k.call(this,d),this.registerOperationHandler=function(e,t){return o.insert(e,t),this},this.registerPlainOperationHandler=function(e,n){return this.registerOperationHandler(e,function(e){var t=n.call(this,e.operation,e.external);e.ensure(!1!==t,"operation handler failed")})},this.serializeToJSON=function(){return T.warn("$badge{EditModel} serializeToJSON: not implemented"),{}},this.getSelectionState=function(){},this.setSelectionState=function(){T.error("$badge{EditModel} setSelectionState: missing implementation")},this.isProcessingActions=function(){return!!t&&I(t)},this.waitForActionsProcessed=function(){return t?j(t,_.noop,_.noop):this.createResolvedPromise()},this.isProcessingOperations=function(){return i},this.isProcessingExternalOperations=function(){return r},this.isProcessingInternalOperations=function(){return n},this.setInternalOperationBlocker=function(e){g&&(e?n=e:n&&u.isProcessingActions()?t.always(function(){u.setInternalOperationBlocker(e)}):n&&!d.isRemovalOfInternalBlockerPossible()||(n=e,d.checkStartOfExternalOperations()))},this.setDrawingChangeActive=function(e){a=e},this.isDrawingChangeActive=function(){return a},this.sendOperations=W.profileMethod("$badge{EditModel} sendOperations",function(e,t){try{return S(e,!1,_.extend({},t,{sendOnly:!0})),!0}catch(e){return!1}}),this.applyOperationsAsync=W.profileMethod("$badge{EditModel} applyOperationsAsync",function(e,t){return O(function(){return w(e,!1,t)})}),this.applyOperations=W.profileMethod("$badge{EditModel} applyOperations",function(e,t){var n=O(function(){S(e,!1,t)});return C(n)}),this.applyExternalOperations=W.profileMethod("$badge{EditModel} applyExternalOperations",function(e,t){return 0===e.length?U():(t&&t.expand&&$.handleMinifiedActions([{operations:e}],!0),O(function(){return w(e,!0)}))}),this.invokeOperationHandlers=function(e){this.undoManager.disableUndoSync(function(){z(e).forEach(function(e,t){try{var n=new c(this,e,!1);b(n).call(this,n)}catch(e){throw e.index=t,e}},this)},this)},this.createOperationGenerator=function(e){return new K(this,e)},this.createAndApplyOperations=W.profileMethod("$badge{EditModel} createAndApplyOperations",function(r,a){var s=a&&a.generator||this.createOperationGenerator(a),c=!0===(a&&a.storeSelection)?_.noop:E.getFunctionOption(a,"storeSelection",null),l=s.isImmediateApplyMode();return O(function(){var t={preventSelectionChange:!(!a||!a.preventSelectionChange)};c&&(t.undoSelectionState=a&&a.undoSelectionState||u.getSelectionState());var n=!1;function e(){n=!0}this.on("operations:immediate",e);var o,i=null;try{i=u.convertToPromise(r.call(u,s))}catch(e){i=N(e)}return i.done(function(e){o=e}),i.always(function(){u.off("operations:immediate",e)}),i.fail(function(e){l&&n&&(W.error("$badge{EditModel} createAndApplyOperations: failure with immediate operations, reloading...",e),d.reloadDocument())}),i=j(i,function(){var e=s.getUserData(),e=e?{userData:e}:void 0;return l?u.sendOperations(s,e)?null:N({cause:"operation"}):w(s,!1,e)}),i=j(i,function(){c&&(c.call(u),t.redoSelectionState=a&&a.redoSelectionState||u.getSelectionState()),a&&a.afterApplyHandler&&a.afterApplyHandler.call(u,s);var e=u.undoManager;switch(a&&a.undoMode||"generate"){case"generate":t.undoUserData=s.getUserData({undo:!0}),t.redoUserData=s.getUserData(),e.addUndo(s.getOperations({undo:!0}),s.getOperations(),t);break;case"clear":e.clearUndoActions();break;case"skip":break;default:T.error("$badge{EditModel} createAndApplyOperations: unknown undo mode")}return o})})}),this.getOperationsCount=function(){return l},this.getOperationStateNumber=function(){return p},this.setOperationStateNumber=function(e){return p!==e&&(p=e,g||this.trigger("change:osn",e)),this},this.getLastOperation=function(){return f},this.getUndoManager=function(){return this.undoManager},this.useSlideMode=function(){return e},this.getSlideTouchMode=function(){return h},this.getDocumentChecksum=function(){var e=this.serializeToJSON(),e=x.MD5(JSON.stringify(e)).toString();return u.trigger("update:checksum",e),e},this.hasUnsavedComments=function(){return!1},this.checkUndoOperations=function(){},this.deleteUnsavedComments=function(){},this.isPresentationMode=function(){return!1},this.showRemoteSelections=function(){return!0},this.blockPopupMenus=function(){return!1},this.isValidReadOnlyMode=function(){return!0},this.undoManager=new V(this,s),D.call(this,s),this.registerOperationHandler(P.NOOP,_.noop),this.registerDestructor(function(){this.undoManager.destroy(),o.clear()})})});