define("io.ox/office/editframework/model/undomanager",["exports","io.ox/office/tk/utils/logger","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/operation/context"],function(e,t,o,n,r){"use strict";var k=t.globalLogger,w=n.otLogger,i=r.OperationContext,M=1,A=2;function a(e,t,n){return t?0<e.length&&_.isFunction(t)!==_.isFunction(e[0])?(k.error("$badge{UndoManager} callback function and JSON operations cannot be mixed!"),e):(_.isFunction(t)?t=[t]:(t=_.getArray(_.copy(t instanceof i?t.operation:t,!0)),n===A&&(t=t.filter(function(e){return!e._SKIP_REDO_}))),n===M?t.concat(e):e.concat(t)):e}function x(e,t,n){this.undoOperations=[],this.redoOperations=[],this.preventSelectionChange=!(!n||!n.preventSelectionChange),this.undoSelectionState=n&&n.undoSelectionState,this.redoSelectionState=n&&n.redoSelectionState,this.undoUserData=n&&n.undoUserData,this.redoUserData=n&&n.redoUserData,this.restoreActions=null,this.otMarker=void 0,this.appendOperations(e,t)}x.prototype.empty=function(){return 0===this.undoOperations.length&&0===this.redoOperations.length},x.prototype.appendOperations=function(e,t){this.undoOperations=a(this.undoOperations,e,M),this.redoOperations=a(this.redoOperations,t,A)},e.UndoManager=o.extend(function(a,e){var l=this,u=a.docApp,r=e&&e.mergeUndoActionHandler,i=e&&e.updateSelectionInUndo,d=e&&e.disableRedoWithOT,s=u.isOTEnabled(),p=[],f=null,g=0,n=0,c=0,h=null,S=null;function O(){0===g&&(f=null),g<p.length&&(p.splice(g),l.trigger("change:stack"))}function m(e){var t=null,n=p.length;if(g<n){if(S){if(!s)return void k.error("$badge{UndoManager} pushAction: OT must be enabled if processing is true in function pushAction!");var o=p[g];return void(S===M&&(o.redoOperations=e.undoOperations,v(o)))}O()}else{if(d&&S===M)return;if(r&&0<n&&(t=_.last(p),!0===r.call(l,t,e)))return void(t.redoSelectionState=e.redoSelectionState)}p.push(e),g=p.length,s&&v(e),l.trigger("change:stack")}function v(e){e.otMarker=f?f.length:0}function b(){return p[g].otMarker}function U(e,t,n,o){S=e,a.setInternalOperationBlocker(!0);o=_.isFunction(t[0])?t.reduce(function(e,t){return e.then(function(){var e=t.call(l);return!1===e?$.Deferred().reject():e})},l.createResolvedPromise()):a.applyOperationsAsync(_.copy(t,!0),{userData:o});return l.await(o,function(){_.isObject(n)&&a.setSelectionState(n)}),l.finally(o,function(){S=null,a.setInternalOperationBlocker(!1)}),o}function y(e,t,n,o){var r,i,a,s=f.slice(b());e===M?(a=s,p[g].restoreActions=0<a.length?_.copy(a,!0):null):(i=p[g].restoreActions,p[g].restoreActions=null,i&&(r=i.length,a=b()-r,f.splice.apply(f,[a,r].concat(i))));var c={operations:t,selection:!0};if(0===s.length)return c;d&&e===M&&(w.info("$badge{UndoManager} transformOperations: dropping untransformable redo actions"),O());try{w.info("$badge{UndoManager} transformOperations: stackIndex="+g+", transforming operations..."),c.operations=u.otManager.transformOperations(t,s,{swapped:!0,userData:o}),n&&(c.selection=u.otManager.transformSelectionState(n,s),c.selection&&l.trigger("transform:selectionstate",n,s))}catch(e){"OTError"===e.name?w.warn("$badge{UndoManager} transformOperations: transformation failed"):w.exception(e,"$badge{UndoManager} transformOperations: transformation failed"),w.warn("$badge{UndoManager} transformOperations: clearing undo stack"),l.clearUndoActions(),delete c.operations}return c}o.call(this,a),this.isUndoEnabled=function(){return(!S||s)&&0===n&&this.isImportFinished()},this.clearUndoActions=function(){g=0,O()},this.enterUndoGroup=function(e,t,n){this.isUndoEnabled()&&0===c&&(h=new x(null,null,n),i&&!h.undoSelectionState&&(h.undoSelectionState=a.getSelectionState()),l.trigger("undogroup:open")),c+=1;var o=null;try{o=this.convertToPromise(e.call(t))}catch(e){o=this.createRejectedPromise(e)}return this.finally(o,function(){--c,h&&0===c&&(h.empty()||u.isOperationsBlockActive()||(i&&!h.redoSelectionState&&(h.redoSelectionState=a.getSelectionState()),m(h)),h=null,l.trigger("undogroup:close"))}),o},this.disableUndoSync=function(e,t){try{return n+=1,e.call(t)}finally{--n}},this.addUndo=function(e,t,n){u.isEditable()&&this.isUndoEnabled()&&(e||t)&&(h?h.appendOperations(e,t):(i&&((n=n||{}).undoSelectionState||(n.undoSelectionState=a.getSelectionState())),m(new x(e,t,n))))},this.getUndoCount=function(){return g},this.undo=function(){if(0===g)return $.when();var e=p[--g],t=e.undoOperations,n=e.undoUserData;if(s&&f&&!_.isFunction(t[0])){var o=y(M,t,e.undoSelectionState,n);if(!o.operations)return $.when();t=o.operations,o.selection||delete e.undoSelectionState}var r=_.isFunction(t[0])?[]:t,i={preventSelectionChange:e.preventSelectionChange},o=e.undoSelectionState;o&&(i.selectionState=o),n&&(i.userData=n),this.trigger("undo:before",r,i),s&&0===t.length&&(e.redoOperations=[],v(e));n=U(M,t,o,n);return this.finally(n,function(){this.trigger("undo:after",r,i)}),n},this.getRedoCount=function(){return p.length-g},this.redo=function(){if(g===p.length)return $.when();var e=p[g],t=e.redoOperations,n=e.redoUserData;if(s&&f&&!_.isFunction(t[0])){var o=y(A,t,e.redoSelectionState,n);if(!o.operations)return $.when();t=o.operations,o.selection||delete e.redoSelectionState}var r=_.isFunction(t[0])?[]:t,i={preventSelectionChange:e.preventSelectionChange},o=e.redoSelectionState;o&&(i.selectionState=o),n&&(i.userData=n),this.trigger("redo:before",r,i);n=U(A,t,o,n);return this.finally(n,function(){g+=1,this.trigger("redo:after",r,i),s&&0===t.length&&a.checkUndoOperations(f,e.undoOperations)}),n},s&&this.listenTo(a,"operations:success",function(e,t,n){n&&0<p.length&&((f=f||[]).push({operations:t,sentToServer:!0}),d&&(w.info('$badge{UndoManager} event "operations:success": dropping untransformable redo actions'),O()))})})});