define("io.ox/office/spreadsheet/model/formula/funcs/referencefuncs",["require","exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/dimension","io.ox/office/spreadsheet/model/formula/utils/matrix","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/funcs/types","io.ox/office/spreadsheet/model/formula/tokenarray"],function(e,r,l,i,v,u,m,c,o,d,f,t,n){"use strict";Object.defineProperty(r,"__esModule",{value:!0});var E,y=Math.floor;(T=E=E||{}).EXACT="exact",T.LESS="less";var C={emptyParam:!0,blankCells:!(T.GREATER="greater"),acceptErrors:!0},a=new t.FunctionSpecBuilder("reference"),s=a.param("val:int",{mat:"pass"}),p=a.param("ref",{dep:"skip"}),h=a.param("ref:single",{dep:"skip"}),g=a.param("ref:multi",{dep:"skip"}),w=a.param("any",{mat:"pass"}),A=a.param("any",{dep:"skip"}),R=a.param("any",{dep:"skip",mat:"pass"}),T=a.param("any:lazy",{dep:"pass"}),t=a.param("any:lazy",{dep:"pass",mat:"forward"});function x(e,r,t,o){if(r<1||t<=r)throw v.ErrorCode.VALUE;return e.getOperand(r,o?"val:any":"any")}function S(r,t,e,o,n,a){function s(e){return e||v.ErrorCode.NA.throw()}if(1<(n?o.rows:o.cols))switch(e.type){case m.ContextType.MAT:var i=e.getMatrix(),i=n?i.toRowVector(0):i.toColVector(0);e=r.createOperand(i);break;case m.ContextType.REF:var l=e.getRanges()[0].clone();l.setEnd(l.getStart(!n),!n),e=r.createOperand(l)}if(a===E.EXACT){var l=r.createScalarIterator(e,C),u=r.createScalarMatcher(t);return s(l.find(function(e){return u(e.value)}))}for(var c,d=function(s,e){switch(e.type){case m.ContextType.VAL:var r=e.getRawValue();return function(){return{value:r,offset:0}};case m.ContextType.MAT:var t=e.getMatrix();return function(e){return{value:t.getByIndex(e),offset:e}};case m.ContextType.REF:var e=s.convertToValueRange(e.getRanges()),i=s.getSheetModel(e.sheet1),l=i.cellCollection,u=e.toRange();return function(e,r,t){var o=u.addressAt(e),n=s.getCellValue(i,o);if(null!==n)return{value:n,offset:e};e=l.findFirstCell(u,{startAddress:o,skipStart:!0,type:"value"});if(e){var a=u.indexAt(e);if(a<=t)return{value:s.getCellValue(i,e),offset:a}}a=l.findFirstCell(u,{startAddress:o,skipStart:!0,type:"value",reverse:!0});if(a){o=u.indexAt(a);if(r<=o)return{value:s.getCellValue(i,a),offset:o}}}}return m.throwEngineError("createNearestScalarResolver(): unknown operand type")}(r,e),f=a===E.LESS?function(e){return r.compareScalars(e,t)<=v.CompareResult.EQUAL}:function(e){return r.compareScalars(e,t)>=v.CompareResult.EQUAL},p=0,h=(n?o.cols:o.rows)-1;p<=h;){var g=d(y((p+h)/2),p,h);if(!g)return s(c);f(g.value)?p=(c=g).offset+1:h=g.offset-1}return s(c)}function M(e,r,t,o,n){var a=t?o:n,o=t?n:o;switch(r.type){case m.ContextType.VAL:if(0!==a||0!==o)throw v.ErrorCode.NA;return r.getRawValue();case m.ContextType.MAT:var s=r.getMatrix();if(a>=s.rows()||o>=s.cols())throw v.ErrorCode.NA;return s.values()[a][o];case m.ContextType.REF:s=r.getRanges()[0],r=e.getSheetModel(s.sheet1),s=s.start.clone();return s[0]+=o,s[1]+=a,e.getCellValue(r,s)}return m.throwEngineError("getScalarAt(): unknown operand type")}function O(e,r,t,o,n,a){var s=t.getDimension({errorCode:v.ErrorCode.VALUE}),i=o?s.rows:s.cols;if(n<1||i<n)throw v.ErrorCode.NA;a=S(e,r,t,s,o,l.toBoolean(a,!0)?E.LESS:E.EXACT);return 1===n?a.value:M(e,t,o,n-1,a.offset)}r.default={ADDRESS:a.genericFixed("val:str",2,5,{signature:["val:int","val:int","val:int","val:bool","val:str"],resolve:function(e,r,t,o,n){var a="";if((t=this.isMissingOrEmptyOperand(2)?1:t)<1||4<t)throw v.ErrorCode.VALUE;o=this.isMissingOrEmptyOperand(3)||o;var s=new d.CellRef(0,0,0<t%2,t<=2),i=new u.Address(0,0);return o||s.absCol?s.col=r-1:r<0?(t=this.addressFactory.maxCol,s.col=t+r,i[0]=t):(s.col=r,i[0]=0),o||s.absRow?s.row=e-1:e<0?(r=this.addressFactory.maxRow,s.row=r+e,i[1]=r):(s.row=e,i[1]=0),this.checkCellRef(s),l.isString(n)&&(0<n.length&&!this.formulaGrammar.isSimpleSheetName(this.docModel,n,{range:!0,external:!0})&&(n=f.encodeComplexSheetName(n)),a=n+"!"),a+this.docModel.getFormulaGrammarUI(!o).formatReference(this.docModel,i,s)}}),AREAS:a.unary("val:num",p,function(e){return e.length}),CHOOSE:a.generic("any",2,{signature:[s,t],resolve:function(e){var r=this,t=this.getOperandCount();if(!m.isValType(this.contextType)&&m.isMatType(this.getOperand(0).type)||m.isMatType(this.contextType)&&!m.isValType(this.getOperand(0).type)){var o=this.getOperands(0).reduce(function(e,r){return c.Dimension.boundary(e,r.getDimension({errorCode:v.ErrorCode.NA}))},null);return this.aggregateMatrix(o,function(){return x(r,r.getOperand(0,"val:int"),t,!0)})}return x(this,e,t)}}),COLUMN:a.unaryOpt("val:num",h,{resolve:function(e){if(e&&m.isMatType(this.contextType)){o.ensureMatrixDim(1,e.cols());var t=e.start[0]+1;return new o.NumberMatrix(1,e.cols(),function(e,r){return t+r})}return(e?this.getMatrixAddress(e):this.getTargetAddress())[0]+1},relColRef:function(e){return 0===e}}),COLUMNS:a.unary("val:num",A,function(e){var r=e.getRawValue();switch(e.type){case m.ContextType.VAL:return v.isErrorCode(r)?r.throw():1;case m.ContextType.MAT:return r.cols();case m.ContextType.REF:return this.convertToRange(r).cols()}return m.throwEngineError("ReferenceFuncs.COLUMNS.resolve(): unknown operand type")}),FORMULATEXT:a.unary("val:str",h,{name:{ooxml:"_xlfn.FORMULATEXT",odf:"FORMULA"},recalc:m.RecalcMode.ALWAYS,resolve:function(e){var r=e.start,e=this.getSheetModel(e.sheet1),e=this.getCellFormula(e,r);if(!e)throw v.ErrorCode.NA;r="="+e.formula;return e.matrix?"{"+r+"}":r}}),GETPIVOTDATA:a.generic("val:any",2,{hidden:!0,repeatParams:2}),HLOOKUP:a.genericFixed("any",3,4,{signature:["val",w,"val:int","val:bool"],resolve:function(e,r,t,o){return O(this,e,r,!0,t,o)}}),INDEX:a.genericFixed("any",2,4,{recalc:m.RecalcMode.ALWAYS,signature:[A,s,s,s],resolve:function(e,r,t,o){var n,a,s=l.isNumber(o)?o-1:0;if(s<0)throw v.ErrorCode.REF;o=i.block(function(){switch(e.type){case m.ContextType.VAL:if(0<s)throw v.ErrorCode.REF;return new c.Dimension(1,1);case m.ContextType.MAT:if(0<s)throw v.ErrorCode.REF;return(n=e.getRawValue()).dim();case m.ContextType.REF:if(!(a=e.getRawValue()[s]))throw v.ErrorCode.REF;if(!a.singleSheet())throw v.ErrorCode.VALUE;return c.Dimension.createFromRange(a)}return m.throwEngineError("function INDEX: invalid operand type")});if(l.isNumber(t)||(1===o.rows?(t=r,r=1):t=0),r<0||r>o.rows||t<0||t>o.cols)throw v.ErrorCode.REF;if(n)return 0===r&&0===t?n:0===r?n.toColVector(t-1):0===t?n.toRowVector(r-1):n.values()[r-1][t-1];if(a){o=this.getSheetModel(a.sheet1);return 0<r&&(a=a.rowRange(r-1)),0<t&&(a=a.colRange(t-1)),this.isMatrixMode()&&a.single()?this.getCellValue(o,a.start):a}return e}}),INDIRECT:a.binaryOpt("ref",["val:str","val:bool"],{recalc:m.RecalcMode.ALWAYS,resolve:function(e,r){r=this.isMissingOrEmptyOperand(1)||r;var t=this.getRefSheetModel(),o=new n.TokenArray(t,m.FormulaType.LINK),t=r?m.GrammarType.UI_A1:m.GrammarType.UI_RC,r=this.getTargetAddress();o.parseFormula(t,e,r);r=o.resolveRangeList(r,r,{resolveNames:n.ResolveNamesMode.SIMPLE});return 1===r.length?r.first():v.ErrorCode.REF.throw()}}),LOOKUP:a.ternaryOpt1("any",["val",w,R],{recalc:m.RecalcMode.ALWAYS,resolve:function(e,r,t){m.isValType(r.type)&&v.throwErrorCode(r.getRawValue());var o=r.getDimension({errorCode:v.ErrorCode.VALUE}),n=o.rows<o.cols,a=null==t?void 0:t.getDimension({errorCode:v.ErrorCode.VALUE});if(a&&1<a.rows&&1<a.cols)throw v.ErrorCode.NA;e=S(this,e,r,o,n,E.LESS);if(t&&a)return M(this,t,1<a.cols||1===a.rows&&n,0,e.offset);o=(n?o.rows:o.cols)-1;return 0==o?e.value:M(this,r,n,o,e.offset)}}),MATCH:a.ternaryOpt1("val:num",["val",w,"val:num"],function(e,r,t){if(m.isValType(r.type))throw v.throwErrorCode(r.getRawValue()),v.ErrorCode.NA;var o=r.getDimension({errorCode:v.ErrorCode.VALUE});if(1<o.rows&&1<o.cols)throw v.ErrorCode.NA;t=!l.isNumber(t)||0<t?E.LESS:t<0?E.GREATER:E.EXACT;return S(this,e,r,o,1<o.cols,t).offset+1}),OFFSET:a.genericFixed("ref",3,5,{recalc:m.RecalcMode.ALWAYS,signature:[p,"val:int","val:int","val:int","val:int"],resolve:function(e,r,t,o,n){e=this.convertToRange(e,{errorCode:v.ErrorCode.VALUE});return e.start[0]+=t,e.start[1]+=r,e.end[0]+=t,e.end[1]+=r,this.isMissingOrEmptyOperand(4)||(e.end[0]=e.start[0]+n-1),this.isMissingOrEmptyOperand(3)||(e.end[1]=e.start[1]+o-1),this.addressFactory.isValidRange(e)?e:v.ErrorCode.REF.throw()}}),ROW:a.unaryOpt("val:num",h,{resolve:function(e){if(e&&m.isMatType(this.contextType)){o.ensureMatrixDim(e.rows(),1);var r=e.start[1]+1;return new o.NumberMatrix(e.rows(),1,function(e){return r+e})}return(e?this.getMatrixAddress(e):this.getTargetAddress())[1]+1},relRowRef:function(e){return 0===e}}),ROWS:a.unary("val:num",A,function(e){var r=e.getRawValue();switch(e.type){case m.ContextType.VAL:return v.isErrorCode(r)?r.throw():1;case m.ContextType.MAT:return r.rows();case m.ContextType.REF:return this.convertToRange(r).rows()}return m.throwEngineError("function ROWS: unknown operand type")}),SHEET:a.unaryOpt("val:num",A,{name:{ooxml:"_xlfn.SHEET"},recalc:m.RecalcMode.ALWAYS,resolve:function(e){if(!e)return this.getRefSheet()+1;var r=e.getRawValue();if(m.isRefType(e.type))return this.convertToRange(r).sheet1+1;if(m.isValType(e.type)){r=this.docModel.getSheetIndex(this.convertToString(r));return r<0?v.ErrorCode.NA.throw():r+1}throw v.ErrorCode.NA}}),SHEETS:a.unaryOpt("val:num",g,{name:{ooxml:"_xlfn.SHEETS"},recalc:m.RecalcMode.ALWAYS,resolve:function(e){return e?e.sheets():this.docModel.getSheetCount()}}),SWITCH:a.generic("any",3,{name:{ooxml:"_xlfn.SWITCH",odf:null},signature:["val",T,T],resolve:function(e){for(var r=this.getOperandCount(),t=y((r-1)/2),o=0;o<t;o+=1){var n=this.getOperand(2*o+1,"val");if(this.equalScalars(e,n))return this.getOperand(2*o+2)}return this.getOperand(2*t+1)}}),VLOOKUP:a.genericFixed("any",3,4,{signature:["val",w,"val:int","val:bool"],resolve:function(e,r,t,o){return O(this,e,r,!1,t,o)}})}});