define("io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter",["io.ox/office/tk/utils","io.ox/office/tk/object/dobject","io.ox/office/editframework/model/formatter/presetformattable","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/tokens","io.ox/office/spreadsheet/model/formula/interpret/operand","io.ox/office/spreadsheet/model/formula/interpret/formulacontext"],function(l,e,r,t,o,a,n,s){"use strict";var i=e.DObject,u=r.PresetCodeId,c=t.ErrorCode,p=t.isErrorCode,d=t.Address,f=t.Range,h=t.Range3DArray,m=o.ContextType,y=o.InternalErrorCode,v=o.isValType,g=o.isMatType,R=o.isRefType,O=o.isAnyType,T=o.isInternalError,w=o.Dimension,E=o.CompareNullMode,x=o.equalScalars,A=o.compareScalars,N=o.scalarToString,F=o.isValidMatrixDim,k=o.Matrix,M=o.throwEngineError,S=o.FormulaErrorCode,C=o.FormulaError,D=o.formulaLogger,I=a.TokenType,b=n.Operand,P=n.OperandResolver,V=s.combineParsedFormats,L=s.FormulaContext;function U(e,r){if(R(r)&&!R(e)&&!O(e))throw new C("expected reference token",S.REFERENCE)}function j(e,r,t,o){var a=g(e)?new k(o):o;return D.info(function(){return"result: type="+r+" code="+t+" value="+N(a)}),{type:r,code:t,value:a}}var z=i.extend(function(e,r,t,o,a){i.call(this),this.docModel=e,this.rootNode=r,this.refAddress=t,this.targetAddress=o,this.refSheet=l.getIntegerOption(a,"refSheet",null),this.wrapReferences=a&&a.wrapReferences,this.recalcDirty=a&&a.recalcDirty,this.formulaContext=new L(e,o,a)});z.prototype.getResult=function(e,r){var t=function(){try{return this.resolveNode(this.rootNode,e,r)}catch(e){if(p(e))return this.createOperand(e);throw e}}.call(this),o=O(e)?t.type:e,a={value:function(){try{switch(o){case m.VAL:return t.getScalar(null,null);case m.MAT:return t.getMatrix();case m.REF:return t.getRanges();default:M('InterpreterInstance.getResult(): unknown context type: "'+o+'"')}}catch(e){if(p(e))return e;throw e}}.call()},n=t.format;n&&!n.isStandard()&&(a.format=n);n=t.url;return null!==n&&(a.url=n),a},z.prototype.resolveReference=function(e){e=e.getRange3D(this.refAddress,this.targetAddress,this.refSheet,this.wrapReferences);return e?new h(e):c.REF},z.prototype.resolveDefinedName=function(e,r,t){var o=this.docModel.resolveNameModel(e,this.refSheet);if(!o)return c.NAME;var a=this.formulaContext.getRefAddress(),e={refSheet:this.refSheet,recalcDirty:this.recalcDirty};return t&&(e.matrixRange=f.createFromAddressAndSize(a,t.cols,t.rows)),g(r)&&!t&&(r=m.ANY),o.tokenArray.interpretFormula(r,d.A1,a,e).value},z.prototype.resolveTableRange=function(e){e=e.getRange3D(this.targetAddress);return e?new h(e):c.REF},z.prototype.createOperand=function(e,r){return!r&&e instanceof b?e:this.formulaContext.createOperand(e,r)},z.prototype.resolveOperandNode=function(e,r,t){var o=e.token,a=null,e=null;switch(D.log("> resolving operand token "+o+" with context type "+r),o.type){case I.LIT:a=(e=o.value)===c.REF?m.REF:m.VAL;break;case I.MAT:e=o.value,a=m.MAT;break;case I.REF:e=this.resolveReference(o),a=m.REF;break;case I.NAME:e=this.resolveDefinedName(o,r,t),a=m.ANY;break;case I.TABLE:e=this.resolveTableRange(o),a=m.REF;break;default:M('InterpreterInstance.resolveOperandNode(): unknown token type: "'+o.type+'"')}return U(a,r),this.createOperand(e)},z.prototype.getParsedFormat=function(e,r){var t=this.docModel.numberFormatter;if("infer"===r){for(var o=t.standardFormat,a=0;o&&a<e.size();a+=1)var n=e.get(a),n=n&&n.format||t.standardFormat,o=V(o,n);return o}switch(r){case"percent":return t.getPercentFormat({int:!0});case"currency":return t.getCurrencyFormat({red:!0});case"fraction":return t.getParsedFormat(u.FRACTION_LONG);case"date":return t.getSystemDateFormat();case"time":return t.getSystemTimeFormat();case"datetime":return t.getSystemDateTimeFormat()}},z.prototype.getOperand=function(r,t,o,a,n){var s=this.formulaContext;s.checkEvalTime();var e=function(){try{s.setMatrixPosition(a,n);var e=o.map(function(e,r){return e?s.convertOperandToValue(e,t[r].typeSpec):null});return D.logTokens("  resolving with parameters",e),r.resolve.apply(s,e)}catch(e){if(p(e))return e;throw e}}();return this.createOperand(e)},z.prototype.resolveOperatorNode=function(o,a,n){if(o.error)throw o.error;var e=o.token;D.log("> processing operator "+e+" with "+o.operands.length+" parameters and context type "+a);var s=o.resource;if(!s)return this.createOperand(c.NAME);if(U(s.retType,a),!_.isFunction(s.resolve))return D.warn('$badge{InterpreterInstance} resolveOperatorNode: unsupported operator or function "'+e+'"'),this.createOperand(y.UNSUPPORTED);if(n&&!F(n))return this.createOperand(y.UNSUPPORTED);var i=new P,l=o.signature;l.forEach(function(e,r){var t=o.operands[r],r=g(a)&&e.preferMat?m.MAT:e.contextType,e=g(r)&&e.forwardDim;i.push(this.resolveNode.bind(this,t,r,e?n:null))},this);var u=l.map(function(e,r){return"any:lazy"===e.typeSpec?null:i.resolve(r)});if(!n&&v(s.retType)){var t=g(a);if(t||s.allValType){try{u.forEach(function(e,r){e&&(t?v(l[r].baseType)&&!v(e.type):g(e.type))&&(e=e.getDimension({errorCode:c.VALUE}),n=w.boundary(n,e))})}catch(e){if(p(e))return this.createOperand(e);throw e}if(n){if(!F(n))return this.createOperand(y.UNSUPPORTED);a=m.MAT}}}var r=D.takeTime(s.key,function(){try{this.formulaContext.pushOperandResolver(i,a,n);var t=this.getOperand(s,l,u,0,0),e=s.retType;return g(e)&&v(t.type)&&(t=this.createOperand(new k(t.getRawValue()))),O(e)||e===t.type||R(e)&&v(t.type)&&p(t.getRawValue())||v(e)&&g(a)&&g(t.type)||M("InterpreterInstance.resolveOperatorNode(): "+s.key+": operator result type does not match operator return type"),n&&v(t.type)&&(D.info("  expand scalar result to "+n+" matrix"),e=new k(n.rows,n.cols,function(e,r){if(0===e&&0===r)return t.getRawValue();r=this.getOperand(s,l,u,e,r);if(v(r.type))return r.getRawValue();M("InterpreterInstance.resolveOperatorNode(): invalid matrix element type")},this),t=this.createOperand(e)),t}finally{this.formulaContext.popOperandResolver()}}.bind(this)),e=s.format&&!g(a)?this.getParsedFormat(i,s.format):null;return e?this.createOperand(r,{format:e}):r},z.prototype.resolveNode=function(e,r,t){t=e.operands?this.resolveOperatorNode(e,r,t):this.resolveOperandNode(e,r,t);return D.log("< result of "+e+": "+t),t};s=i.extend(function(e){i.call(this),this.docModel=e,this.COMPARE_OPTIONS={withCase:e.docApp.isODF(),nullMode:E.CONVERT}});return s.prototype.equalScalars=function(e,r){return x(e,r,this.COMPARE_OPTIONS)},s.prototype.compareScalars=function(e,r){return A(e,r,this.COMPARE_OPTIONS)},s.prototype.createWarnResult=function(e,r){var t=T(r)?r.value:r;return j(e,"warn",r.key,t)},s.prototype.createErrorResult=function(e,r){return j(e,"error",r,c.NA)},s.prototype.interpretTokens=D.profileMethod("$badge{FormulaInterpreter} interpretTokens",function(r,e,t,o,a){D.log("contextType="+r);var n=new z(this.docModel,e,t,o,a);try{var s=g(r)?l.getOption(a,"matrixRange",null):null,s=s?w.createFromRange(s):null,i=n.getResult(r,s);return T(i.value)?this.createWarnResult(r,i.value):(i.type="valid",D.info(function(){return"result: type=valid value="+N(i.value)+" format="+i.format+" url="+i.url}),i)}catch(e){if(p(e))return this.createWarnResult(r,e);if(e instanceof C)return D.info('  error="'+e.message+'"'),this.createErrorResult(r,e.code);throw e}finally{n.destroy()}}),s});