var __extends=this&&this.__extends||function(){var o=function(e,t){return(o=Object.setPrototypeOf||{__proto__:[]}instanceof Array&&function(e,t){e.__proto__=t}||function(e,t){for(var r in t)Object.prototype.hasOwnProperty.call(t,r)&&(e[r]=t[r])})(e,t)};return function(e,t){function r(){this.constructor=e}o(e,t),e.prototype=null===t?Object.create(t):(r.prototype=t.prototype,new r)}}();define("io.ox/office/spreadsheet/model/formula/parser/formulagrammar",["require","exports","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/object/dobject","io.ox/office/baseframework/utils/apputils","io.ox/office/editframework/model/formatter/autoformat","io.ox/office/spreadsheet/utils/scalar","io.ox/office/spreadsheet/utils/address","io.ox/office/spreadsheet/utils/range","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/formula/utils/types","io.ox/office/spreadsheet/model/formula/utils/logger","io.ox/office/spreadsheet/model/formula/utils/sheetref","io.ox/office/spreadsheet/model/formula/utils/cellref","io.ox/office/spreadsheet/model/formula/parser/referencegrammar","io.ox/office/spreadsheet/model/formula/parser/formulaparser","io.ox/office/spreadsheet/model/formula/parser/rangelistparser"],function(e,t,n,r,o,T,a,i,s,E,R,S,l,p,f,x,u,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FormulaGrammar=void 0;var h="_xludf.",m=new r.TMap;function g(e){return e instanceof p.SheetRef?e:null==e?void 0:e.r1}function d(e){return e instanceof p.SheetRef||null==e?void 0:e.r2}function N(e){return new RegExp("^(?:"+e[0]+"(\\d*))?(?:"+e[1]+"(\\d*))?$","i")}var y,o=(y=o.DObject,__extends(A,y),A.get=function(e,t){var r=e.getResource(t),o=t!==S.GrammarType.OP&&t!==S.GrammarType.OP_OOX,a=t===S.GrammarType.UI_RC||t===S.GrammarType.EN_RC,t=r.uid+":"+(o?1:0)+(a?1:0);return m.getOrCreate(t,function(){return new A(r,o,a)})},A.prototype.isReservedSymbol=function(e,t){return this._isBooleanLiteral(t)||this._isReferenceSymbol(e,t)},A.prototype.isSimpleSheetName=function(e,t,r){t=t.match(this.SIMPLE_EXT_SHEET_NAME_RE);return!!t&&(!(t[1]&&(null==r||!r.external))&&(!(t[3]&&(null==r||!r.range))&&(!this.isReservedSymbol(e,t[2])&&(!t[3]||!this.isReservedSymbol(e,t[3])))))},A.prototype.validateNameLabel=function(e,t){return 0===t.length?"name:empty":!this.VALID_NAME_RE.test(t)||!this.odf&&this._isBooleanLiteral(t)?"name:invalid":this._isReferenceSymbol(e,t)?"name:address":""},A.prototype.formatScalar=function(e){switch(i.getScalarType(e)){case i.ScalarTypeId.NUMBER:var t=e;return isFinite(t)?n.isZero(t)?"0":a.autoFormatNumber(t,{dec:this.DEC,stdLen:R.MAX_LENGTH_STANDARD_EDIT}).text:this.getErrorName(i.ErrorCode.NUM);case i.ScalarTypeId.STRING:return'"'+e.replace(/"/g,'""')+'"';case i.ScalarTypeId.BOOLEAN:return this.getBooleanName(e);case i.ScalarTypeId.ERROR:return this.getErrorName(e)||this.NA_ERROR;case i.ScalarTypeId.NULL:return""}return l.formulaLogger.warn("$badge{FormulaGrammar} formatScalar: unsupported scalar value type"),""},A.prototype.formatGenericRange=function(e,t,r,o){if(this.REF_SYNTAX===S.RefSyntaxType.OF){var a=g(o),n=this._generateOFSheetPrefix(e,a);if(null===n)return this.REF_ERROR;a=d(o),a=a?this._generateOFSheetPrefix(e,a):"";if(null===a)return this.REF_ERROR;n=n+t;return(a||r)&&(n+=":"+a+(r||t)),n}o=this._generateSheetRangePrefix(e,o);return null===o?this.REF_ERROR:""+o+t+(r?":"+r:"")},A.prototype.formatReference=function(e,t,r,o){var a=this.RC_STYLE,n=this.PREFIX_CHARS,i=this.REF_ERROR;if(!this.UI&&a)return l.formulaLogger.error("$badge{FormulaGrammar} formatReference: R1C1 notation not supported in native grammar"),this.NA_ERROR;var s=r instanceof f.CellRef?r:null==r?void 0:r.r1,r=r instanceof f.CellRef||null==r?void 0:r.r2;if(this.REF_SYNTAX===S.RefSyntaxType.OF){if(!s)return"["+i+"]";var R=s.refText();g(o)||(R="."+R);var p="";return r&&(p=r.refText(),d(o)||(p="."+p)),"["+this.formatGenericRange(e,R,p,o)+"]"}if(!s)return this.odf?i:this.formatGenericRange(e,i,null,o);R=E.Range.createFromAddresses(s.toAddress(),null==r?void 0:r.toAddress()),p="",i="";return s.absCol&&null!=r&&r.absCol&&e.addressFactory.isRowRange(R)?(p=a?s.rowTextRC(n,t):s.rowText(),a&&R.singleRow()&&s.absRow===r.absRow||(i=a?r.rowTextRC(n,t):r.rowText())):s.absRow&&null!=r&&r.absRow&&e.addressFactory.isColRange(R)?(p=a?s.colTextRC(n,t):s.colText(),a&&R.singleCol()&&s.absCol===r.absCol||(i=a?r.colTextRC(n,t):r.colText())):(p=a?s.refTextRC(n,t):s.refText(),r&&(i=a?r.refTextRC(n,t):r.refText())),this.formatGenericRange(e,p,i,o)},A.prototype.formatName=function(e,t,r,o){if(this.odf&&(r||o))return this.NA_ERROR;o=this._generateSheetRangePrefix(e,r,o);return null===o?this.REF_ERROR:o+t},A.prototype.formatMacro=function(e,t,r,o){if(this.odf&&(r||o))return this.NA_ERROR;var a=h.length<t.length&&n.stringStartsWith(t.toLowerCase(),h);return this.UI&&a?t=t.substr(h.length):this.UI||a||!this.functionMap.getKey(t,!1)||(t=h+t),this.formatName(e,t,r,o)},A.prototype.getBooleanName=function(e){return this.booleanMap.getName(e?"t":"f",this.UI)},A.prototype.getBooleanValue=function(e){e=this.booleanMap.getKey(e,this.UI);return e?"t"===e:null},A.prototype.getErrorName=function(e){return this.errorMap.getName(e.key,this.UI)},A.prototype.getErrorCode=function(e){e=this.errorMap.getKey(e,this.UI);return e?i.ErrorCode[e]:null},A.prototype.getOperatorName=function(e){return this.operatorMap.getName(e,this.UI)},A.prototype.getOperatorKey=function(e){return this.operatorMap.getKey(e,this.UI)},A.prototype.getFunctionName=function(e){return this.functionMap.getName(e,this.UI)},A.prototype.getFunctionKey=function(e){return this.functionMap.getKey(e,this.UI)},A.prototype.getTableRegionName=function(e){return this.regionMap.getName(e,this.UI)},A.prototype.getTableRegionKey=function(e){return this.regionMap.getKey(e,this.UI)},A.prototype.isSimpleTableColumn=function(e){return this.SIMPLE_TABLE_COLUMN_NAME_RE.test(e)},A.prototype.decodeTableColumn=function(e){return e.replace(/'(.)/g,"$1")},A.prototype.encodeTableColumn=function(e){return e.replace(this.TABLE_COL_ESCAPE_RE,"'$&")},A.prototype.generateAutoFormula=function(e,t,r,o){var a=this.getFunctionName(t);if(!r)return a+"()";t=new f.CellRef(r.start[0],r.start[1],!1,!1),r=r.single()?void 0:new f.CellRef(r.end[0],r.end[1],!1,!1);return a+"("+this.formatReference(e,o,{r1:t,r2:r})+")"},A.prototype.parseFormula=function(e,t,r,o){return(this._formulaParser||(this._formulaParser=u.createFormulaParser(this))).parse(e,t,r,o)},A.prototype.parseRangeList=function(e,t,r){return(this._rangeListParser||(this._rangeListParser=c.createRangeListParser(this))).parse(e,t,r)},A.prototype.formatRangeList=function(e,t,r){return(this._rangeListParser||(this._rangeListParser=c.createRangeListParser(this))).format(e,t,r)},A.prototype._isBooleanLiteral=function(e){return null!==this.booleanMap.getKey(e,this.UI)},A.prototype._isReferenceSymbol=function(e,t){if(0===t.length)return!1;if(e.addressFactory.parseAddress(t))return!0;var r=t.match(this.SIMPLE_RCREF_RE)||this.SIMPLE_RCREF_EN_RE&&t.match(this.SIMPLE_RCREF_EN_RE);if(!r)return!1;t=r[1]?parseInt(r[1],10)-1:0,r=r[2]?parseInt(r[2],10)-1:0;return e.addressFactory.isValidAddress(new s.Address(r,t))},A.prototype._encodeAbsSheetName=function(e,t,r){return t&&!this.isSimpleSheetName(e,t)&&(t=p.encodeComplexSheetName(t)),(r&&t?"$":"")+t},A.prototype._generateSheetRangePrefix=function(e,t,r){var o=r?"["+r.index+"]":"",a=g(t);if(a){var n=a.resolve(e,r);if(null===n)return null;t=d(t),r=t&&!a.equals(t)?t.resolve(e,r):"";if(null===r)return null;o+=this.odf?this._encodeAbsSheetName(e,n,a.abs):n,r&&(o+=":"+(this.odf?this._encodeAbsSheetName(e,r,t.abs):r)),this.odf||this.isSimpleSheetName(e,n)&&(!r||this.isSimpleSheetName(e,r))||(o=p.encodeComplexSheetName(o))}return o?o+"!":""},A.prototype._generateOFSheetPrefix=function(e,t){if(!t)return"";var r=t.resolve(e);return r?this._encodeAbsSheetName(e,r,t.abs)+".":null},A);function A(e,t,r){var o=y.call(this)||this,a=o.odf=e.fileFormat===T.FileFormatType.ODF;o.UI=t,o.REF_SYNTAX=a?t?S.RefSyntaxType.ODF_UI:S.RefSyntaxType.OF:S.RefSyntaxType.OOX,o.RC_STYLE=r,o.DEC=e.getDec(t);var n=o.SEP=e.getSeparator(t);o.TABLE_SEP=n,o.MAT_OPEN="{",o.MAT_ROW=a||t?"|":";",o.MAT_COL=a||t?";":",",o.MAT_CLOSE="}",o.PREFIX_CHARS=e.getRCPrefixChars(t);var i=o.booleanMap=e.booleanMap,s=o.errorMap=e.errorMap,R=o.regionMap=e.regionMap,p=o.operatorMap=e.operatorMap;o.functionMap=e.functionMap,o.ISECT_SPACE=" "===p.getName("isect",t),o.NA_ERROR=s.getName("NA",t),o.REF_ERROR=s.getName("REF",t),o.refGrammar=x.createReferenceGrammar(e,t,r);var E=o.refGrammar.sheetConfig,l=E.PATTERNS,f=l.TERMINATE_REF,u=l.NAME_INNER_CHAR_CLASS,c=l.DEFINED_NAME,h=_.escapeRegExp(n),m=_.escapeRegExp(o.TABLE_SEP),g="\\[\\]'#"+(t?"@":""),d="\\x00-\\x2B\\x2D-\\x2F\\x3A-\\x40\\x5B-\\x60\\x7B\\x7D\\x7E"+(","===n?n:""),A="([^"+d+"]+)",a="((?:[^"+g+"]|'.)+)",r="(?:"+A+"|\\["+a+"\\])",l="(["+x.WHITESPACE_CHARS+"]*)",n="(?:(["+x.WHITESPACE_CHARS+"]+)(?=\\[|\\]|"+m+(t?"|@":"")+"|$))?";o.SIMPLE_RCREF_RE=N(o.PREFIX_CHARS);e=e.getRCPrefixChars(!1);return o.SIMPLE_RCREF_EN_RE=o.PREFIX_CHARS!==e?N(e):void 0,o.SIMPLE_EXT_SHEET_NAME_RE=E.RE.SIMPLE_EXT_SHEET_NAME,o.VALID_NAME_RE=new RegExp("^"+c+"$","i"),o.TABLE_COL_ESCAPE_RE=new RegExp("["+g+"]","g"),o.SIMPLE_TABLE_COLUMN_NAME_RE=new RegExp("^[^"+d+"]+$","i"),o.RE={STRING_LIT:/^(".*?")+/,BOOLEAN_LIT:new RegExp("^"+i.getAllPattern(t)+f,"i"),ERROR_LIT:new RegExp("^"+s.getAllPattern(t)+"(?!"+u+")","i"),FRACTION_LIT:/^(\d+) (\d+)\/(0*[1-9]\d*)/,MATRIX_OPEN:new RegExp("^"+_.escapeRegExp(o.MAT_OPEN)),MATRIX_COL_SEPARATOR:new RegExp("^"+_.escapeRegExp(o.MAT_COL)),MATRIX_ROW_SEPARATOR:new RegExp("^"+_.escapeRegExp(o.MAT_ROW)),MATRIX_CLOSE:new RegExp("^"+_.escapeRegExp(o.MAT_CLOSE)),WHITESPACE:new RegExp("^["+x.WHITESPACE_CHARS+"]+"),SEPARATOR:new RegExp("^"+h),OPERATOR:new RegExp("^"+p.getAllPattern(t)),OPEN:/^\(/,CLOSE:/^\)/,TABLE_OPEN:new RegExp("^\\["+n),TABLE_CLOSE:new RegExp("^"+l+"(\\]|$)"),TABLE_SEPARATOR:new RegExp("^"+l+m+n),TABLE_SINGLE_REGION_NAME:new RegExp("^"+R.getAllPattern(t)+"(?=\\])","i"),TABLE_SINGLE_COLUMN_NAME:new RegExp("^"+a+"(?=\\])","i"),TABLE_SIMPLE_COLUMN_NAME:new RegExp("^"+A,"i"),TABLE_REGION_REF:new RegExp("^\\["+R.getAllPattern(t)+"\\]","i"),TABLE_COLUMN_REF:new RegExp("^\\["+a+"\\]","i"),TABLE_MIXED_COLUMN_REF:new RegExp("^"+l+r,"i"),TABLE_COLUMN_RANGE_REF:new RegExp("^\\["+a+"\\]:\\["+a+"\\]","i"),TABLE_MIXED_COLUMN_RANGE_REF:new RegExp("^"+l+r+":"+r,"i"),TABLE_THISROW_REF:/^@/},o}t.FormulaGrammar=o});