define("io.ox/office/spreadsheet/model/model",["exports","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/locale/locale","io.ox/office/textframework/model/editor","io.ox/office/textframework/model/listhandlermixin","io.ox/office/textframework/model/updatelistsmixin","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/model/modelpropset","io.ox/office/spreadsheet/model/addressfactory","io.ox/office/spreadsheet/model/operation/context","io.ox/office/spreadsheet/model/operation/generator","io.ox/office/spreadsheet/model/operation/builder","io.ox/office/spreadsheet/model/numberformatter","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/sortlistcollection","io.ox/office/spreadsheet/model/sheetcollection","io.ox/office/spreadsheet/model/modelattributesmixin","io.ox/office/spreadsheet/model/modelsnapshot","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/parser/formularesource","io.ox/office/spreadsheet/model/formula/parser/formulagrammar","io.ox/office/spreadsheet/model/formula/interpret/formulacompiler","io.ox/office/spreadsheet/model/formula/interpret/formulainterpreter","io.ox/office/spreadsheet/model/formula/deps/dependencymanager"],function(e,h,t,o,n,r,c,u,d,p,i,a,s,l,m,f,g,E,C,S,y,T,O,R,A,I,M,v){"use strict";var N=t.isBoolean,b=t.isEmpty,D=t.toNumber,w=t.toBoolean,x=t.getDict,L=t.newRejected,F=o.clamp,t=o.createDict,G=o.fastChain,U=o.arrayForEachReverse,H=n.someInSource,k=n.TArray,V=n.UidSet,P=r.LOCALE_DATA,B=i.Range3DArray,K=i.modelLogger,W=i.mapKey,$=i.inverseSortVector,X=a.ModelPropertySet,z=s.AddressFactory,Y=l.SheetOperationContext,j=g.NumberFormatter,J=E.NameCollection,q=S.SheetCollection,Q=T.DocumentSnapshot,Z=m.SheetOperationGenerator,ee=f.OperationBuilder,te=O.GrammarType,oe=R.FormulaResourceFactory,ne=A.FormulaGrammar,re=I.FormulaCompiler;e.SHEET_TO_DOCUMENT_INJECT_EVENTS=S.SHEET_TO_DOCUMENT_INJECT_EVENTS,e.SHEET_TO_DOCUMENT_INSERT_EVENTS=S.SHEET_TO_DOCUMENT_INSERT_EVENTS;var ie=t([p.SET_ATTRIBUTES,p.DELETE,p.MOVE,p.TEXT_INSERT,p.TAB_INSERT,p.HARDBREAK_INSERT,p.PARA_INSERT,p.PARA_SPLIT,p.PARA_MERGE,p.INSERT_LIST,p.DELETE_LIST],!0);function ae(e){e={model:e,name:e.getName(),sheet:e.sheetModel.getIndex(),range:e.getRange(),header:e.hasHeaderRow(),footer:e.hasFooterRow()};return Object.defineProperty(e,"columns",{get:function(){return this.model.getColumnKeys()},enumerable:!0}),e}var se=e.SpreadsheetModel=c.extend(K.profileMethod("$badge{SpreadsheetModel} constructor",function(n,t){c.call(this,n,{contextClass:Y,defaultStyleFamily:"cell",slideMode:!0,disableRedoWithOT:!0}),u.call(this,n),d.call(this,n);var a=this;function r(){if(n.isODF())return null;var e=a.getDocumentAttribute("calcOnLoad"),t=a.dependencyManager.needsCalcOnLoad();return e===t?null:t}this.propSet=this.member(new X(this));var i=this.debounce(function(){var e=a.getSelectionState();e&&n.updateUserData({sheet:e.sheet,ranges:e.selection.ranges.toOpStr(),drawings:e.selection.drawings})},{delay:250,contextMsg:"SpreadsheetModel.sendActiveSelectionDebounced"});function e(e,n,r,t){var i=t&&t.allowDoc;return a.registerOperationHandler(e,function(e){var t=i&&!e.has("sheet"),o=t?-1:e.getInt("sheet"),o=t?a:a.getSheetModel(o);e.ensure(o,"missing sheet"),o[n][r](e)})}function o(e,n){return a.registerOperationHandler(e,function(e){var t=e.getPos("start");e.ensure(2<=t.length,"invalid drawing start position");var o=a.getSheetModel(t[0]);return e.ensure(o,"invalid sheet index"),n.call(a,e,o.drawingCollection,t.slice(1))})}function s(e,n){o(e,function(e,t,o){t[n](e,o)})}function l(e,n,t){var r=t&&t.type;o(e,function(e,t,o){o=t.getModelInfo(o);e.ensure(o,"invalid drawing position"),e.ensure(!r||r===o.model.drawingType,"invalid drawing type"),e.ensure(!o.remaining,"invalid drawing start position"),o.model[n](e)})}this.postProcessImport=function(){if(0===this.sheetCollection.getSheetCount())return L();this.cellStyles.createMissingStyles();var e=this.sheetCollection.createModelIterator();return this.asyncForEach(e,function(e){return e.postProcessImport()})},this.getSelectionState=function(){var e=this.getActiveSheet(),t=this.getSheetModel(e);return t&&{sheet:e,selection:t.getSelection()}},this.setSelectionState=function(e){var t=this.getSheetModel(e.sheet);t?(this.setActiveSheet(e.sheet),t.setSelection(e.selection)):K.warn("$badge{SpreadsheetModel} setSelectionState: invalid sheet index: "+e.sheet)},this.createReloadSettings=function(){return{recalcFormulas:this.dependencyManager.needsCalcOnLoad(),docAttrs:this.propSet.all(),sheetAttrsArray:this.createSheetIterator().map(function(e){return e.getChangedViewAttributes()})}},this.getFormulaGrammar=function(e){return e===te.UI?this.formulaGrammarUI:ne.get(t,e)},this.getFormulaGrammarUI=function(e){return N(e)||(e=this.propSet.get("rcStyle")),ne.get(t,e?te.UI_RC:te.UI_A1)},this.parseRangeList=function(e,t,o){return this.getFormulaGrammar(e).parseRangeList(this,t,o)},this.formatRangeList=function(e,t,o){return this.getFormulaGrammar(e).formatRangeList(this,t,o)},this.getMaxCol=function(){return this.addressFactory.maxCol},this.getMaxRow=function(){return this.addressFactory.maxRow},this.getMaxIndex=function(e){return this.addressFactory.getMaxIndex(e)},this.getSheetRange=function(){return this.addressFactory.getSheetRange()},this.isColRange=function(e){return this.addressFactory.isColRange(e)},this.makeColRange=function(e){return this.addressFactory.getColRange(e)},this.makeColRanges=function(e){return this.addressFactory.getColRangeList(e)},this.isRowRange=function(e){return this.addressFactory.isRowRange(e)},this.makeRowRange=function(e){return this.addressFactory.getRowRange(e)},this.makeRowRanges=function(e){return this.addressFactory.getRowRangeList(e)},this.isFullRange=function(e,t){return this.addressFactory.isFullRange(e,t)},this.makeFullRange=function(e,t){return this.addressFactory.getFullRange(e,t)},this.makeFullRanges=function(e,t){return this.addressFactory.getFullRangeList(e,t)},this.isValidAddress=function(e){return this.addressFactory.isValidAddress(e)},this.getMaxSheetNameLength=function(){return n.isOOXML()?31:65535},this.getSheetName=function(e){return this.sheetCollection.getSheetName(e)},this.getSheetIndex=function(e){return this.sheetCollection.getSheetIndex(e)},this.getSheetModel=function(e){return this.sheetCollection.getSheetModel(e)},this.getSheetCount=function(e){return this.sheetCollection.getSheetCount(e)},this.createSheetIterator=function(e){return this.sheetCollection.createModelIterator(e)},this.getActiveSheet=function(){return this.propSet.get("activeSheet")},this.setActiveSheet=function(e){K.takeTime("$badge{SpreadsheetModel} activating sheet "+e,function(){a.propSet.set("activeSheet",e)})},this.hasUnsavedComments=function(){return this.createSheetIterator().some(function(e){return e.hasUnsavedComment()})},this.deleteUnsavedComments=function(){this.createSheetIterator().forEach(function(e){e.deleteUnsavedComment()})},this.hasName=function(e,t){return!!this.getNameModel(e,t)},this.getNameModel=function(e,t){return(null===e?this:this.getSheetModel(e)).nameCollection.getNameModel(t)},this.resolveName=function(e,t){t=this.getNameModel(e,t);return t?{model:t,sheet:e,label:t.getLabel()}:void 0},this.resolveNameModel=function(e,t){t=e.resolveName(t);return t?t.model:void 0},this.createNameIterator=function(t){var e=this.nameCollection.createModelIterator(t),o=this.createSheetIterator({supported:!0}).nestedIterator(function(e){return e.nameCollection.createModelIterator(t)});return e.chainIterator(o)},this.hasTable=function(e){return this.sheetCollection.tableModelSet.hasKey(W(e))},this.getTableModel=function(e){return this.sheetCollection.tableModelSet.get(W(e))},this.resolveTable=function(e){return this.sheetCollection.tableModelSet.with(W(e),ae)},this.resolveTableAt=function(e,t){t=this.getSheetModel(e).tableCollection.getTableModelAt(t);return t?ae(t):void 0},this.resolveTableModel=function(e){e=e.resolveTable();return e?e.model:void 0},this.createTableIterator=function(){return this.sheetCollection.tableModelSet.valueIterator()},this.getRangeContents=function(e,o){var n=h.getIntegerOption(o,"maxCount",null,1),r=[],i=0;return e=B.filter(e,function(e){return!(!this.sheetCollection.getSheetModel(e.sheet1)||!e.singleSheet())||(K.warn("$badge{SpreadsheetModel} getRangeContents: invalid sheet index in range address"),!1)},this),o=_.clone(o),H(e,function(e){var t=this.getSheetModel(e.sheet1).cellCollection,e=e.toRange(),e=t.getRangeContents(e,o);if(r=r.concat(e),i+=e.count,n===i)return!0;n&&(o.maxCount-=e.count)},this),r.count=i,r},this.createAndApplySheetOperations=K.profileMethod("$badge{SpreadsheetModel} createAndApplySheetOperations",function(t,e){e=_.extend({preventSelectionChange:!0},e,{generator:new Z(this,e)}),n.isOTEnabled()&&(e.afterApplyHandler=function(e){e.setUserData(Q.fromModel(this),{undo:!0})}),this.setBlockKeyboardEvent(!0);e=this.createAndApplyOperations(function(e){return n.isOTEnabled()&&e.setUserData(Q.fromModel(this)),t.call(this,e)},e);return this.finally(e,function(){this.setBlockKeyboardEvent(!1)}),e}),this.buildOperations=function(t,e){var o=new ee(this);o.assertCause(!(e&&e.applyImmediately),"operation",'unexpected "applyImmediately" mode'),e=_.extend({preventSelectionChange:!0},e,{generator:new Z(this,e)}),n.isOTEnabled()&&(e.afterApplyHandler=function(e){e.setUserData(Q.fromModel(this),{undo:!0})}),this.setBlockKeyboardEvent(!0);e=this.createAndApplyOperations(function(e){return n.isOTEnabled()&&e.setUserData(Q.fromModel(this)),G(t.bind(this,o),function(){return o.flushOperations(e)})},e);return this.finally(e,function(){o.destroy(),this.setBlockKeyboardEvent(!1)}),e},this.generateUpdateTaskOperations=K.profileMethod("$badge{SpreadsheetModel} generateUpdateTaskOperations",function(e,t){return G(function(){return a.nameCollection.generateUpdateTaskOperations(e.headGenerator,t)},function(){return a.sheetCollection.generateUpdateTaskOperations(e,t)})}),this.hasUnsavedPendingChanges=function(){if(N(r()))return!0;var t=this.sheetAttrPool.getRegisteredAttributes("sheet");return this.createSheetIterator().some(function(e){var e=e.getChangedViewAttributes(),n=!1;return t.forEachSupported(e,function(e,t,o){n=n||o.sendAlways}),n})},this.generatePendingChangesOperations=function(o){var e={},t=r();N(t)&&(e.calcOnLoad=t);t=this.getActiveSheet();t!==this.getDocumentAttribute("activeSheet")&&(e.activeSheet=t),b(e)||o.generateChangeConfigOperation(e),this.createSheetIterator().forEach(function(e){var t=e.getChangedViewAttributes();b(t)||(o.sheet=e.getIndex(),e.generateChangeOperations(o,{sheet:t}))})},this.addressFactory=new z(1,1),this.numberFormatter=this.member(new j(this)),this.formulaResource=t.getResource(te.UI),this.formulaGrammarOP=this.getFormulaGrammar(te.OP),this.formulaGrammarUI=this.getFormulaGrammarUI(),this.formulaCompiler=this.member(new re(this)),this.formulaInterpreter=this.member(new M(this)),this.nameCollection=this.member(new J(this)),this.sortListCollection=this.member(new C(this)),this.sheetCollection=this.member(new q(this)),this.dependencyManager=this.member(new v(this)),y.call(this),e(p.CHANGE_CELLS,"cellCollection","applyChangeCellsOperation"),e(p.MOVE_CELLS,"cellCollection","applyMoveCellsOperation"),e(p.MERGE_CELLS,"mergeCollection","applyMergeCellsOperation"),e(p.INSERT_HYPERLINK,"hlinkCollection","applyInsertOperation"),e(p.DELETE_HYPERLINK,"hlinkCollection","applyDeleteOperation"),e(p.INSERT_COLUMNS,"colCollection","applyInsertOperation"),e(p.DELETE_COLUMNS,"colCollection","applyDeleteOperation"),e(p.CHANGE_COLUMNS,"colCollection","applyChangeOperation"),e(p.INSERT_ROWS,"rowCollection","applyInsertOperation"),e(p.DELETE_ROWS,"rowCollection","applyDeleteOperation"),e(p.CHANGE_ROWS,"rowCollection","applyChangeOperation"),e(p.INSERT_NAME,"nameCollection","applyInsertOperation",{allowDoc:!0}),e(p.DELETE_NAME,"nameCollection","applyDeleteOperation",{allowDoc:!0}),e(p.CHANGE_NAME,"nameCollection","applyChangeOperation",{allowDoc:!0}),e(p.INSERT_TABLE,"tableCollection","applyInsertOperation"),e(p.DELETE_TABLE,"tableCollection","applyDeleteOperation"),e(p.CHANGE_TABLE,"tableCollection","applyChangeOperation"),e(p.CHANGE_TABLE_COLUMN,"tableCollection","applyChangeColumnOperation"),e(p.INSERT_DVRULE,"dvRuleCollection","applyInsertOperation"),e(p.DELETE_DVRULE,"dvRuleCollection","applyDeleteOperation"),e(p.CHANGE_DVRULE,"dvRuleCollection","applyChangeOperation"),e(p.INSERT_CFRULE,"cfRuleCollection","applyInsertOperation"),e(p.DELETE_CFRULE,"cfRuleCollection","applyDeleteOperation"),e(p.CHANGE_CFRULE,"cfRuleCollection","applyChangeOperation"),e(p.INSERT_NOTE,"noteCollection","applyInsertNoteOperation"),e(p.DELETE_NOTE,"noteCollection","applyDeleteNoteOperation"),e(p.CHANGE_NOTE,"noteCollection","applyChangeNoteOperation"),e(p.MOVE_NOTES,"noteCollection","applyMoveNotesOperation"),e(p.INSERT_COMMENT,"commentCollection","applyInsertCommentOperation"),e(p.DELETE_COMMENT,"commentCollection","applyDeleteCommentOperation"),e(p.CHANGE_COMMENT,"commentCollection","applyChangeCommentOperation"),e(p.MOVE_COMMENTS,"commentCollection","applyMoveCommentsOperation"),s(p.INSERT_DRAWING,"applyInsertDrawingOperation"),s(p.DELETE_DRAWING,"applyDeleteDrawingOperation"),s(p.MOVE_DRAWING,"applyMoveDrawingOperation"),l(p.CHANGE_DRAWING,"applyChangeOperation"),l(p.INSERT_CHART_SERIES,"applyInsertSeriesOperation",{type:"chart"}),l(p.DELETE_CHART_SERIES,"applyDeleteSeriesOperation",{type:"chart"}),l(p.CHANGE_CHART_SERIES,"applyChangeSeriesOperation",{type:"chart"}),l(p.DELETE_CHART_AXIS,"applyDeleteAxisOperation",{type:"chart"}),l(p.CHANGE_CHART_AXIS,"applyChangeAxisOperation",{type:"chart"}),l(p.CHANGE_CHART_GRID,"applyChangeGridOperation",{type:"chart"}),l(p.CHANGE_CHART_TITLE,"applyChangeTitleOperation",{type:"chart"}),l(p.CHANGE_CHART_LEGEND,"applyChangeLegendOperation",{type:"chart"}),this.waitForImport(function(){var e,t,o=this.sheetCollection.getSheetCount();0!==o&&(this.createSheetIterator().forEach(function(e){e.initializePropSet()}),t=x(n.getLaunchOptions(),"docAttrs",!0),e=D(t.activeSheet,this.getDocumentAttribute("activeSheet")),0<=(o=this.sheetCollection.findVisibleSheet(F(e,0,o-1)))&&this.setActiveSheet(o),t=w(t.rcStyle,w(this.getDocumentAttribute("rcStyle"),!1)),this.propSet.set("rcStyle",t))},this),this.forwardEvents(this.sheetCollection),this.forwardEvents(this.nameCollection,{transformFn:function(e){return[e,null].concat(_.rest(arguments))}}),this.addressFactory.updateSheetSize(this.getDocumentAttribute("cols"),this.getDocumentAttribute("rows")),this.on("change:attributes",function(e,t){this.addressFactory.updateSheetSize(t.cols,t.rows)}),this.on("change:sheetattrs",function(e,t){var o=this.getActiveSheet();t!==o||this.getSheetModel(t).isVisible()||0<=(o=this.sheetCollection.findVisibleSheet(o))&&this.setActiveSheet(o)}),this.propSet.onProp("activeSheet",i),this.propSet.onProp("rcStyle",function(e){this.formulaGrammarUI=this.getFormulaGrammarUI(e),this.trigger("change:locale")}),this.on("change:sheetprops",function(e,t,o){"selection"in o&&t===this.getActiveSheet()&&i()}),this.listenTo(P.changeHook,function(){oe.create(n.getFileFormat(),P).then(function(e){t=e,a.formulaResource=t.getResource(te.UI),a.formulaGrammarOP=a.getFormulaGrammar(te.OP),a.formulaGrammarUI=a.getFormulaGrammarUI(),a.trigger("change:locale")})}),this.on("operations:success",function(e,t){var n,r;t.some(function(e){return e.name in ie})&&(n=this.createSheetIterator().appendTo(new k),r=new V,U(t,function(e){if(e.name in ie){var t=e.start;if(!_.isArray(t)||t.length<3)return;var o=n[t[0]];if(!o)return;t=o.drawingCollection.getModelInfo(t.slice(1));return t&&t.remaining?void r.insert(t.model):void 0}switch(e.name){case p.INSERT_SHEET:n.deleteAt(e.sheet);break;case p.DELETE_SHEET:n.insertAt(e.sheet,null);break;case p.MOVE_SHEET:n.insertAt(e.sheet,n.deleteAt(e.to));break;case p.MOVE_SHEETS:n.permute($(e.sheets));break;case p.COPY_SHEET:n.deleteAt(e.to)}}),r.forEach(function(e){e.parentCollection.trigger("change:drawing:text",e)}))}),this.listenTo(this.getNode()[0],"mousedown touchstart",function(){this.setActiveMouseDownEvent(!0)}),this.registerDestructor(function(){this.dependencyManager.disconnect()})}));se.create=K.profileMethod("$badge{SpreadsheetModel} create",function(t){return oe.create(t.getFileFormat(),P).then(function(e){return new se(t,e)})})});