define("io.ox/office/spreadsheet/model/sheetmodel",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/dom","io.ox/office/editframework/utils/color","io.ox/office/editframework/utils/otutils","io.ox/office/editframework/model/attributedmodel","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/paneutils","io.ox/office/spreadsheet/utils/sheetselection","io.ox/office/spreadsheet/model/operation/generator","io.ox/office/spreadsheet/model/sheetpropset","io.ox/office/spreadsheet/model/addresstransformer","io.ox/office/spreadsheet/model/namecollection","io.ox/office/spreadsheet/model/colrowcollection","io.ox/office/spreadsheet/model/cellcollection","io.ox/office/spreadsheet/model/mergecollection","io.ox/office/spreadsheet/model/hlinkcollection","io.ox/office/spreadsheet/model/tablecollection","io.ox/office/spreadsheet/model/dvrulecollection","io.ox/office/spreadsheet/model/cfrulecollection","io.ox/office/spreadsheet/model/drawing/drawingcollection","io.ox/office/spreadsheet/model/drawing/notecollection","io.ox/office/spreadsheet/model/drawing/commentcollection","io.ox/office/spreadsheet/model/formula/formulautils","io.ox/office/spreadsheet/model/formula/tokenarray","io.ox/office/spreadsheet/model/formula/parser/updatetask"],function(e,t,o,i,n,r,s,g,d,f,l,a,c,h,p,u,m,C,v,S,w,R,T,x,y,H,O,k,b){"use strict";var I=t.isDict,P=t.toNumber,M=t.toString,A=t.toBoolean,E=t.toArray,z=t.toEnum,L=t.getArray,B=t.newDict,U=t.newFulfilled,F=o.filterArray,D=o.fastThen,W=o.fastChain,V=i.everyInSource,N=n.convertLengthToHmm,G=n.convertHmmToLength,Z=n.Rectangle,$=r.Color,J=s.transformPositionInsert,q=s.transformPositionDelete,K=s.transformPositionMove,j=f.ZOOM_ADJUST_FACTOR,Q=f.SheetType,X=f.SplitMode,Y=f.Address,ee=f.Interval,te=f.Range,oe=f.RangeArray,ie=f.mergeRanges,ne=f.modelLogger,re=l.PaneSide,se=l.PanePos,le=l.getNextPanePos,ae=c.SheetOperationGenerator,ce=a.SheetSelection,he=h.SheetPropertySet,pe=p.AddressTransformer,ge=u.NameCollection,de=w.TableCollection,fe=R.DVRuleCollection,ue=T.CFRuleCollection,me=y.NoteCollection,Ce=O.FormulaType,ve=k.TokenArray,Se=b.MoveCellsUpdateTask;e.SheetModel=g.extend(ne.profileMethod("$badge{SheetModel} constructor",function(s,e,t){g.call(this,s,t,{families:"sheet column row"});var c=this;this.propSet=this.member(new he(this));var l=s.addressFactory,a=0,o=0;function r(e){return oe.map(e,function(e){return l.isColRange(e)||l.isRowRange(e)?e:c.mergeCollection.expandRangeToMergedRanges(e)})}function n(e){return c.isCellType()?c.propSet.get(e?"splitWidth":"splitHeight"):0}function h(e){var t=n(e);if(0===t)return null;var o=c.propSet.get(e?"anchorLeft":"anchorTop"),i=new ee(Math.floor(o));if(c.hasFrozenSplit())return i.last=i.first+t-1,i;e=e?c.colCollection:c.rowCollection,t=e.getScrollAnchorByOffset(e.convertScrollAnchorToHmm(o)+t);return i.last=Math.floor(t),!i.single()&&t%1<.5&&--i.last,!i.single()&&.5<o%1&&(i.first+=1),i}function i(e,t){if(c.hasFrozenSplit()){var o=h(e),i=e?c.colCollection:c.rowCollection;return o?i.getIntervalPosition(o)[t?"size":"sizeHmm"]:0}e=n(e);return t?c.convertHmmToPixel(e):e}function p(e,n,r){var s=r?"anchorLeft":"anchorTop",l=r?"anchorRight":"anchorBottom",a=r?"splitWidth":"splitHeight";e[n?"some":"someReverse"](function(e){var t=c.hasFrozenSplit()?h(r):null;if(!t)return!0;var o,i={};n?(o=e.size(),e.first<t.first?(i[s]=t.first+o,i[l]=t.last+1+o):e.first<=t.last&&(i[a]=t.size()+o,i[l]=t.last+1+o)):((o=e.intersect(t))&&(i[a]=t.size()-o.size(),0===i[a]&&(i[a]=1)),e.first<t.first&&(i[s]=e.first),e.first<=t.last&&(i[l]=e.first,0===i[l]&&(i[l]=1))),0===i[a]&&((e=c.propSet.get("activePane"))!==(e=le(e,r?re.R:re.B))&&(i.activePane=e),h(!r)||(i.splitMode=X.SPLIT)),c.propSet.update(i)})}this.postProcessImport=function(){return this.cellCollection.postProcessImport()},this.applyCopySheetOperation=function(e,t){this.setAttributes(t.getExplicitAttributeSet(!0)),this.colCollection.applyCopySheetOperation(e,t.colCollection),this.rowCollection.applyCopySheetOperation(e,t.rowCollection),this.cellCollection.applyCopySheetOperation(e,t.cellCollection),this.mergeCollection.applyCopySheetOperation(e,t.mergeCollection),this.hlinkCollection.applyCopySheetOperation(e,t.hlinkCollection),this.nameCollection.applyCopySheetOperation(e,t.nameCollection),this.tableCollection.applyCopySheetOperation(e,t.tableCollection),this.dvRuleCollection.applyCopySheetOperation(e,t.dvRuleCollection),this.cfRuleCollection.applyCopySheetOperation(e,t.cfRuleCollection),this.drawingCollection.applyCopySheetOperation(e,t.drawingCollection),this.noteCollection.applyCopySheetOperation(e,t.noteCollection),this.commentCollection.applyCopySheetOperation(e,t.commentCollection),this.propSet.update(t.propSet.all())},this.getType=function(){return e},this.isSupportedType=function(){return f.isSupportedSheetType(e)},this.isWorksheet=function(){return e===Q.WORKSHEET},this.isChartsheet=function(){return e===Q.CHARTSHEET},this.isCellType=function(){return f.isCellSheetType(e)},this.getIndex=function(){return s.sheetCollection.getSheetIndexByUid(this.uid)},this.isActive=function(){return this.getIndex()===s.getActiveSheet()},this.getName=function(){return s.getSheetName(this.getIndex())},this.getSelection=function(){return this.propSet.get("selection").clone()},this.setSelection=function(e){this.propSet.set("selection",e)},this.createCellTokenArray=function(){return new ve(this,Ce.CELL)},this.isOwnMoveTask=function(e){return e instanceof Se&&this.getIndex()===e.sheet},this.hasUnsavedComment=function(){return this.commentCollection.hasUnsavedComment()},this.deleteUnsavedComment=function(){this.commentCollection.deleteUnsavedComment()},this.convertPixelToHmm=function(e){return N(e/o,"px")},this.convertHmmToPixel=function(e){return G(e*o,"px",1)},this.getEffectiveZoom=function(){return o},this.getDefaultDigitWidth=function(){return s.getDefaultDigitWidth(o)},this.getTextPadding=function(e){return s.getTextPadding(e,o)},this.getTotalCellPadding=function(e){return s.getTotalCellPadding(e,o)},this.getRowHeight=function(e){return s.getRowHeight(e,o)},this.getSheetRectangle=function(e){e=e&&e.pixel;return new Z(0,0,e?this.colCollection.getTotalSize():this.colCollection.getTotalSizeHmm(),e?this.rowCollection.getTotalSize():this.rowCollection.getTotalSizeHmm())},this.getRangeRectangle=function(e,t){var o=t&&t.pixel,t=this.colCollection.getIntervalPosition(e.colInterval()),e=this.rowCollection.getIntervalPosition(e.rowInterval());return new Z(o?t.offset:t.offsetHmm,o?e.offset:e.offsetHmm,o?t.size:t.sizeHmm,o?e.size:e.sizeHmm)},this.getCellRectangle=function(e,t){var o=t&&t.expandMerged?this.mergeCollection.getMergedRange(e,"all"):null;if(o)return this.getRangeRectangle(o,t);o=t&&t.pixel,t=this.colCollection.getEntry(e[0]),e=this.rowCollection.getEntry(e[1]);return new Z(o?t.offset:t.offsetHmm,o?e.offset:e.offsetHmm,o?t.size:t.sizeHmm,o?e.size:e.sizeHmm)},this.getAnchorRectangle=function(e){return this.getCellRectangle(e,{pixel:!0,expandMerged:!0})},this.getRangeFromRectangle=function(e,t){var o=this.colCollection.getEntryByOffset(e.left,t),i=this.rowCollection.getEntryByOffset(e.top,t),n=this.colCollection.getEntryByOffset(e.right()-1,t),t=this.rowCollection.getEntryByOffset(e.bottom()-1,t);return te.create(o.index,i.index,n.index,t.index)},this.getUsedRange=function(){var e,t,o=this.cellCollection.getUsedRange();return e=o,t=this.mergeCollection.getUsedRange(),e&&t?e.boundary(t):e||t},this.isSingleCellInRange=function(e){return e.single()||!!this.mergeCollection.getBoundingMergedRange(e)},this.getContentRangeForCell=function(e){return this.isSingleCellInRange(e)?this.cellCollection.findContentRange(e):e},this.areRangesHidden=function(e){return V(e,function(e){return this.colCollection.isIntervalHidden(e.colInterval())||this.rowCollection.isIntervalHidden(e.rowInterval())},this)},this.getVisibleRanges=function(e){return oe.map(e,function(e){var t=this.colCollection.getVisibleIntervals(e.colInterval()),e=this.rowCollection.getVisibleIntervals(e.rowInterval());return oe.createFromIntervals(t,e)},this)},this.getVisibleCell=function(e,t){var o=this.colCollection.getVisibleEntry(e[0],t),t=this.rowCollection.getVisibleEntry(e[1],t);return o&&t?new Y(o.index,t.index):null},this.shrinkRangeToVisible=function(e,t){var o="rows"!==t?this.colCollection.shrinkIntervalToVisible(e.colInterval()):e.colInterval(),e=o?"columns"!==t?this.rowCollection.shrinkIntervalToVisible(e.rowInterval()):e.rowInterval():null;return e?te.createFromIntervals(o,e):null},this.expandRangeToHidden=function(e){var t=this.colCollection.expandIntervalToHidden(e.colInterval()),e=this.rowCollection.expandIntervalToHidden(e.rowInterval());return te.createFromIntervals(t,e)},this.mergeAndShrinkRanges=function(e){return e=oe.map(e,this.expandRangeToHidden,this).merge(),oe.map(e,this.shrinkRangeToVisible,this)},this.hasColSplit=function(){return 0<n(!0)},this.hasRowSplit=function(){return 0<n(!1)},this.hasSplit=function(){return this.hasColSplit()||this.hasRowSplit()},this.getSplitMode=function(){return this.hasSplit()?this.propSet.get("splitMode"):null},this.hasDynamicSplit=function(){var e=this.getSplitMode();return e===X.SPLIT||e===X.FROZEN_SPLIT},this.hasFrozenSplit=function(){var e=this.getSplitMode();return e===X.FROZEN||e===X.FROZEN_SPLIT},this.getSplitWidthHmm=function(){return i(!0,!1)},this.getSplitHeightHmm=function(){return i(!1,!1)},this.getSplitWidth=function(){return i(!0,!0)},this.getSplitHeight=function(){return i(!1,!0)},this.getSplitColInterval=function(){return h(!0)},this.getSplitRowInterval=function(){return h(!1)},this.setDynamicSplit=function(e,t,o){var i=this.getSplitWidthHmm(),n=this.getSplitHeightHmm();o=o?_.clone(o):B(),_.extend(o,{splitMode:X.SPLIT,splitWidth:e,splitHeight:t}),0<i&&0===o.splitWidth?o.anchorRight=this.propSet.get("anchorLeft"):0===i&&0<o.splitWidth&&(o.anchorLeft=this.propSet.get("anchorRight")),0<n&&0===o.splitHeight?o.anchorBottom=this.propSet.get("anchorTop"):0===n&&0<o.splitHeight&&(o.anchorTop=this.propSet.get("anchorBottom")),this.propSet.update(o)},this.setFrozenSplit=function(e,t,o){(o=o?_.clone(o):B()).splitMode=this.hasDynamicSplit()?X.FROZEN_SPLIT:X.FROZEN,e?(o.splitWidth=e.size(),o.anchorLeft=e.first,o.anchorRight=e.last+1):o.splitWidth=0,t?(o.splitHeight=t.size(),o.anchorTop=t.first,o.anchorBottom=t.last+1):o.splitHeight=0,this.propSet.update(o)},this.clearSplit=function(){this.setDynamicSplit(0,0)},this.isVisible=function(){return this.getMergedAttributeSet(!0).sheet.visible},this.isLocked=function(){return!this.isWorksheet()||this.getMergedAttributeSet(!0).sheet.locked},this.getZoom=function(){return a},this.setZoom=function(e){this.propSet.set("zoom",e)},this.isGridVisible=function(){return this.isCellType()&&this.propSet.get("showGrid")},this.toggleGridVisibility=function(e){this.isCellType()&&this.propSet.set("showGrid",e)},this.getGridColor=function(){return $.parseJSON(this.getMergedAttributeSet(!0).sheet.gridColor)||new $("auto")},this.initializePropSet=_.once(function(){var e=this.getMergedAttributeSet(!0).sheet,t=L(s.docApp.getLaunchOptions(),"sheetAttrsArray",!0)[this.getIndex()];I(t)&&(e=_.extend({},e,t));var o=l.parseRangeList(M(e.selectedRanges)),i=P(e.activeIndex,0),n=l.parseAddress(M(e.activeCell)),t=E(e.selectedDrawings,!0).filter(d.isPosition),t=o?new ce(r(o),i,n,t):null;t?(t.active!==i&&ne.warn("$badge{SheetModel} initializePropSet: sheet="+this.getIndex()+", invalid range index in selection"),t.activeRange().containsAddress(t.address)||(ne.warn("$badge{SheetModel} initializePropSet: sheet="+this.getIndex()+", invalid active cell in selection"),t.address=t.activeRange().start.clone())):(ne.warn("$badge{SheetModel} initializePropSet: sheet="+this.getIndex()+", invalid selection"),(t=ce.createFromAddress(Y.A1)).ranges=r(t.ranges));e={selection:t,zoom:P(e.zoom,1),showGrid:A(e.showGrid,!0),splitMode:z(X,e.splitMode,X.SPLIT),splitWidth:P(e.splitWidth),splitHeight:P(e.splitHeight),activePane:z(se,e.activePane,se.BR),anchorLeft:P(e.scrollLeft),anchorRight:P(e.scrollRight),anchorTop:P(e.scrollTop),anchorBottom:P(e.scrollBottom)};0===e.splitWidth&&(e.activePane=le(e.activePane,re.R),e.anchorRight=e.anchorLeft,delete e.anchorLeft),0===e.splitHeight&&(e.activePane=le(e.activePane,re.B),e.anchorBottom=e.anchorTop,delete e.anchorTop),this.propSet.update(e)}),this.getChangedViewAttributes=function(){var o=this.getMergedAttributeSet(!0).sheet,e=this.propSet.get("selection"),i={selectedRanges:e.ranges.toOpStr(),activeIndex:e.active,activeCell:e.address.toOpStr(),selectedDrawings:e.drawings,zoom:a,showGrid:this.propSet.get("showGrid"),splitWidth:this.propSet.get("splitWidth"),splitHeight:this.propSet.get("splitHeight"),activePane:this.propSet.get("activePane"),scrollLeft:r(this.propSet.get("anchorLeft"),!0),scrollRight:r(this.propSet.get("anchorRight"),!0),scrollTop:r(this.propSet.get("anchorTop"),!1),scrollBottom:r(this.propSet.get("anchorBottom"),!1)},t=0<i.splitWidth,n=0<i.splitHeight;function r(e,t){return Math.min(Math.round(e),l.getMaxIndex(t))}t||(i.activePane=le(i.activePane,re.L),i.scrollLeft=i.scrollRight,delete i.scrollRight),n||(s.docApp.isODF()?(i.activePane=le(i.activePane,re.B),i.scrollBottom=i.scrollTop,delete i.scrollTop):(i.activePane=le(i.activePane,re.T),i.scrollTop=i.scrollBottom,delete i.scrollBottom));e=t||n?this.propSet.get("splitMode"):X.SPLIT;return(i.splitMode=e)!==X.SPLIT&&(i.activePane=t?n?se.BR:se.TR:se.BL),_.forEach(i,function(e,t){_.isEqual(o[t],e)&&delete i[t]}),i},this.refreshRanges=function(e){(e=ie(e)).empty()||this.trigger("refresh:ranges",e)},this.canRestoreDeletedRanges=function(e){return this.tableCollection.canRestoreDeletedRanges(e)&&this.drawingCollection.canRestoreDeletedRanges(e)},this.createOperationGenerator=function(e){e=new ae(s,e);return e.sheet=this.getIndex(),e},this.createAndApplyOperations=function(t,e){return s.createAndApplySheetOperations(function(e){return e.sheet=c.getIndex(),t.call(c,e)},e)},this.buildOperations=function(t,o){return D(s.buildOperations(function(e){e=e.createSheetCache(c,o);return t.call(c,e)},o),function(e){return e.sheetResults.get(c.uid)})},this.generateChangeOperations=function(e,t){var o=this.getUndoAttributeSet(t);e.generateSheetOperation(d.CHANGE_SHEET,{attrs:t}),e.generateSheetOperation(d.CHANGE_SHEET,{attrs:o},{undo:!0})},this.generateRestoreOperations=function(){return U()},this.generateUpdateTaskOperations=ne.profileMethod("$badge{SheetModel} generateUpdateTaskOperations",function(e,t){return W(function(){return c.cellCollection.generateUpdateTaskOperations(e,t)},function(){return c.mergeCollection.generateUpdateTaskOperations(e,t)},function(){return c.hlinkCollection.generateUpdateTaskOperations(e,t)},function(){return c.nameCollection.generateUpdateTaskOperations(e,t)},function(){return c.tableCollection.generateUpdateTaskOperations(e,t)},function(){return c.dvRuleCollection.generateUpdateTaskOperations(e,t)},function(){return c.cfRuleCollection.generateUpdateTaskOperations(e,t)},function(){return c.drawingCollection.generateUpdateTaskOperations(e,t)},function(){return c.noteCollection.generateUpdateTaskOperations(e,t)},function(){return c.commentCollection.generateUpdateTaskOperations(e,t)})}),this.generateRefreshAnchorOperations=ne.profileMethod("$badge{SheetModel} generateRefreshAnchorOperations",function(e){return W(function(){return c.drawingCollection.generateRefreshAnchorOperations(e)},function(){return c.noteCollection.generateRefreshAnchorOperations(e)},function(){return c.commentCollection.generateRefreshAnchorOperations(e)})}),this.generateMoveOperations=ne.profileMethod("$badge{SheetModel} generateMoveOperations",function(e,t,o){var i=!f.isVerticalDir(o);ne.trace(function(){return"intervals="+t.toString(i)+" dir="+o});var n=pe.fromIntervals(l,t,o),r=e.createSheetCache(this,{transformer:n});(i?this.colCollection:this.rowCollection).generateMoveOperations(r,n);n=new Se(r.sheet,n);return s.generateUpdateTaskOperations(e,n)}),this.generateMoveCellsOperations=ne.profileMethod("$badge{SheetModel} generateMoveCellsOperations",function(e,t,o){ne.trace(function(){return"range="+t+" dir="+o});var i=pe.fromRange(l,t,o),n=e.createSheetCache(this,{transformer:i,moveCells:!0});n.generateMoveCellsOperation(t,o),n.generateMoveCellsOperation(t,f.getReverseDirection(o),{undo:!0});i=new Se(n.sheet,i);return s.generateUpdateTaskOperations(e,i)}),this.propSet.onProp("zoom",function(e){o=(a=e)*j}),this.propSet.fireAll(),this.colCollection=this.member(new m(this,!0)),this.rowCollection=this.member(new m(this,!1)),this.cellCollection=this.member(new C(this)),this.mergeCollection=this.member(new v(this)),this.hlinkCollection=this.member(new S(this)),this.nameCollection=this.member(new ge(this)),this.tableCollection=this.member(new de(this)),this.dvRuleCollection=this.member(new fe(this)),this.cfRuleCollection=this.member(new ue(this)),this.drawingCollection=this.member(new x(this)),this.noteCollection=this.member(new me(this)),this.commentCollection=this.member(new H(this)),this.colCollection.moveHook.on(function(e){p(e.intervals,e.insert,!0)}),this.rowCollection.moveHook.on(function(e){p(e.intervals,e.insert,!1)}),this.cellCollection.moveHook.on(function(e){var t;e.external&&!e.importing&&(t=c.getSelection(),t=e.transformer.transformSheetSelection(t),c.setSelection(t))}),this.mergeCollection.changeHook.on(function(){var e=c.getSelection();e.ranges=r(e.ranges),c.setSelection(e)}),this.drawingCollection.on("insert:drawing delete:drawing move:drawing",function(e,t,o){var i=c.getSelection();if(0!==i.drawings.length){var n=t.getPosition();switch(e.type){case"insert:drawing":i.drawings.forEach(function(e){J(e,n,1)});break;case"delete:drawing":F(i.drawings,function(e){return!!q(e,n,1)});break;case"move:drawing":var r=n.slice(0,-1).concat(o),s=_.last(n);i.drawings.forEach(function(e){K(e,r,1,s)})}c.setSelection(i)}}),this.forwardHook(this.colCollection.moveHook,"move:columns"),this.forwardHook(this.colCollection.changeHook,"change:columns"),this.forwardHook(this.rowCollection.moveHook,"move:rows"),this.forwardHook(this.rowCollection.changeHook,"change:rows"),this.forwardHook(this.cellCollection.usedRangeHook,"change:usedarea",{transformFn:_.constant([])}),this.forwardHook(this.mergeCollection.usedRangeHook,"change:usedarea",{transformFn:_.constant([])}),this.forwardHook(this.cellCollection.changeHook,"change:cells"),this.forwardHook(this.cellCollection.moveHook,"move:cells"),this.forwardHook(this.mergeCollection.changeHook,"merge:cells"),this.forwardEvents(this.hlinkCollection),this.forwardEvents(this.nameCollection),this.forwardEvents(this.cfRuleCollection),this.forwardEvents(this.dvRuleCollection),this.forwardEvents(this.tableCollection),this.forwardEvents(this.drawingCollection),this.forwardEvent(this.noteCollection,"insert:drawing",{triggerType:"insert:note"}),this.forwardEvent(this.noteCollection,"delete:drawing",{triggerType:"delete:note"}),this.forwardEvent(this.noteCollection,"change:drawing",{triggerType:"change:note"}),this.forwardEvent(this.noteCollection,"change:drawing:text",{triggerType:"change:note:text"}),this.forwardEvent(this.noteCollection,"move:notes"),this.forwardEvent(this.commentCollection,"move:comments")}))});