define("io.ox/office/spreadsheet/model/tablecollection",["exports","io.ox/office/tk/utils","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/baseframework/model/modelobject","io.ox/office/editframework/model/attributedmodel","io.ox/office/spreadsheet/utils/operations","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/scalarset","io.ox/office/spreadsheet/model/cellvaluecache"],function(e,p,t,n,r,s,b,m,a,o,i){"use strict";var C=t.isString,c=t.getString,R=t.newFulfilled,v=n.createDict,l=r.DSet,A=r.TMap,d=a.MergeMode,M=a.SortDirection,E=a.Interval,O=a.Address,T=a.Range,w=a.IntervalArray,y=a.RangeArray,S=a.mapKey,F=a.modelLogger,x=o.ScalarSet,D=i.CellValueCache,N=e.TableColumnModel=b.extend(function(e,t,n){b.call(this,e.docModel,n,{families:"filter sort",autoClear:!0}),this.clone=function(e,t){return new N(e,t,this.getExplicitAttributeSet(!0))},this.isButtonVisible=function(){return!this.getMergedAttributeSet(!0).filter.hideButton},this.isFiltered=function(){return"none"!==this.getMergedAttributeSet(!0).filter.type},this.isSorted=function(){return"none"!==this.getMergedAttributeSet(!0).sort.type},this.isDescending=function(){return this.getMergedAttributeSet(!0).sort.descending},this.isRefreshable=function(){return this.isFiltered()||this.isSorted()}}),I=e.TableModel=b.extend(function(l,u,c,e){b.call(this,l.docModel,e,{styleFamily:"table",autoClear:!0});var d=this,a=l.docModel,g=(this.sheetModel=l).cellCollection,s=new A,t=this.member(new N(l,this)),r=this.member(new D(l,c)),i=[];function o(e,r){var a={tableCol:e,columnModel:r},o=r.uid;s.insert(e,a),d.listenTo(r,"change:attributes",function(e,t,n){d.trigger("change:column",a.tableCol,t,n),r.isSorted()&&i.push(o),r.hasExplicitAttributes()||(r.destroy(),s.remove(a.tableCol),i=_.without(i,o))})}function h(e){e=s.get(e);return e?e.columnModel:null}function f(r,a){s.forEach(function(e){var t,n;!e.columnModel.isSorted()||a&&0<=a.indexOf(e.tableCol)||(t={sort:{type:"none",descending:!1}},n=e.columnModel.getUndoAttributeSet(t),r.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,{col:e.tableCol,attrs:n},{undo:!0}),r.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,{col:e.tableCol,attrs:t}))})}this.clone=function(e,t){return new I(e,t,c,this.getExplicitAttributeSet(!0),s)},this.applyChangeOperation=function(e){var t=e.getInt("col");e.ensure(0<=t&&t<c.cols(),"invalid table column");var n=e.getDict("attrs");(t=h(e=t))||o(e,t=new N(l,d)),t.setAttributes(n)},this.getName=function(){return u},this.getKey=function(){return S(u)},this.isAutoFilter=function(){return 0===u.length},this.getRange=function(){return c.clone()},this.containsCell=function(e){return c.containsAddress(e)},this.overlapsRange=function(e){return c.overlaps(e)},this.hasHeaderRow=function(){return this.getMergedAttributeSet(!0).table.headerRow},this.hasFooterRow=function(){return this.getMergedAttributeSet(!0).table.footerRow},this.getStyleId=function(){return this.getMergedAttributeSet(!0).styleId||null},this.getStyleFlags=function(){var e=this.getMergedAttributeSet(!0).table;return{firstRow:e.headerRow,lastRow:e.footerRow,firstCol:e.firstCol,lastCol:e.lastCol,bandsHor:e.bandsHor,bandsVert:e.bandsVert}},this.areButtonsVisible=function(){var e=this.getMergedAttributeSet(!0).table;return e.headerRow&&!e.hideButtons},this.isFiltered=function(){return s.some(function(e){return e.columnModel.isFiltered()})},this.isSorted=function(){return s.some(function(e){return e.columnModel.isSorted()})},this.getSortRules=function(){var r=c.start[0],e=s.reduce([],function(e,t){var n=t.columnModel;return n.isSorted()&&e.push({order:i.indexOf(n.uid),index:r+t.tableCol,descending:n.isDescending()}),e});return _.sortBy(e,"order")},this.getHeaderRange=function(){return this.hasHeaderRow()?c.headerRow():null},this.getFooterRange=function(){return this.hasFooterRow()?c.footerRow():null},this.getDataRange=function(){var e,t=this.hasHeaderRow(),n=this.hasFooterRow(),r=c.clone();return!n&&this.isAutoFilter()&&(r=g.findContentRange(r,{directions:"down"}),c.end[1]<r.end[1]&&(e=T.create(c.start[0],c.end[1]+1,c.end[0],a.getMaxRow()),l.tableCollection.createModelIterator({overlapRange:e}).forEach(function(e){r.end[1]=Math.min(r.end[1],e.getRange().start[1]-1)}))),t&&(r.start[1]+=1),n&&--r.end[1],r.start[1]<=r.end[1]?r:null},this.getVisibleDataRows=function(){var e=this.getDataRange();return e?l.rowCollection.getVisibleIntervals(e.rowInterval()).move(-e.start[1]):new w},this.canRestoreDeletedRanges=function(e){return this.isAutoFilter()||e.every(function(e){return!e.contains(c)})},this.setName=function(e){u=e},this.setRange=function(e){if(c.equals(e))return this;c=e.clone(),r.setRanges(this.getHeaderRange());var n=c.cols();s.forEach(function(e,t){e.tableCol>=n&&(e.columnModel.destroy(),s.remove(t))})},this.transformRange=function(n){if(!n.bandContainsRange(c))return!0;if(!n.insert&&!n.columns){var e=this.getHeaderRange();if(e&&n.transformRanges(e).empty())return!1}var r,a=c.start[0],o=n.transformRanges(c).first();o?c.equals(o)||n.columns&&(r=new A,s.forEach(function(e){var t=new O(a+e.tableCol,c.start[1]);(t=n.transformAddress(t))?(e.tableCol=t[0]-o.start[0],r.insert(e.tableCol,e)):e.columnModel.destroy()}),s=r):F.error("$badge{TableModel} transformRange: unexpected deleted table, range="+c)},this.getColumnKeys=function(){return r.getCustom("colKeys",function(e){return e.map(function(e){return C(e.value)?S(e.value):""})})},this.getColumnModel=function(e){return h(e)||t},this.getColumnDataRange=function(e){var t=this.getDataRange(),e=c.start[0]+e;return t&&c.containsCol(e)?t.setBoth(e,!0):null},this.getColumnContents=function(e,t){var n=this.getColumnDataRange(e);if(!n)return[];e=n.rowInterval();if((t=t?t.deepClone().move(e.first).intersect(e):new w(e)).empty())return[];n=y.createFromRowIntervals(t,n.start[0]);return g.getRangeContents(n,{blanks:!0,display:!0,compressed:!0})},this.isRefreshable=function(){return s.some(function(e){return e.columnModel.isRefreshable()})},this.createFilterMatcher=function(e){e=this.getColumnModel(e).getMergedAttributeSet(!0).filter;return"discrete"===e.type?function(e){if(0===e.length)return _.constant(!1);var n=x.from(e);return a.getApp().isODF()?function(e){return n.has(e)}:function(e,t){return n.has(t.replace(/^ +| +$/g,""))}}(e.entries):null},this.queryFilterResult=function(e){var t=this.getDataRange();if(!t)return this.createResolvedPromise([]);var n=[],r=v(e&&e.skipColumns||[],!0),t=t.rowInterval(),d=new w(new E(0,t.size()-1));return s.forEach(function(e){!e.columnModel.isFiltered()||e.tableCol in r||n.push(e.tableCol)}),this.iterateArraySliced(n,function(e){if(d.empty())return p.BREAK;var s,l,u,c=this.createFilterMatcher(e);c&&(e=this.getColumnContents(e,d),s=new w,u=l=0,e.forEach(function(e){for(var t,n,r,a,o=e.count,i=c(e.value,e.display);0<o;)t=d[u],l=Math.max(l,t.first),n=Math.min(o,t.last-l+1),i&&(a=void 0,a=l+(r=n)-1,(r=s.last())&&r.last+1===l?r.last=a:s.push(new E(l,a))),o-=n,l+=n,t.last<l&&(u+=1)}),d=s)},"TableModel.queryFilterResult").then(function(){return d})},this.generateRefreshOperations=function(e,t){var n=this.getDataRange();if(!n)return this.createResolvedPromise();var r=c.boundary(n),a=this.createResolvedPromise();c.differs(r)&&(e.generateTableRangeOperation(m.CHANGE_TABLE,u,c,null,{undo:!0}),e.generateTableRangeOperation(m.CHANGE_TABLE,u,r),this.isAutoFilter()&&(a=a.then(function(){return l.nameCollection.generateFilterDatabaseOperations(e,r)})));var o,i=l.createOperationGenerator({applyImmediately:!0}),s=l.createOperationGenerator({applyImmediately:!0});return t&&t.updateFilter&&(a=a.then(function(){return d.queryFilterResult(t).then(function(e){var t=n.rowInterval(),e=e.deepClone().move(t.first);p.addProperty(e,"fillData",{attrs:{visible:!0,filtered:!1}});t=new w(t).difference(e);p.addProperty(t,"fillData",{attrs:{visible:!1,filtered:!0}});t=e.concat(t);return l.rowCollection.generateIntervalOperations(i,t)})})),t&&t.updateSort&&(0<(o=this.getSortRules()).length&&(a=a.then(function(){return g.generateSortOperations(s,n,M.VERTICAL,o)}))),a.done(function(){e.appendOperations(i),e.appendOperations(s),e.appendOperations(s,{undo:!0}),e.appendOperations(i,{undo:!0})})},this.generateChangeOperations=function(e,t){return e.generateTableOperation(m.CHANGE_TABLE,u,{attrs:this.getUndoAttributeSet(t)},{undo:!0}),e.generateTableOperation(m.CHANGE_TABLE,u,{attrs:t}),this.generateRefreshOperations(e)},this.generateChangeColumnOperations=function(e,t,n,r){r&&r.resetSort&&f(e,[t]);r=this.getColumnModel(t).getUndoAttributeSet(n);return e.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,{col:t,sort:"sort"in r,attrs:r},{undo:!0}),e.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,{col:t,sort:"sort"in n,attrs:n}),this.generateRefreshOperations(e,{updateFilter:"filter"in n,updateSort:"sort"in n})},this.generateDeleteOperations=function(t,e){t.rowCache.changeIntervals(c.rowInterval(),{attrs:{row:{visible:!0,filtered:!1}}});var n={attrs:d.getExplicitAttributeSet(!0)};t.generateTableRangeOperation(m.INSERT_TABLE,u,c,n,{undo:!0}),s.forEach(function(e){e={col:e.tableCol,attrs:e.columnModel.getExplicitAttributeSet(!0)};t.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,e,{undo:!0})}),t.generateTableOperation(m.DELETE_TABLE,u,void 0,e)},this.generateUpdateTaskOperations=function(n,e){var r=e.transformer,t=!r.insert&&!r.columns&&this.hasHeaderRow()&&r.deleteIntervals.containsIndex(c.start[1])?null:r.transformRanges(c).first();if(!t)return this.generateDeleteOperations(n,{prepend:!0}),R();if(c.equals(t))return R();n.assertCause(function(t){if(!(n=c.intersect(t.dirtyRange)))return!0;var e=c.interval(!t.columns),n=n.interval(!t.columns);return!e.differs(n)&&(!!(t.insert||t.columns||d.isAutoFilter())||(n=function(e){return!e||!t.transformRanges(e).empty()})(d.getHeaderRange())&&n(d.getFooterRange())&&n(d.getDataRange()))}(r),"table:move");e={range:t.toOpStr()},t={range:c.toOpStr()};!r.insert&&!r.columns&&this.hasFooterRow()&&r.deleteIntervals.containsIndex(c.end[1])&&(e.attrs={table:{footerRow:!1}},t.attrs={table:{footerRow:!0}}),n.generateTableOperation(m.CHANGE_TABLE,u,e),n.generateTableOperation(m.CHANGE_TABLE,u,t,{undo:!0});var a,o,i,t=R();return r.columns&&!s.empty()&&(a=c.start[0],o=c.start[1],i=[],s.forEach(function(e){var t=new O(a+e.tableCol,o);r.transformAddress(t)||(t={col:e.tableCol,attrs:e.columnModel.getExplicitAttributeSet(!0)},n.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,t,{undo:!0}),i.push(e.tableCol))}),t=this.generateRefreshOperations(n,{skipColumns:i})),t},this.generateSortOperations=function(r,e){var a=c.start[0],t=e.map(function(e){return e.index-a});return f(r,t),e.forEach(function(e){var t=e.index-a,n={sort:{type:"value",descending:!!e.descending}},e=d.getColumnModel(t).getUndoAttributeSet(n);r.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,{sort:!0,col:t,attrs:e},{undo:!0}),r.generateTableOperation(m.CHANGE_TABLE_COLUMN,u,{sort:!0,col:t,attrs:n})}),this.generateRefreshOperations(r,{updateSort:!0})},c=c.clone(),this.on("change:attributes",function(e,t,n){t.table.headerRow!==n.table.headerRow&&r.setRanges(d.getHeaderRange())}),arguments[I.length]instanceof A&&arguments[I.length].forEach(function(e){o(e.tableCol,e.columnModel.clone(l,this))},this),this.registerDestructor(function(){s.forEach(function(e){e.columnModel.destroy()}).clear()})}),g=l.extend(function(){l.call(this,function(e){return e.getKey()})});e.TableCollection=s.extend(function(l){s.call(this,l.docModel);var r=this,u=l.docModel,o=this.member(new g);function a(e,t){var n=e.optStr("table",!0),r=0===n.length,a=o.get(S(n),null);return t&&t.insert?e.ensure(!a&&(r||!u.hasTable(n)),"table exists"):e.ensure(a,"missing table"),{name:n,model:a}}function i(t){o.insert(t),r.trigger("insert:table",t),r.forwardEvents(t,{transformFn:function(e){return["change:table",t,e].concat(_.rest(arguments,2))}})}function t(e){var t=e.transformer;o.forEach(function(e){e.transformRange(t)})}this._getCloneData=function(){return{tableModelSet:o}},this.applyCopySheetOperation=function(r,e){var a=r.optDict("tableNames");e._getCloneData().tableModelSet.forEach(function(e){var t=e.getName(),n=t;e.isAutoFilter()||(n=c(a,t),r.ensure(n,'missing replacement name for table "%s"',t)),i(e.clone(l,n))})},this.applyInsertOperation=function(e){var t=a(e,{insert:!0}),n=e.getRange("range");t.model=new I(l,t.name,n,e.optDict("attrs")),i(t.model)},this.applyDeleteOperation=function(e){e=a(e);e=e.model,r.trigger("delete:table",e),o.remove(e),e.destroy()},this.applyChangeOperation=function(e){var t=a(e).model,n=t.getRange(),r=e.optRange("range");r&&r.differs(n)&&(this.trigger("change:table:before",t,"change:range",r.clone()),t.setRange(r),this.trigger("change:table",t,"change:range",n));r=t.getName(),n=e.optStr("newName");n&&n!==r&&(e.ensure(!t.isAutoFilter(),"auto-filter cannot be renamed"),e.ensure(!u.hasTable(n),"table name already used"),this.trigger("change:table:before",t,"change:name",n),o.remove(t),t.setName(n),o.insert(t),this.trigger("change:table",t,"change:name",r)),e.has("attrs")&&t.setAttributes(e.getDict("attrs"))},this.applyChangeColumnOperation=function(e){a(e).model.applyChangeOperation(e)},this.hasTable=function(e){return o.hasKey(S(e))},this.hasAutoFilter=function(){return o.hasKey("")},this.getTableModel=function(e){return o.get(S(e))},this.getAutoFilterModel=function(){return o.get("")},this.getTableModelAt=function(t){return o.find(function(e){return e.containsCell(t)})||null},this.createModelIterator=function(e){var t=o.valueIterator();e&&e.autoFilter||(t=t.filterIterator(function(e){return!e.isAutoFilter()}));var n=e&&e.overlapRange;return n&&(t=t.filterIterator(function(e){return e.overlapsRange(n)})),t},this.hasFilteredTables=function(){return o.some(function(e){return e.isFiltered()})},this.canRestoreDeletedRanges=function(t){return o.every(function(e){return e.canRestoreDeletedRanges(t)})},this.generateInsertTableOperations=function(o,i,s,t){var e=0===i.length,n=e?this.hasAutoFilter():u.hasTable(i);o.assertCause(!n,"table:duplicate");n=this.createModelIterator({overlapRange:s,autoFilter:!0});o.assertCause(n.next().done,"table:overlap");n=(n=e?R():l.mergeCollection.generateMergeCellsOperations(o,s,d.UNMERGE)).then(function(){var e={range:s.toOpStr()};t&&(e.attrs=t),o.generateTableOperation(m.DELETE_TABLE,i,null,{undo:!0}),o.generateTableOperation(m.INSERT_TABLE,i,e)});return e&&(n=(n=n.then(function(){var e=l.mergeCollection.getMergedRanges(s.headerRow());return r.asyncForEach(e,function(e){for(var t=Math.max(e.start[0],s.start[0]),n=Math.min(e.end[0],s.end[0]),r={filter:{hideButton:!0}},a=t;a<n;a+=1)o.generateTableOperation(m.CHANGE_TABLE_COLUMN,i,{col:a-s.start[0],attrs:r})})})).then(function(){return l.nameCollection.generateFilterDatabaseOperations(o,s)})),n},this.generateUpdateTaskOperations=function(t,n){return l.isOwnMoveTask(n)?this.asyncForEach(o,function(e){return e.generateUpdateTaskOperations(t,n)}):R()},this.waitForImportSuccess(function(e){this.listenTo(l.cellCollection.moveHook,t),!e&&l.isActive()&&o.forEach(function(e){l.refreshRanges(e.getRange())})},this)})});