define("io.ox/office/spreadsheet/view/view",["exports","io.ox/office/tk/types","io.ox/office/tk/algorithms","io.ox/office/tk/containers","io.ox/office/tk/utils","io.ox/office/tk/dom","io.ox/office/tk/utils/logger","io.ox/office/tk/locale/locale","io.ox/office/baseframework/view/popup/contextmenu","io.ox/office/editframework/view/commentspane","io.ox/office/drawinglayer/view/popup/chartlabelsmenu","io.ox/office/textframework/view/view","io.ox/office/spreadsheet/utils/config","io.ox/office/spreadsheet/utils/sheetutils","io.ox/office/spreadsheet/utils/paneutils","io.ox/office/spreadsheet/model/formula/parser/updatetask","io.ox/office/spreadsheet/model/model","io.ox/office/spreadsheet/view/viewpropset","io.ox/office/spreadsheet/view/statuspane","io.ox/office/spreadsheet/view/formulapane","io.ox/office/spreadsheet/view/cornerpane","io.ox/office/spreadsheet/view/headerpane","io.ox/office/spreadsheet/view/gridpane","io.ox/office/spreadsheet/view/labels","io.ox/office/spreadsheet/view/controls","io.ox/office/spreadsheet/view/toolbars","io.ox/office/spreadsheet/view/popup/namesmenu","io.ox/office/spreadsheet/view/mixin/selectionmixin","io.ox/office/spreadsheet/view/mixin/viewfuncmixin","io.ox/office/spreadsheet/view/render/renderutils","io.ox/office/spreadsheet/view/render/rendercache","io.ox/office/spreadsheet/view/edit/rangehighlighter","io.ox/office/spreadsheet/view/edit/texteditorbase","io.ox/office/spreadsheet/view/edit/celltexteditor","io.ox/office/spreadsheet/view/edit/drawingtexteditor","gettext!io.ox/office/spreadsheet/main","less!io.ox/office/spreadsheet/view/style"],function(e,t,i,o,V,r,n,a,U,W,X,Y,Z,s,l,d,c,u,h,g,f,p,w,j,q,J,Q,ee,te,m,ie,b,T,oe,re,ne){"use strict";var ae=t.isNumber,se=t.isString,le=t.getString,de=t.getArray,ce=t.newFulfilled,ue=t.newRejected,he=i.clamp,ge=i.roundp,fe=i.hasProperty,pe=o.KeySet,we=o.TMap,me=o.DMap,be=o.DSet,Te=r.COMPACT_DEVICE,ve=r.deviceResolutionHook,Se=r.addDeviceMarkers,Ee=r.hasModifierKeys,Pe=r.matchKeyCode,Be=r.enableTracking,ye=n.globalLogger,xe=a.LOCALE_DATA,Ce=q.Button,_e=q.CheckBox,Ae=q.CompoundButton,Oe=s.Address,Le=s.Interval,Me=s.IntervalArray,Ne=s.RangeArray,Re=l.ALL_PANE_SIDES,ke=l.ALL_PANE_POSITIONS,He=l.MIN_PANE_SIZE,Ge=l.PaneSide,Ie=l.PanePos,De=l.isColumnSide,Fe=l.getColPaneSide,ze=l.getRowPaneSide,Ke=l.getNextColPanePos,Ve=l.getNextRowPanePos,Ue=l.getPanePos,We=d.DeleteSheetUpdateTask,$e=d.RenameSheetUpdateTask,Xe=d.RelabelNameUpdateTask,Ye=d.RenameTableUpdateTask,Ze=d.MoveCellsUpdateTask,je=c.SHEET_TO_DOCUMENT_INJECT_EVENTS,qe=c.SHEET_TO_DOCUMENT_INSERT_EVENTS,Je=u.ViewPropertySet,Qe=h.StatusPane,et=g.FormulaPane,tt=f.CornerPane,v=p.HeaderPane,it=w.GridPane,ot=m.renderLogger,rt=b.RangeHighlighter,nt=T.editLogger;function at(e,t){this.headerPane=new v(e,t),this.paneSide=t,this.offset=0,this.size=1,this.frozen=!1,this.showOppositeScroll=!1,this.hiddenSize=0}at.prototype.destroy=function(){this.headerPane.destroy()},e.SpreadsheetView=Y.extend(function(o,n){Y.call(this,o,n,{initHandler:function(){var t=n.dependencyManager,i=new we;p.insertContentNode(w),p.insertHiddenNodes(a),w.append(c),g.forEach(function(e){w.append(e.getNode())}),m.forEach(function(e){w.append(e.headerPane.getNode())}),w.append(p.cornerPane.getNode()),w.append(b,T,v,S,E),(_.browser.iOS||_.browser.Android)&&(o.registerGlobalEventHandler(document,"touchstart",function(e){h=e.originalEvent.changedTouches[0]}),o.registerGlobalEventHandler(document,"touchend",function(){p.setTimeout(function(){h=null},100)}));p.one("change:activesheet",function(){p.grabFocus()}),p.listenTo(o,"docs:editmode",function(e){w.toggleClass("edit-mode",e)}),p.listenTo(o,"docs:users:selection",function(e){e=e.filter(function(e){return e.remote&&_.isObject(e.userData)&&ae(e.userData.sheet)&&se(e.userData.ranges)});this.propSet.set("remoteClients",e)}),p.listenTo(t,"recalc:start",function(){o.setUserState("recalc")}),p.listenTo(t,"recalc:end recalc:cancel",function(){o.setUserState(null)}),p.registerStatusCaption("recalc",j.CALCULATING_LABEL,{busy:!0,delay:1e3}),p.listenTo(n,"change:cells",function(e,t){t.external||i.getOrConstruct(t.sheetModel.uid,pe).merge(t.formulaCells)}),p.listenTo(t,"recalc:end",function(e,t){t=t.some(function(e){return e.some(function(e){var t=i.get(e.sheetUid,null);return t&&t.has(e)})});i.clear(),t&&p.yell({headline:ne("Circular Reference"),message:ne("A reference in the formula is dependent on the result of the formula cell."),skipPlugged:!0})}),p.listenTo(t,"recalc:overflow",function(){p.yell({type:"error",message:ne("This document exceeds the spreadsheet size and complexity limits. Calculation has been stopped. Formula results are not updated anymore."),skipPlugged:!0})},{once:!0}),p.listenTo(t,"recalc:end",function(){var e=n.formulaGrammarUI,e=t.getMissingFunctionKeys().map(e.getFunctionName,e).filter(_.identity).sort();0<e.length&&(e=e.map(function(e){return"\n • "+e}).join(),p.yell({type:"warning",message:_.noI18n(ne("This spreadsheet contains formulas with unsupported functions:")+e),duration:3e4,skipPlugged:!0}))},{once:!0}),p.listenTo(n.propSet,function(e){"activeSheet"in e&&function(e){0<=B&&(p.cancelTextEditMode(),L(null,null,{hide:!0}),p.trigger("before:activesheet",B));0<=e&&(B=e,y=n.getSheetModel(B),x=y.colCollection,C=y.rowCollection,A=y.drawingCollection,p.trigger("change:activesheet",B,y),N(y.propSet.all()),M())}(e.activeSheet)}),je.forEach(function(e){p.forwardEvent(n,e,{filterFn:function(e){return e.sheet===B}})}),qe.forEach(function(e){"change:sheetprops"===e?p.listenTo(n,e,function(e,t,i){t===B&&N(i)}):p.forwardEvent(n,e,{filterFn:function(e){return e===B},transformFn:function(){return _.rest(arguments)}})}),p.listenTo(n,"rename:sheet:before",function(e,t,i){p.trigger("update:formulas",new $e(t,i))}),p.listenTo(n,"delete:sheet:before",function(e,t){p.trigger("update:formulas",new We(t))}),p.listenTo(n,"change:name:before",function(e,t,i,o,r){o.label&&p.trigger("update:formulas",new Xe(t,i.getLabel(),r))}),p.listenTo(n,"change:table:before",function(e,t,i,o,r){"change:name"===o&&p.trigger("update:formulas",new Ye(i.getName(),r))}),p.listenTo(n,"move:cells",function(e,t){p.trigger("update:formulas",new Ze(t.sheet,t.transformer))}),p.waitForImportSuccess(function(){var e=o.isViewerMode()?o.getRootNode():document;o.registerGlobalEventHandler(e,"contextmenu",z),Be(P),P.on("tracking:start tracking:move tracking:end tracking:cancel",I),w.on({keydown:D,keypress:F});var i,e=o.getLaunchOption("comment_id");se(e)&&e&&(i=parseInt(e,10),n.createSheetIterator().some(function(e){var t=_.find(e.commentCollection.getCommentModels(),function(e){return new Date(e.getDate()).getTime()===i});if(t)return n.setActiveSheet(e.getIndex()),p.commentsPane.selectThread(t),!0}))}),p.waitForImportFailure(function(){w.hide(),p.statusPane.hide(),p.commentsPane.hide()}),p.addPane(p.formulaPane=new et(p)),p.addPane(p.statusPane=new Qe(p)),p.addPane(p.commentsPane=new W(p,ne("There are no comments on this sheet."))),p.on("refresh:layout",function(){var e={width:w[0].clientWidth,height:w[0].clientHeight};r.width===e.width&&r.height===e.height||(r=e,M())}),p.on("change:activesheet change:sheetattrs",function(){w.toggleClass("sheet-locked",y.isLocked()),w.toggleClass("cell-sheet",y.isCellType())}),p.on("move:columns change:columns move:rows change:rows",G),p.on("change:sheetprops",function(e,t){"zoom"in t?M({full:!0}):fe(t,/^split/)?M({force:!0}):fe(t,/^anchor/)&&L(null,null)}),this.listenTo(n,"change:locale",function(){M({full:!0})}),p.listenTo(ve,function(){M({full:!0})}),p.on("change:selection",function(e,t){w.toggleClass("drawing-selection",0<t.drawings.length)}),p.on("change:activesheet",function(){p.commentsPane.repaintAllComments()}),p.on("textedit:enter",function(e,t){w.attr("data-text-edit",t)}),p.on("textedit:leave",function(){w.removeAttr("data-text-edit")}),p.on("textedit:leave:drawing",function(){p.insertHiddenNodes(a)}),m.forEach(function(i){var o=i.headerPane,r=De(i.paneSide),n=r?"left":"top",a=r?"width":"height",s=null;function l(e,t){e=i.offset+e-o.getVisiblePosition().offset;c.toggleClass("collapsed",0===t),c.find(">.leading").css(a,Math.max(0,e)+10+"px"),c.find(">.trailing").css(n,e+t+"px")}p.listenTo(o,"resize:start",function(e,t,i){t=t,i=i,c.attr("data-orientation",r?"columns":"rows"),l(t,i),s=p.setTimeout(function(){w.addClass("tracking-active")},200)}),p.listenTo(o,"resize:move",function(e,t,i){l(t,i)}),p.listenTo(o,"resize:end",function(){s&&(s.abort(),s=null),w.removeClass("tracking-active"),c.find(">.leading").css(a,""),c.find(">.trailing").css(n,"")}),p.forwardEvent(o,"change:scrollpos",{transform:function(e){return[i.paneSide,e]}})})},initGuiHandler:function(e){function t(){return new J.FontStyleToolBar(p,{hideTextPosition:!0})}switch(e){case"toolbartabs":Z.COMBINED_TOOL_PANES?(p.createToolBarTab("font",{label:j.FONT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1}),p.createToolBarTab("alignment",{label:j.ALIGNMENT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1}),p.createToolBarTab("cell",{label:j.CELL_HEADER_LABEL,visibleKey:"document/editable/cell",priority:1}),p.createToolBarTab("numberformat",{label:j.NUMBERFORMAT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1})):p.createToolBarTab("format",{label:j.FORMAT_HEADER_LABEL,visibleKey:"view/toolbartab/format/visible",priority:1}),p.createToolBarTab("data",{label:j.DATA_HEADER_LABEL,visibleKey:"view/toolbartab/data/visible",priority:1}),Z.COMBINED_TOOL_PANES||p.createToolBarTab("insert",{label:j.INSERT_HEADER_LABEL,visibleKey:"view/toolbartab/insert/visible",priority:1}),p.createToolBarTab("colrow",{label:j.COL_ROW_HEADER_LABEL,visibleKey:"view/toolbartab/colrow/visible",priority:1}),Z.COMBINED_TOOL_PANES||p.createToolBarTab("table",{label:j.TABLE_HEADER_LABEL,visibleKey:"view/toolbartab/table/visible"}),p.createToolBarTab("drawing",{labelKey:"drawing/type/label",visibleKey:"view/toolbartab/drawing/visible"}),p.createToolBarTab("comments",{label:j.REVIEW_HEADER_LABEL,visibleKey:"view/toolbartab/comments/visible",priority:1});break;case"viewmenu":var i=p.topPane.viewButton;i.addSection("zoom",j.ZOOM_LABEL),i.addGroup("view/zoom/dec",new Ce(p,j.ZOOMOUT_BUTTON_OPTIONS),{inline:!0,sticky:!0}),i.addGroup("view/zoom/inc",new Ce(p,j.ZOOMIN_BUTTON_OPTIONS),{inline:!0,sticky:!0}),i.addGroup("view/zoom",new q.PercentageLabel(p),{inline:!0}),i.addSection("split",ne.pgettext("sheet-split","Split and freeze")),i.addGroup("view/split/dynamic",new q.DynamicSplitCheckBox(p)),i.addGroup("view/split/frozen",new q.FrozenSplitCheckBox(p)),i.addSection("options",j.OPTIONS_LABEL),i.addGroup("view/toolbars/show",new _e(p,j.SHOW_TOOLBARS_CHECKBOX_OPTIONS)),i.addGroup("view/commentspane/show",new _e(p,j.SHOW_COMMENTSPANE_CHECKBOX_OPTIONS),{visibleKey:"document/ooxml"}),i.addGroup("document/users",new _e(p,j.SHOW_COLLABORATORS_CHECKBOX_OPTIONS)),i.addGroup("view/formulapane/show",new _e(p,{label:ne("Show formula bar"),tooltip:ne("Show or hide the formula bar")})),i.addGroup("view/grid/show",new _e(p,{label:ne("Show grid lines"),tooltip:ne("Show or hide the cell grid lines in the current sheet")})),i.addGroup("view/statuspane/show",new _e(p,{label:ne("Show sheet tabs"),tooltip:ne("Show or hide the sheet tabs below the sheet area")}));break;case"format":Z.COMBINED_TOOL_PANES||(p.addToolBar("format",new J.FontFamilyToolBar(p),{priority:1}),p.addToolBar("format",t(),{priority:2}),p.addToolBar("format",new J.FormatPainterToolBar(p),{priority:3}),p.addToolBar("format",new J.CellColorToolBar(p),{priority:4}),p.addToolBar("format",new J.CellAlignmentToolBar(p),{priority:5}),p.addToolBar("format",new J.NumberFormatToolBar(p),{priority:6}),p.addToolBar("format",new J.CellBorderToolBar(p),{priority:7}),p.addToolBar("format",new J.CellStyleToolBar(p),{priority:8}),p.addToolBar("format",new J.BoxAlignmentToolBar(p),{priority:9,visibleKey:"view/selection/drawing"}),p.addToolBar("format",new J.ListStyleToolBar(p),{priority:10,visibleKey:"view/selection/drawing"}));break;case"font":Z.COMBINED_TOOL_PANES&&(p.addToolBar("font",new J.FontFamilyToolBar(p),{priority:1}),p.addToolBar("font",t(),{priority:2}),p.createToolBar("font",{priority:3}).addGroup("character/color",new q.TextColorPicker(p)));break;case"alignment":Z.COMBINED_TOOL_PANES&&p.addToolBar("alignment",new J.CellAlignmentToolBar(p));break;case"cell":Z.COMBINED_TOOL_PANES&&(p.createToolBar("cell").addGroup("cell/fillcolor",new q.CellFillColorPicker(p)),p.addToolBar("cell",new J.CellBorderToolBar(p)));break;case"numberformat":Z.COMBINED_TOOL_PANES&&p.addToolBar("numberformat",new J.NumberFormatToolBar(p));break;case"data":i=p.createToolBar("data");Z.COMBINED_TOOL_PANES&&i.addGroup("cell/autoformula",new q.InsertAutoSumButton(p)).addGroup("function/insert/dialog",new q.InsertFunctionButton(p)).addSeparator(),i.addGroup("table/sort",new q.SortMenuButton(p)).addSeparator().addGroup("table/filter",new q.FilterButton(p)).addGroup("table/refresh",new q.RefreshButton(p)),Z.COMBINED_TOOL_PANES||i.addSeparator().addGroup("view/namesmenu/toggle",new q.NamesMenuButton(p)),i.addSeparator().addGroup("sheet/operation/unlocked/cell",new q.CellProtectionMenuButton(p));break;case"insert":Z.COMBINED_TOOL_PANES||(p.addToolBar("insert",new J.InsertContentToolBar(p)),p.addToolBar("insert",new J.InsertDrawingToolBar(p)),p.addToolBar("insert",new J.InsertCommentToolBar(p)));break;case"colrow":p.addToolBar("colrow",new J.ColRowToolBar(p,!1)),p.addToolBar("colrow",new J.ColRowToolBar(p,!0));break;case"table":Z.COMBINED_TOOL_PANES||p.addToolBar("table",new J.TableToolBar(p));break;case"drawing":p.createToolBar("drawing").addGroup("shape/insert",new q.ShapeTypePicker(p,{label:null}),{visibleKey:"drawing/type/shape"}).addGroup("drawing/delete",new Ce(p,j.DELETE_DRAWING_BUTTON_OPTIONS)),Z.COMBINED_TOOL_PANES||(p.createToolBar("drawing",{visibleKey:"view/toolbar/drawing/connector/visible"}).addGroup("drawing/border/style",new q.BorderPresetStylePicker(p,{label:j.LINE_STYLE_LABEL})).addGroup("drawing/border/color",new q.BorderColorPicker(p,{label:ne("Line color"),smallerVersion:{hideLabel:!0}})).addGroup("drawing/connector/arrows",new q.ArrowPresetStylePicker(p)),p.createToolBar("drawing",{visibleKey:"view/toolbar/drawing/border/visible"}).addGroup("drawing/border/style",new q.BorderPresetStylePicker(p,{label:j.BORDER_STYLE_LABEL})).addGroup("drawing/border/color",new q.BorderColorPicker(p,{label:ne("Border color"),smallerVersion:{hideLabel:!0}})),p.createToolBar("drawing",{visibleKey:"view/toolbar/drawing/fill/visible",hideable:!0}).addGroup("drawing/fill/color",new q.FillColorPicker(p,{label:ne("Background color"),icon:"docs-drawing-fill-color",splitValue:{type:"scheme",value:"accent2"},smallerVersion:{hideLabel:!0}})),p.createToolBar("drawing",{visibleKey:"drawing/chart",priority:1}).addGroup("drawing/charttype",new q.ChartTypePicker(p)).addGap().addGroup("drawing/chartlabels",new Ce(p,_.extend({"aria-owns":p.chartLabelsMenu.uid},j.CHART_LABELS_BUTTON_OPTIONS))).addSeparator().addGroup("drawing/chartcolorset",new q.ChartColorSetPicker(p)).addGroup("drawing/chartstyleset",new q.ChartStyleSetPicker(p)),p.createToolBar("drawing",{visibleKey:"drawing/chart",priority:2,hideable:!0}).addGroup("drawing/chart/valid",new Ae(p,j.CHART_DATA_POINTS_BUTTON_OPTIONS).addGroup("drawing/chartdatalabel",new _e(p,j.CHART_SHOW_POINT_LABELS_BUTTON_OPTIONS)).addGroup("drawing/chartvarycolor",new _e(p,j.CHART_VARY_POINT_COLORS_BUTTON_OPTIONS))),p.createToolBar("drawing",{visibleKey:"drawing/chart",priority:3,hideable:!0}).addGroup("drawing/chartlegend/pos",new q.ChartLegendPicker(p)),p.createToolBar("drawing",{visibleKey:"drawing/chart",priority:4,hideable:!0}).addGroup("drawing/chartdatasource",new Ae(p,{label:ne.pgettext("chart-source","Data source")}).addGroup("drawing/chartsource",new Ce(p,{label:ne.pgettext("chart-source","Edit data references")})).addGroup("drawing/chartexchange",new Ce(p,{label:ne.pgettext("chart-source","Switch rows and columns")})).addGroup("drawing/chartfirstrow",new _e(p,{attributes:{class:"highlight"},label:ne.pgettext("chart-source","First row as label")})).addGroup("drawing/chartfirstcol",new _e(p,{attributes:{class:"highlight"},label:ne.pgettext("chart-source","First column as label")})))),p.createToolBar("drawing").addGroup("drawing/order",new q.DrawingArrangementPicker(p));break;case"comments":o.isOOXML()&&p.addToolBar("comments",new J.CommentsToolBar(p)),p.addToolBar("comments",new J.NotesToolBar(p),{visibleKey:"note/available/any"})}},grabFocusHandler:function(e){if(!y)return;if(d&&d.isActive())return void d.grabFocus();e=e&&e.target;(e instanceof Oe?p.getTargetGridPane(e):p.getActiveGridPane()).grabFocus()}});var p=this;this.propSet=this.member(new Je(this));var t,e,w=$('<div class="abs pane-root">'),r={width:0,height:0},a=n.getNode(),m=new me,g=new me,f=0,i=!1,s=null,l=new be(_.property("editMode")),d=null,b=$('<div class="split-line columns">'),T=$('<div class="split-line rows">'),v=$('<div class="abs split-tracking columns" style="width:4px;padding:0 3px;" tabindex="-1">'),S=$('<div class="abs split-tracking rows" style="height:4px;padding:3px 0;" tabindex="-1">'),E=$('<div class="abs split-tracking columns rows" style="width:4px;height:4px;padding:3px;" tabindex="-1">'),P=v.add(S).add(E),c=$('<div class="abs resize-tracking"><div class="abs leading"></div><div class="abs trailing"></div></div>'),u=null,h=null,B=-1,y=null,x=null,C=null,A=null,O=ot.profileMethod("$badge{SpreadsheetView} updateHeaderAndGridPanes",function(e){var t,i,o,r,n,a,s,l,d,c,u=m.reduce(3,function(e,t){var i=t.headerPane.getRenderInterval();return i&&!De(t.paneSide)&&(e=Math.max(e,String(i.last).length)),e}),h=f!==u;f=u,!h&&e||(i=!(t=y.hasFrozenSplit())&&y.hasSplit(),o=t?1:2,r=y.getSplitWidth(),n=y.getSplitHeight(),i&&(0<r&&(r=Math.max(r,He)),0<n&&(n=Math.max(n,He))),(a={}).left=(i||t)&&0<r,a.top=(i||t)&&0<n,p.cornerPane.initializePaneLayout(f),c=p.cornerPane.getWidth(),s=p.cornerPane.getHeight(),l=m.get(Ge.L),a.left?(l.offset=c,l.size=r,l.hiddenSize=t?x.convertScrollAnchorToPixel(y.propSet.get("anchorLeft")):0):l.offset=l.size=l.hiddenSize=0,d=m.get(Ge.T),a.top?(d.offset=s,d.size=n,d.hiddenSize=t?C.convertScrollAnchorToPixel(y.propSet.get("anchorTop")):0):d.offset=d.size=d.hiddenSize=0,r=l.offset+l.size,n=d.offset+d.size,a.right=!a.left||r+o+He+V.SCROLLBAR_WIDTH<=w.width(),a.bottom=!a.top||n+o+He+V.SCROLLBAR_HEIGHT<=w.height(),u=a.left&&a.right,h=a.top&&a.bottom,e=m.get(Ge.R),a.right?(e.offset=u?r+o:c,e.size=w.width()-e.offset,e.hiddenSize=t?l.hiddenSize+l.size:0):a.left&&(l.size=w.width()-c,e.offset=e.size=e.hiddenSize=0),c=m.get(Ge.B),a.bottom?(c.offset=h?n+o:s,c.size=w.height()-c.offset,c.hiddenSize=t?d.hiddenSize+d.size:0):a.top&&(d.size=w.height()-s,c.offset=c.size=c.hiddenSize=0),l.frozen=d.frozen=t,e.frozen=c.frozen=!1,l.showOppositeScroll=!a.right,d.showOppositeScroll=!a.bottom,e.showOppositeScroll=c.showOppositeScroll=!0,m.forEach(function(e){e.headerPane.initializePaneLayout(e)}),g.forEach(function(e,t){e.initializePaneLayout(m.get(Fe(t)),m.get(ze(t)))}),b.toggle(u).css({left:r,width:o}),T.toggle(h).css({top:n,height:o}),v.toggle(i&&u).css({left:r-4}),S.toggle(i&&h).css({top:n-4}),E.toggle(i&&u&&h).css({left:r-4,top:n-4}))}),L=ot.profileMethod("$badge{SpreadsheetView} updateRenderingLayers",function(e,t,i){O(!(i&&i.initialize));var o=new Ne;i&&i.full?o.push(n.getSheetRange()):(e&&o.append(n.makeColRanges(e)),t&&o.append(n.makeRowRanges(t)),o=o.merge()),o.empty()||(ot.log("dirty ranges: "+o),(i=i||{}).force=!0);var r=new we;m.forEach(function(e){var t=e.headerPane.updateLayerInterval(i);t&&r.insert(e.paneSide,t)}),O(!0),r.empty()||p.renderCache.updateLayerRanges(r,o).forEach(function(e,t){g.get(t).setLayerRange(e,o,i)})}),M=(t={},e=ot.profileMethod("$badge{SpreadsheetView} initializePanes",function(){var e;y&&(e=p.hasAppFocus(),t.initialize=!0,L(null,null,t),t={},i=!0,e&&p.grabFocus())}),o.createDebouncedFor(p,function(e){t.full=t.full||e&&e.full,t.force=t.force||e&&e.force,i=!1},e,{contextMsg:"SpreadsheetView.initializePanes"}));function N(e){var t=e.selection;t&&p.trigger("change:selection:prepare",t),p.trigger("change:sheetprops",e),t&&p.trigger("change:selection",t)}var R,k,H,G=(R=new Me,k=new Me,o.createDebouncedFor(p,function(e,t){switch(e.type){case"move:columns":R.push(new Le(t.intervals.boundary().first,n.getMaxCol()));break;case"change:columns":t.size?(R.push(new Le(0,n.getMaxCol())),y.hasFrozenSplit()&&M()):R.append(t.intervals);break;case"move:rows":k.push(new Le(t.intervals.boundary().first,n.getMaxRow()));break;case"change:rows":t.size?(k.push(new Le(t.intervals.boundary().first,n.getMaxRow())),y.hasFrozenSplit()&&M()):k.append(t.intervals);break;default:ye.error('$badge{SpreadsheetView} colRowHandler: unknown event "'+e.type+'"')}},function(){L(R,k),R.clear(),k.clear()},{contextMsg:"SpreadsheetView.colRowHandler"}));function I(t){var e=$(this),i=e.hasClass("columns"),o=e.hasClass("rows"),r=p.getHeaderWidth(),n=w.width()-V.SCROLLBAR_WIDTH-2,a=p.getHeaderHeight(),s=w.height()-V.SCROLLBAR_HEIGHT-2,l=m.get(Ge.L),d=m.get(Ge.T);function c(){var e=l.offset+l.size+(i?t.offsetX:0);return e-He<r?r:n<e+He?n:e}function u(){var e=d.offset+d.size+(o?t.offsetY:0);return e-He<a?a:s<e+He?s:e}function h(e,t,i,o,r){e.toggleClass("collapsed",i<=o||r<=i).add(E).css(t,i-4+"px")}function g(){P.removeClass("tracking-active"),p.grabFocus()}switch(t.type){case"tracking:start":v.toggleClass("tracking-active",i),S.toggleClass("tracking-active",o);break;case"tracking:move":i&&h(v,"left",c(),r,n),o&&h(S,"top",u(),a,s);break;case"tracking:end":var f=null,e=null,f=i?(f=c(),r<f&&f<n?y.convertPixelToHmm(f-p.getHeaderWidth()):0):y.getSplitWidthHmm(),e=o?(e=u(),a<e||e<s?y.convertPixelToHmm(e-p.getHeaderHeight()):0):y.getSplitHeightHmm();y.setDynamicSplit(f,e),g();break;case"tracking:cancel":M(),g()}}function D(e){if(!p.isTextEditMode())return p.hasDrawingSelection()?Pe(e,"F2")?(p.enterTextEditMode("drawing"),!1):Pe(e,"DELETE")||Pe(e,"BACKSPACE")?(p.requireEditMode()&&p.executeControllerItem("drawing/delete"),!1):void 0:Pe(e,"F2")?(p.enterTextEditMode("cell"),!1):Pe(e,"F10")?(z(e),!1):!_.browser.MacOS&&Pe(e,"BACKSPACE")?(p.enterTextEditMode("cell",{text:""}),!1):Pe(e,"DELETE")||_.browser.MacOS&&Pe(e,"BACKSPACE")?(p.requireEditMode()&&p.executeControllerItem("cell/clear/values"),!1):void 0}function F(e){var t;if(!p.isTextEditMode()){var i=!!e.ctrlKey,o=!!e.metaKey,r=!!e.altKey;if(32<e.charCode&&(_.browser.MacOS?i==o:(i||o)==r)||32===e.charCode&&!Ee(e)){t=String.fromCharCode(e.charCode);r=p.hasDrawingSelection()?"drawing":"cell",e={text:t};return"cell"==r&&(e.quick=!0,e.autoComplete=!0,"percent"!==p.getNumberFormatCategory()||!/^[-+0-9]$/.test(t)&&t!==xe.dec||(e.text+="%",e.pos=1)),p.enterTextEditMode(r,e),!1}}}function z(e){var t=$(e.target);if(!t.is("input, textarea")){var i=_.browser.IE?t.is(".clipboard"):V.isContextEventTriggeredByKeyboard(e),o=p.getSelectedDrawings(),r=p.getActiveGridPane(),n=r.getLayerRootNode(),a=n.parent(),s=n.offset(),l=n.position(),d=a.scrollLeft(),n=a.scrollTop(),a=null;return t.is(".header-pane .cell")?a=t:t.is(".status-pane .button, .status-pane .button *")||i&&0<$(".status-pane .active-sheet-group.focused .selected").length?i&&0<$(".status-pane .active-sheet-group.focused .selected").length?(a=$(".status-pane .active-sheet-group.focused .button.selected"),e.pageX+=Math.round(a.width()/2),e.pageY+=Math.round(a.height()/2)):(e.pageX||e.pageY||(e.pageX=t.offset().left,e.pageY=t.offset().top),a=t):0<o.length?(a=r.drawingRenderer.getDrawingFrame(o[0]),h?(e.pageX=h.pageX,e.pageY=h.pageY):i&&(o=A.getModel(o[0]).getRectangle(),e.target=a,e.pageX=Math.round(o.centerX())-l.left+s.left-d,e.pageY=Math.round(o.centerY())-l.top+s.top-n)):t.is(".grid-pane *, html")&&(a=r.getNode(),h?(e.pageX=h.pageX,e.pageY=h.pageY):i&&(i=y.getCellRectangle(p.getActiveCell(),{pixel:!0,expandMerged:!0}),e.pageX=Math.round(i.centerX())-l.left+s.left-d,e.pageY=Math.round(i.centerY())-l.top+s.top-n)),a&&U.triggerShowEvent(a,e),!1}}function K(e){l.insert(e),p.forwardEvents(e),p.listenTo(e,"textedit:enter",function(){d=e}),p.listenTo(e,"textedit:leave",function(){d=null})}this.addSheetActionButtons=function(e,t){return t&&t.insertSheet&&(e.addGroup("document/insertsheet",new Ce(this,{label:j.INSERT_SHEET_LABEL})),e.addSeparator()),e.addGroup("sheet/rename/dialog",new Ce(this,{label:j.RENAME_SHEET_LABEL})),e.addGroup("document/copysheet/dialog",new Ce(this,{label:j.COPY_SHEET_LABEL}),{visibleKey:"document/ooxml"}),e.addGroup("document/deletesheet",new Ce(this,{label:j.DELETE_SHEET_LABEL})),e.addGroup("sheet/visible",new q.ShowSheetButton(this)),e.addGroup("sheet/locked",new q.LockSheetButton(this)),e.addSeparator(),e.addGroup("document/movesheets/dialog",new Ce(this,{label:j.REORDER_SHEETS_LABEL})),e.addGroup("document/showsheets/dialog",new Ce(this,{label:j.UNHIDE_SHEETS_LABEL})),this},this.getGridPane=function(e){return g.get(e)},this.getVisibleGridPane=function(e){return 0===m.get(Fe(e)).size&&(e=Ke(e)),0===m.get(ze(e)).size&&(e=Ve(e)),g.get(e)},this.getActiveGridPane=function(){return this.getVisibleGridPane(y.propSet.get("activePane"))},this.getTargetGridPane=function(e){if(!y.hasFrozenSplit())return this.getActiveGridPane();var t=y.getSplitColInterval(),i=y.getSplitRowInterval(),t=t&&e[0]<=t.last?Ge.L:Ge.R,i=i&&e[1]<=i.last?Ge.T:Ge.B;return this.getVisibleGridPane(Ue(t,i))},this.getGridPaneForEvent=function(t){return g.find(function(e){return e.containsEventOffset(t)})||null},this.updateActiveGridPane=function(e){i&&!this.isTextEditMode("cell")&&y.propSet.set("activePane",e)},this.iterateGridPanes=function(e,t){g.forEach(e,t)},this.getHeaderPane=function(e){return m.get(e).headerPane},this.getColHeaderPane=function(e){return this.getHeaderPane(Fe(e))},this.getRowHeaderPane=function(e){return this.getHeaderPane(ze(e))},this.getVisibleHeaderPane=function(e){e=e?0<m.get(Ge.L).size?Ge.L:Ge.R:0<m.get(Ge.T).size?Ge.T:Ge.B;return this.getHeaderPane(e)},this.getActiveHeaderPane=function(e){return this.getActiveGridPane().getHeaderPane(e)},this.iterateHeaderPanes=function(t,i){m.forEach(function(e){t.call(i,e.headerPane,e.paneSide)})},this.getHeaderWidth=function(){return this.cornerPane.getWidth()},this.getHeaderHeight=function(){return this.cornerPane.getHeight()},this.getVisibleIntervals=function(i,o){var r=new Me;return i=Me.cast(i),this.iterateHeaderPanes(function(e,t){De(t)===o&&e.isVisible()&&r.append(i.intersect(e.getRenderInterval()))}),r.merge()},this.yellMessage=function(e,t){if("readonly"===e)return o.rejectEditAttempt();if("image:insert"===e)return o.rejectEditAttempt("image");if(e in j.RESULT_MESSAGES){t=t?"success":"info",e=j.RESULT_MESSAGES[e];if(_.isObject(e)&&(e=e[o.getFileFormat()]),se(e)&&e)return this.yell({type:t,message:e,skipPlugged:!0})}return!1},this.yellOnFailure=function(e){return this.catch(e,function(e){this.yellMessage(V.getStringOption(e,"cause",""))}),e},this.requireEditMode=function(){var e=this.isEditable();return e||this.yellMessage("readonly"),e},this.getStatusLabel=function(){return u},this.setStatusLabel=function(e){u!==e&&(u=e,this.trigger("change:statuslabel",e))},this.getZoomFactor=function(){return y?y.getEffectiveZoom():1},this.getHeaderFontSize=function(){return he(ge(5*this.getZoomFactor()+6,.1),8,Te?12:30)},this.registerCanvasRenderer=function(t){g.forEach(function(e){e.cellRenderer.registerCanvasRenderer(t)})},this.getActiveSheet=function(){return B},this.getSheetModel=function(){return y},this.getCommentCollection=function(){return y?y.commentCollection:null},this.convertPixelToHmm=function(e){return y.convertPixelToHmm(e)},this.convertHmmToPixel=function(e){return y.convertHmmToPixel(e)},this.getSheetRectangle=function(){return y.getSheetRectangle({pixel:!0})},this.getRangeRectangle=function(e){return y.getRangeRectangle(e,{pixel:!0})},this.getCellRectangle=function(e,t){return y.getCellRectangle(e,_.extend({},t,{pixel:!0}))},this.iterateRemoteSelections=function(o,r){return this.propSet.get("remoteClients").forEach(function(e){var t,i;e.userData.sheet===B&&(t=(t=le(e.userData,"ranges"))&&n.addressFactory.parseRangeList(t),(i=de(e.userData,"drawings"))&&0===i.length&&(i=null),(t||i)&&o.call(r,e.userName,e.colorIndex,t,i))}),this},this.scrollToCell=function(e,t){var i=this.getTargetGridPane(e);t&&t.preserveFocus||this.grabFocus({target:e}),i.scrollToCell(e)},this.scrollToDrawingFrame=function(e){(y.hasFrozenSplit()?this.getVisibleGridPane(Ie.BR):this.getActiveGridPane()).scrollToDrawingFrame(e)},this.startProcessingScrollEvents=(H=p.debounce(function(){p.stopProcessingScrollEvents()},{delay:100}),function(e){return(!s||e===s)&&(s=e,H(),!0)}),this.isProcessingScrollEvents=function(e){return e===s},this.stopProcessingScrollEvents=function(){s=null},this.tempShowDrawingFrame=function(t){g.forEach(function(e){e.drawingRenderer.tempShowDrawingFrame(t)})},this.tempHideDrawingFrame=function(t){g.forEach(function(e){e.drawingRenderer.tempHideDrawingFrame(t)})},this.activateUnsavedCommentCollection=function(){var e=n.createSheetIterator({supported:!0,visible:!0}).find(function(e){return e.hasUnsavedComment()});if(e){var t=e.getIndex();if(t!==B)return this.leaveTextEditMode({force:!0}).then(function(){n.setActiveSheet(t)})}},this.isTextEditMode=function(e){return null!==d&&(!e||d.editMode===e)},this.getActiveTextEditor=function(e){return this.isTextEditMode(e)?d:null},this.enterTextEditMode=nt.profileMethod("SpreadsheetView.enterTextEditMode",function(e,t){e=l.get(e);return e?(t&&t.restart&&e===d&&d.cancelEditMode(),((!d||e===d||d.leaveEditMode())&&e.enterEditMode(t)?ce:ue)()):ue()}),this.leaveTextEditMode=nt.profileMethod("SpreadsheetView.leaveTextEditMode",function(e){return!this.isTextEditMode(e&&e.editMode)||d.leaveEditMode(e)?n.waitForActionsProcessed():ue()}),this.cancelTextEditMode=function(e){this.isTextEditMode(e&&e.editMode)&&d.cancelEditMode()},this.getTextEditFocusNode=function(e){return this.isTextEditMode(e&&e.editMode)?d.getFocusNode():void 0},this.getTextAttributeSet=function(){var e=n.getAttributePool(),t={};return e.extendAttributeSet(t,n.getAttributes("paragraph")),e.extendAttributeSet(t,n.getAttributes("character")),t},this.setTextAttributeSet=function(e){var t=(t=this.ensureUnlockedDrawings()).then(function(){return n.setAttributes("character",e)});return this.yellOnFailure(t)},this.recalculateDocumentMargin=_.noop,Se(w),this.namesMenu=new Q(this),this.chartLabelsMenu=new X(this,{anchorBox:function(){return p.getActiveGridPane().getScrollNode()}}),this.renderCache=new ie(this),this.rangeHighlighter=new rt(n),Re.forEach(function(e){m.insert(e,new at(this,e))},this),ke.forEach(function(e){g.insert(e,new it(this,e))},this),this.cornerPane=new tt(this),K(new oe(this)),K(new re(this)),ee.call(this,w),te.call(this),this.registerDestructor(function(){this.renderCache.destroy(),g.destroy(),m.destroy(),this.cornerPane.destroy(),this.namesMenu.destroy(),this.chartLabelsMenu.destroy(),this.rangeHighlighter.destroy(),l.destroy()})})});